drop function agc_i18n_entity_update;
drop trigger TRG_ENT_HIER_HISTORY;
drop trigger TRG_ENTITLEMENT_HISTORY;
drop trigger TRG_ENTITLEMENT_I18N_CREATE;

alter table i18n_entity drop constraint i18n_entity_language_fk;

drop index language_lcode_idx;
drop index language_lname_idx;
alter table language drop primary key;

rename language to agc_language;

ALTER TABLE AGC_LANGUAGE ADD
  CONSTRAINT AGC_LANGUAGE_PK
 PRIMARY KEY (ID);
CALL SYSPROC.ADMIN_CMD ( 'REORG TABLE AGC_LANGUAGE' );

create unique index AGC_LANGUAGE_LCODE_IDX on AGC_LANGUAGE (LOWER(CODE))
;

create unique index AGC_LANGUAGE_LNAME_IDX on AGC_LANGUAGE (LOWER(NAME))
;

CALL SYSPROC.ADMIN_CMD( 'REORG TABLE AGC_LANGUAGE' );

drop sequence language_seq;

CREATE SEQUENCE AGC_LANGUAGE_SEQ
  AS NUMERIC(18)
  START WITH 100
  INCREMENT BY 1
  MINVALUE 100
  MAXVALUE 999999999999999999
  NO CACHE
  NO CYCLE
  NO ORDER;

grant usage on sequence AGC_LANGUAGE_SEQ to &AA_SUPER_ADMIN_USER;
grant usage, alter on sequence AGC_LANGUAGE_SEQ to &IDEAS_SUPER_ADMIN_USER;
grant usage on sequence AGC_LANGUAGE_SEQ to &IDEAS_REPORT_SUPER_ADMIN_USER;
