--RENAME A TABLE
set verify off
set serveroutput on
declare
  curr_user         varchar(30);
  
  tab_name_src      varchar(30) := 'LANGUAGE';
  tab_name_dest     varchar(30) := 'AGC_LANGUAGE';
  dml_def           varchar(4000);
  
  counter           numeric(16);
begin
  select trim ( user ) into curr_user from dual;
  select count(1) into counter from sysibm.tables t where ( t.table_type = 'BASE TABLE' or t.table_type is null ) and lower ( t.table_schema ) = lower ( curr_user ) and t.table_name = tab_name_dest;
  if ( counter = 1 ) then
    return;
  end if;

  dml_def :=
'drop function agc_i18n_entity_update
';

  if ( '&ECHO' = 'ON' ) then
    dbms_output.put_line ( dml_def );
  end if;
  execute immediate ( dml_def );

  dml_def :=
'drop trigger TRG_ENT_HIER_HISTORY
';

  if ( '&ECHO' = 'ON' ) then
    dbms_output.put_line ( dml_def );
  end if;
  execute immediate ( dml_def );

  dml_def :=
'drop trigger TRG_ENTITLEMENT_HISTORY
';

  if ( '&ECHO' = 'ON' ) then
    dbms_output.put_line ( dml_def );
  end if;
  execute immediate ( dml_def );

  dml_def :=
'drop trigger TRG_ENTITLEMENT_I18N_CREATE
';

  if ( '&ECHO' = 'ON' ) then
    dbms_output.put_line ( dml_def );
  end if;
  execute immediate ( dml_def );

  dml_def :=
'alter table i18n_entity drop constraint i18n_entity_language_fk
';

  if ( '&ECHO' = 'ON' ) then
    dbms_output.put_line ( dml_def );
  end if;
  execute immediate ( dml_def );

  dml_def :=
'drop index language_lcode_idx
';

  if ( '&ECHO' = 'ON' ) then
    dbms_output.put_line ( dml_def );
  end if;
  execute immediate ( dml_def );

  dml_def :=
'drop index language_lname_idx
';

  if ( '&ECHO' = 'ON' ) then
    dbms_output.put_line ( dml_def );
  end if;
  execute immediate ( dml_def );

  dml_def :=
'alter table language drop primary key
';

  if ( '&ECHO' = 'ON' ) then
    dbms_output.put_line ( dml_def );
  end if;
  execute immediate ( dml_def );

  dml_def :=
'rename language to agc_language
';

  if ( '&ECHO' = 'ON' ) then
    dbms_output.put_line ( dml_def );
  end if;
  execute immediate ( dml_def );

  dml_def :=
'ALTER TABLE AGC_LANGUAGE ADD
  CONSTRAINT AGC_LANGUAGE_PK
 PRIMARY KEY (ID)
';

  if ( '&ECHO' = 'ON' ) then
    dbms_output.put_line ( dml_def );
  end if;
  execute immediate ( dml_def );

  dml_def :=
'create unique index AGC_LANGUAGE_LCODE_IDX on AGC_LANGUAGE (LOWER(CODE))
';

  if ( '&ECHO' = 'ON' ) then
    dbms_output.put_line ( dml_def );
  end if;
  execute immediate ( dml_def );

  dml_def :=
'create unique index AGC_LANGUAGE_LNAME_IDX on AGC_LANGUAGE (LOWER(NAME))
';

  if ( '&ECHO' = 'ON' ) then
    dbms_output.put_line ( dml_def );
  end if;
  execute immediate ( dml_def );

end;
/
set serveroutput off
set verify on


----DROP A SEQUENCE
set verify off
set serveroutput on
declare
  curr_user         varchar(30);
  
  seq_name          varchar(30) := 'LANGUAGE_SEQ';
  dml_def           varchar(4000);
  
  counter           numeric(16);
begin
  select trim ( user ) into curr_user from dual;
  select count(1) into counter from syscat.sequences t where lower ( t.seqschema ) = lower ( curr_user ) and t.seqtype <> 'I' and lower ( t.seqname ) = lower ( seq_name );
  if ( counter = 0 ) then
    return;
  end if;

  dml_def :=
'drop sequence language_seq
';

  if ( '&ECHO' = 'ON' ) then
    dbms_output.put_line ( dml_def );
  end if;
  execute immediate ( dml_def );

end;
/
set serveroutput off
set verify on


--CREATE A SEQUENCE
set verify off
set serveroutput on
declare
  curr_user         varchar(30);
  
  seq_name          varchar(30) := 'AGC_LANGUAGE_SEQ';
  dml_def           varchar(4000);
  
  counter           numeric(16);
begin
  select trim ( user ) into curr_user from dual;
  select count(1) into counter from syscat.sequences t where lower ( t.seqschema ) = lower ( curr_user ) and t.seqtype <> 'I' and lower ( t.seqname ) = lower ( seq_name );
  if ( counter = 1 ) then
    return;
  end if;

  dml_def :=
'CREATE SEQUENCE AGC_LANGUAGE_SEQ
  AS NUMERIC(18)
  START WITH 100
  INCREMENT BY 1
  MINVALUE 100
  MAXVALUE 999999999999999999
  NO CACHE
  NO CYCLE
  NO ORDER
';

  if ( '&ECHO' = 'ON' ) then
    dbms_output.put_line ( dml_def );
  end if;
  execute immediate ( dml_def );

end;
/
commit;
set serveroutput off
set verify on

--ALIGN A SEQUENCE
declare
  cur_pk       sys_refcursor;
  
  tab_name     varchar(128) := 'AGC_LANGUAGE';
  pk_name      varchar(128) := 'ID';
  seq_name     varchar(128) := 'AGC_LANGUAGE_SEQ';

  max_pk       numeric(16);
  seq_pk       numeric(16);

  counter      numeric(16);

  ddl_query    varchar(256);
begin
  max_pk := null;
  seq_pk := null;
  seq_name := tab_name||'_SEQ';

  ddl_query := 'select max ( ' || pk_name || ' ) from ' || tab_name;
  open cur_pk for ddl_query;
  fetch cur_pk into max_pk;
  close cur_pk;
    
  if( max_pk is null ) then
    max_pk := 1;
  end if;
    
  select count(1) into counter from syscat.sequences t where t.seqschema = current_user and t.seqname = seq_name;
    
  if ( counter = 1 ) then
    ddl_query := 'select nextval for '||seq_name||' from dual';
    open cur_pk for ddl_query;
    fetch cur_pk into seq_pk;
    close cur_pk;
      
    dbms_output.put_line(tab_name|| ' - '||pk_name||': ' || max_pk || ' - SEQ: ' || seq_pk);
      
    --il valore della sequence  minore del massimo della tabella
    if( max_pk > seq_pk  ) then
      loop
        open cur_pk for ddl_query;
        fetch cur_pk into seq_pk;
        close cur_pk;

        exit when seq_pk > max_pk;
      end loop;
    end if;--if(seq_pk < max_pk)
  else
    dbms_output.put_line(tab_name||' - '|| max_pk || ' - not found');
  end if;--if( counter = 1 )
    
end;
/
commit;

grant usage on sequence AGC_LANGUAGE_SEQ to &AA_SUPER_ADMIN_USER;
grant usage, alter on sequence AGC_LANGUAGE_SEQ to &IDEAS_SUPER_ADMIN_USER;
grant usage on sequence AGC_LANGUAGE_SEQ to &IDEAS_REPORT_SUPER_ADMIN_USER;


--REORGANIZE A TABLE
set verify off
set serveroutput on
declare
  curr_user         varchar(30);
  
  tab_name          varchar(30) := 'AGC_LANGUAGE';
  dml_def           varchar(4000);
  
  counter           numeric(16);
begin
  select trim ( user ) into curr_user from dual;
  select count(1) into counter from sysibm.tables t where ( t.table_type = 'BASE TABLE' or t.table_type is null ) and lower ( t.table_schema ) = lower ( curr_user ) and t.table_name = tab_name;
  if ( counter = 0 ) then
    return;
  end if;

  dml_def :=
'CALL SYSPROC.ADMIN_CMD( ''REORG TABLE AGC_LANGUAGE'' )
';

  if ( '&ECHO' = 'ON' ) then
    dbms_output.put_line ( dml_def );
  end if;
  execute immediate ( dml_def );

end;
/
set serveroutput off
set verify on
