create or replace function agc_i18n_entity_update
(
  language_code    in varchar(4000),
  entity_type      in numeric(31),
  env_selected_id  in numeric(31)
)
return numeric(31) is
  counter          numeric(16);

  lan_id           numeric(16);
  lan_status       numeric(16);

  lock_name        varchar(256) := 'I18N_PROCEDURE_UPDATE';
  ENTITLEMENT_TYPE numeric(1) := 1;

  cur_ent          sys_refcursor;
  ent_id           numeric(16);
  ent_i18n_name    varchar(256);
  ent_i18n_desc    varchar(512);
  environment_id   numeric(16);
begin
  select count(1) into counter from agc_language t where t.status > 0;
  if ( counter = 0 ) then
    return -1;
  end if;

  if ( env_selected_id is not null and env_selected_id = 0 ) then
    select t.id into environment_id from environment t where t.working = 1;
  else
    environment_id := env_selected_id;
  end if;

  select count(1) into counter from agc_language t where lower ( t.code ) = lower ( language_code );
  if ( counter = 1 ) then
    select t.id, t.status into lan_id, lan_status from agc_language t where lower ( t.code ) = lower ( language_code );
    if ( lan_status = 0 ) then
      select t.id into lan_id from agc_language t where t.status = 2;
    end if;
  else
    select t.id into lan_id from agc_language t where t.status = 2;
  end if;

  insert into tmp_codoperation ( code ) values ( 'REVERTING' );
  insert into tmp_lock ( name ) values ( lock_name );

  if ( entity_type = ENTITLEMENT_TYPE ) then
    open cur_ent for
      select e.id, t.name, t.description from entitlement e, i18n_entity t
      where e.id = t.entitlement and t.entitlement is not null and t.language = lan_id;
    loop
      fetch cur_ent into ent_id, ent_i18n_name, ent_i18n_desc;
      exit when cur_ent%NOTFOUND;

      update entitlement set name = ent_i18n_name, description = ent_i18n_desc where id = ent_id;
    end loop;
    close cur_ent;
  end if;

  return 0;
end agc_i18n_entity_update;
/
