CREATE OR REPLACE TRIGGER TRG_ENT_HIER_HISTORY
  BEFORE INSERT OR DELETE ON ENTITLEMENT_HIER
  FOR EACH ROW
declare
  counter               number(16);
  code_oper             varchar2(256);
begin
  --HISTORY WITH MULTI LANGUAGE NOT SUPPORTED
  select count(1) into counter from agc_language t where t.status > 0;

  if ( counter > 0 ) then
    return;
  end if;

  select count(1) into counter from tmp_codoperation;

  if ( counter = 0 ) then
    RAISE_APPLICATION_ERROR ( -20200, 'NO OPERATION CODE FOUND IN TMP_CODOPERATION TABLE');
  elsif ( counter = 1 ) then
    select code into code_oper from tmp_codoperation;
  elsif  ( counter > 1 ) then
    RAISE_APPLICATION_ERROR ( -20201, 'TOO MANY OPERATION CODE FOUND IN TMP_CODOPERATION TABLE');
  end if;

  if ( upper ( code_oper ) = 'REVERTING'  ) then
    return;
  end if;

  if ( inserting ) then
    insert into history
     ( id, operation, ent_type, ent_id, ent_name, ent_desc,
       old_val, new_val, field, note )
    values
     ( history_seq.nextval, 1, 1, :new.parent, null, null,
       null, :new.child, 'ADD_ENTITLEMENT', code_oper );
  end if;

  if ( deleting ) then
    insert into history
     ( id, operation, ent_type, ent_id, ent_name, ent_desc,
       old_val, new_val, field, note )
    values
     ( history_seq.nextval, 1, 1, :old.parent, null, null,
       :old.child, null, 'REMOVE_ENTITLEMENT', code_oper );
  end if;

end TRG_ENT_HIER_HISTORY;
/
