CREATE OR REPLACE TRIGGER TRG_ENTITLEMENT_I18N_CREATE
  AFTER INSERT ON ENTITLEMENT
  FOR EACH ROW
declare
  cur_lan               sys_refcursor;
  lan_id                numeric(16);

  counter               numeric(16);
  lock_name             varchar(256);
begin
  if ( inserting ) then
    if ( :new.int_type = 0 ) then
      return;
    end if;
  end if;

  select count(1) into counter from tmp_lock;

  if ( counter = 1 ) then
    select name into lock_name from tmp_lock;
  end if;

  if ( upper ( lock_name ) = 'I18N_PROCEDURE_UPDATE'  ) then
    return;
  end if;

  select count(1) into counter from agc_language t where t.status > 0;

  if ( counter = 0 ) then
    return;
  end if;

  open cur_lan for select t.id from agc_language t where t.status > 0;
  loop
    fetch cur_lan into lan_id;
    exit when cur_lan%NOTFOUND;

    insert into i18n_entity ( id, language, entitlement, name, description )
    values ( i18n_entity_seq.nextval, lan_id, :new.id, :new.name, :new.description );

  end loop;
  close cur_lan;

end TRG_ENTITLEMENT_I18N_CREATE;
/
