--RENAME A TABLE TO A TEMPORARY-NAMED TABLE
set verify off
set serveroutput on
declare
  curr_user         varchar2(30);
  
  tab_name_src      varchar2(30) := 'LOCALIZATION';
  tab_name_dest     varchar2(30) := 'EMS_LOCALIZATION';
  tab_name_dest_tmp varchar2(30) := 'EMS_LOCALIZATION_TMP';
  dml_def           varchar2(4000);
  
  counter           number(16);
begin
  select trim ( user ) into curr_user from dual;
  select count(1) into counter from all_tables t where t.owner = curr_user and t.table_name = tab_name_dest;
  if ( counter = 1 ) then
    return;
  else
    select count(1) into counter from all_tables t where t.owner = curr_user and t.table_name = tab_name_dest_tmp;
    if ( counter = 1 ) then
      return;
    end if;
  end if;

  dml_def :=
'alter table ems_i18n_message drop constraint ems_i18n_localization_fk
';

  if ( '&ECHO' = 'ON' ) then
    dbms_output.put_line ( dml_def );
  end if;
  execute immediate ( dml_def );

  dml_def :=
'alter table ems_template drop constraint ems_template_body_fk
';

  if ( '&ECHO' = 'ON' ) then
    dbms_output.put_line ( dml_def );
  end if;
  execute immediate ( dml_def );

  dml_def :=
'alter table ems_template drop constraint ems_template_subject_fk
';

  if ( '&ECHO' = 'ON' ) then
    dbms_output.put_line ( dml_def );
  end if;
  execute immediate ( dml_def );

  dml_def :=
'drop index localization_lname_idx
';

  if ( '&ECHO' = 'ON' ) then
    dbms_output.put_line ( dml_def );
  end if;
  execute immediate ( dml_def );

  dml_def :=
'alter table localization drop constraint localization_pk cascade drop index
';

  if ( '&ECHO' = 'ON' ) then
    dbms_output.put_line ( dml_def );
  end if;
  execute immediate ( dml_def );

  dml_def :=
'rename localization to ems_localization_tmp
';

  if ( '&ECHO' = 'ON' ) then
    dbms_output.put_line ( dml_def );
  end if;
  execute immediate ( dml_def );

end;
/
set serveroutput off
set verify on

--RENAME A SEQUENCE TO A TEMPORARY-NAMED SEQUENCE
set verify off
set serveroutput on
declare
  curr_user         varchar2(30);
  
  seq_name_src      varchar2(30) := 'LOCALIZATION_SEQ';
  seq_name_dest     varchar2(30) := 'EMS_LOCALIZATION_SEQ';
  seq_name_dest_tmp varchar2(30) := 'EMS_LOCALIZATION_TMP_SEQ';
  dml_def           varchar2(4000);
  
  counter           number(16);
begin
  select trim ( user ) into curr_user from dual;
  select count(1) into counter from all_sequences t where t.sequence_owner = curr_user and t.sequence_name = seq_name_dest;
  if ( counter = 1 ) then
    return;
  else
    select count(1) into counter from all_sequences t where t.sequence_owner = curr_user and t.sequence_name = seq_name_dest_tmp;
    if ( counter = 1 ) then
      return;
    end if;
  end if;

  dml_def :=
'rename localization_seq to ems_localization_tmp_seq
';

  if ( '&ECHO' = 'ON' ) then
    dbms_output.put_line ( dml_def );
  end if;
  execute immediate ( dml_def );

end;
/
set serveroutput off
set verify on

