create table PWDCFG_CHALLENGE
(
  ID            NUMERIC(16) not null,
  PWDCFG        NUMERIC(16) not null,
  LOCALIZATION  NUMERIC(16) not null,
  STATUS        NUMERIC(2),
  ATTR1         VARCHAR(256),
  ATTR2         VARCHAR(256),
  ATTR3         VARCHAR(256),
  ATTR4         VARCHAR(256),
  ATTR5         VARCHAR(256),
  CREATION_USER VARCHAR(128),
  CREATION_DATE DATE default CURRENT_DATE,
  LAST_MOD_USER VARCHAR(128),
  LAST_MOD_TIME DATE default CURRENT_DATE
)
IN &DATA_TABLESPACE
INDEX IN &INDEX_TABLESPACE
LONG IN &LOB_TABLESPACE
;

ALTER TABLE PWDCFG_CHALLENGE ADD
  CONSTRAINT PWDCFG_CHALLENGE_PK 
 PRIMARY KEY (ID);

alter table PWDCFG_CHALLENGE
  add constraint PWD_CHALL_PWDCFG_FK foreign key (PWDCFG)
  references PWDCFG (ID) on delete cascade;
alter table PWDCFG_CHALLENGE
  add constraint PWD_CHALL_LOCALIZATION_FK foreign key (LOCALIZATION)
  references LOCALIZATION (ID) on delete cascade;

create index PWD_CHALL_PWDM_IDX on PWDCFG_CHALLENGE (PWDCFG)
;
create index PWD_CHALL_LOCALIZATION_IDX on PWDCFG_CHALLENGE (LOCALIZATION)
;

create unique index PWD_CHALL_PWDM_IM_IDX on PWDCFG_CHALLENGE (PWDCFG, LOCALIZATION)
;

CALL SYSPROC.ADMIN_CMD ( 'REORG TABLE PWDCFG_CHALLENGE' );

grant select on PWDCFG_CHALLENGE to &AA_SUPER_ADMIN_USER;
grant select, insert, update, delete, references on PWDCFG_CHALLENGE to &IDEAS_SUPER_ADMIN_USER;
grant select, insert, update, delete, references on PWDCFG_CHALLENGE to &IDEAS_CONN_SUPER_ADMIN_USER;
grant select on PWDCFG_CHALLENGE to &IDEAS_REPORT_SUPER_ADMIN_USER;


create sequence PWDCFG_CHALLENGE_SEQ
  AS NUMERIC(18)
  START WITH 100
  INCREMENT BY 1
  MINVALUE 100
  MAXVALUE 999999999999999999
  NO CACHE
  NO CYCLE
  NO ORDER;

grant usage on sequence PWDCFG_CHALLENGE_SEQ to &AA_SUPER_ADMIN_USER;
grant usage, alter on sequence PWDCFG_CHALLENGE_SEQ to &IDEAS_SUPER_ADMIN_USER;
grant usage, alter on sequence PWDCFG_CHALLENGE_SEQ to &IDEAS_CONN_SUPER_ADMIN_USER;
grant usage on sequence PWDCFG_CHALLENGE_SEQ to &IDEAS_REPORT_SUPER_ADMIN_USER;
