create table PWDCFG_CHALLENGE
(
  ID            NUMBER(16) not null,
  PWDCFG        NUMBER(16) not null,
  LOCALIZATION  NUMBER(16) not null,
  STATUS        NUMBER(2),
  ATTR1         VARCHAR2(256 CHAR),
  ATTR2         VARCHAR2(256 CHAR),
  ATTR3         VARCHAR2(256 CHAR),
  ATTR4         VARCHAR2(256 CHAR),
  ATTR5         VARCHAR2(256 CHAR),
  CREATION_USER VARCHAR2(128 CHAR),
  CREATION_DATE DATE default SYSDATE,
  LAST_MOD_USER VARCHAR2(128 CHAR),
  LAST_MOD_TIME DATE default SYSDATE
)
tablespace &DATA_TABLESPACE
;

alter table PWDCFG_CHALLENGE
  add constraint PWDCFG_CHALLENGE_PK primary key (ID)
  using index 
  tablespace &INDEX_TABLESPACE compute statistics;

alter table PWDCFG_CHALLENGE
  add constraint PWD_CHALL_PWDCFG_FK foreign key (PWDCFG)
  references PWDCFG (ID) on delete cascade;
alter table PWDCFG_CHALLENGE
  add constraint PWD_CHALL_LOCALIZATION_FK foreign key (LOCALIZATION)
  references LOCALIZATION (ID) on delete cascade;

create index PWD_CHALL_PWDM_IDX on PWDCFG_CHALLENGE (PWDCFG)
  tablespace &INDEX_TABLESPACE compute statistics;
create index PWD_CHALL_LOCALIZATION_IDX on PWDCFG_CHALLENGE (LOCALIZATION)
  tablespace &INDEX_TABLESPACE compute statistics;

create unique index PWD_CHALL_PWDM_IM_IDX on PWDCFG_CHALLENGE (PWDCFG, LOCALIZATION)
  tablespace &INDEX_TABLESPACE compute statistics;

grant select on PWDCFG_CHALLENGE to AA;
grant select, insert, update, delete, references on PWDCFG_CHALLENGE to IDEAS;
grant select, insert, update, delete, references on PWDCFG_CHALLENGE to IDEAS_CONNECTOR;
grant select on PWDCFG_CHALLENGE to IDEAS_REPORT;


create sequence PWDCFG_CHALLENGE_SEQ
  START WITH 100
  INCREMENT BY 1
  MINVALUE 100
  MAXVALUE 999999999999999999999999999
  NOCACHE
  NOCYCLE
  NOORDER;

grant select on PWDCFG_CHALLENGE_SEQ to AA;
grant select, alter on PWDCFG_CHALLENGE_SEQ to IDEAS;
grant select on PWDCFG_CHALLENGE_SEQ to IDEAS_CONNECTOR;
grant select on PWDCFG_CHALLENGE_SEQ to IDEAS_REPORT;
