create table PWDMANAGEMENT_RESPONSE
(
  ID               NUMERIC(16) not null,
  PWDMANAGEMENT    NUMERIC(16) not null,
  PWDCFG_CHALLENGE NUMERIC(16) not null,
  RESPONSE         VARCHAR(1024) not null,
  STATUS           NUMERIC(2),
  ATTR1            VARCHAR(256),
  ATTR2            VARCHAR(256),
  ATTR3            VARCHAR(256),
  ATTR4            VARCHAR(256),
  ATTR5            VARCHAR(256),
  CREATION_USER    VARCHAR(128),
  CREATION_DATE    DATE default CURRENT_DATE,
  LAST_MOD_USER    VARCHAR(128),
  LAST_MOD_TIME    DATE default CURRENT_DATE
)
IN &DATA_TABLESPACE
INDEX IN &INDEX_TABLESPACE
LONG IN &LOB_TABLESPACE
;

ALTER TABLE PWDMANAGEMENT_RESPONSE ADD
  CONSTRAINT PWDMANAGEMENT_RESPONSE_PK 
 PRIMARY KEY (ID);

alter table PWDMANAGEMENT_RESPONSE
  add constraint PWDM_RESP_PWDMAN_FK foreign key (PWDMANAGEMENT)
  references PWDMANAGEMENT (ID) on delete cascade;
alter table PWDMANAGEMENT_RESPONSE
  add constraint PWDM_RESP_PWDCFG_CHALLENGE_FK foreign key (PWDCFG_CHALLENGE)
  references PWDCFG_CHALLENGE (ID) on delete cascade;

create index PWDM_RESP_PWDMANAGEMENT_IDX on PWDMANAGEMENT_RESPONSE (PWDMANAGEMENT)
;
create index PWDM_RESP_PWDCFG_CHALLENGE_IDX on PWDMANAGEMENT_RESPONSE (PWDCFG_CHALLENGE)
;
create unique index PWDM_RESP_PWDM_LOC_IDX on PWDMANAGEMENT_RESPONSE (PWDMANAGEMENT, PWDCFG_CHALLENGE)
;

CALL SYSPROC.ADMIN_CMD ( 'REORG TABLE PWDMANAGEMENT_RESPONSE' );

grant select on PWDMANAGEMENT_RESPONSE to &AA_SUPER_ADMIN_USER;
grant select, insert, update, delete, references on PWDMANAGEMENT_RESPONSE to &IDEAS_SUPER_ADMIN_USER;
grant select, insert, update, delete, references on PWDMANAGEMENT_RESPONSE to &IDEAS_CONN_SUPER_ADMIN_USER;
grant select on PWDMANAGEMENT_RESPONSE to &IDEAS_REPORT_SUPER_ADMIN_USER;


create sequence PWDMANAGEMENT_RESPONSE_SEQ
  AS NUMERIC(18)
  START WITH 100
  INCREMENT BY 1
  MINVALUE 100
  MAXVALUE 999999999999999999
  NO CACHE
  NO CYCLE
  NO ORDER;

grant usage on sequence PWDMANAGEMENT_RESPONSE_SEQ to &AA_SUPER_ADMIN_USER;
grant usage, alter on sequence PWDMANAGEMENT_RESPONSE_SEQ to &IDEAS_SUPER_ADMIN_USER;
grant usage, alter on sequence PWDMANAGEMENT_RESPONSE_SEQ to &IDEAS_CONN_SUPER_ADMIN_USER;
grant usage on sequence PWDMANAGEMENT_RESPONSE_SEQ to &IDEAS_REPORT_SUPER_ADMIN_USER;
