create table PWDMANAGEMENT_RESPONSE
(
  ID               NUMBER(16) not null,
  PWDMANAGEMENT    NUMBER(16) not null,
  PWDCFG_CHALLENGE NUMBER(16) not null,
  RESPONSE         VARCHAR2(1024 CHAR) not null,
  STATUS           NUMBER(2),
  ATTR1            VARCHAR2(256 CHAR),
  ATTR2            VARCHAR2(256 CHAR),
  ATTR3            VARCHAR2(256 CHAR),
  ATTR4            VARCHAR2(256 CHAR),
  ATTR5            VARCHAR2(256 CHAR),
  CREATION_USER    VARCHAR2(128 CHAR),
  CREATION_DATE    DATE default SYSDATE,
  LAST_MOD_USER    VARCHAR2(128 CHAR),
  LAST_MOD_TIME    DATE default SYSDATE
)
tablespace &DATA_TABLESPACE
;

alter table PWDMANAGEMENT_RESPONSE
  add constraint PWDMANAGEMENT_RESPONSE_PK primary key (ID)
  using index 
  tablespace &INDEX_TABLESPACE compute statistics;

alter table PWDMANAGEMENT_RESPONSE
  add constraint PWDM_RESP_PWDMAN_FK foreign key (PWDMANAGEMENT)
  references PWDMANAGEMENT (ID) on delete cascade;
alter table PWDMANAGEMENT_RESPONSE
  add constraint PWDM_RESP_PWDCFG_CHALLENGE_FK foreign key (PWDCFG_CHALLENGE)
  references PWDCFG_CHALLENGE (ID) on delete cascade;

create index PWDM_RESP_PWDMANAGEMENT_IDX on PWDMANAGEMENT_RESPONSE (PWDMANAGEMENT)
  tablespace &INDEX_TABLESPACE compute statistics;
create index PWDM_RESP_PWDCFG_CHALLENGE_IDX on PWDMANAGEMENT_RESPONSE (PWDCFG_CHALLENGE)
  tablespace &INDEX_TABLESPACE compute statistics;

create unique index PWDM_RESP_PWDM_LOC_IDX on PWDMANAGEMENT_RESPONSE (PWDMANAGEMENT, PWDCFG_CHALLENGE)
  tablespace &INDEX_TABLESPACE compute statistics;

grant select on PWDMANAGEMENT_RESPONSE to AA;
grant select, insert, update, delete, references on PWDMANAGEMENT_RESPONSE to IDEAS;
grant select, insert, update, delete, references on PWDMANAGEMENT_RESPONSE to IDEAS_CONNECTOR;
grant select on PWDMANAGEMENT_RESPONSE to IDEAS_REPORT;


create sequence PWDMANAGEMENT_RESPONSE_SEQ
  START WITH 100
  INCREMENT BY 1
  MINVALUE 100
  MAXVALUE 999999999999999999999999999
  NOCACHE
  NOCYCLE
  NOORDER;

grant select, alter on PWDMANAGEMENT_RESPONSE_SEQ to IDEAS;
grant select on PWDMANAGEMENT_RESPONSE_SEQ to IDEAS_CONNECTOR;
grant select on PWDMANAGEMENT_RESPONSE_SEQ to IDEAS_REPORT;
