--CREATE AN INDEX
set verify off
set serveroutput on
declare
  curr_user         varchar2(30);
  
  idx_name          varchar2(30) := 'JOBUNIT_ID_OU_IDX';
  dml_def           varchar2(4000);
  
  counter           number(16);
begin
  select trim ( user ) into curr_user from dual;
  select count(1) into counter from all_indexes t where t.owner = curr_user and t.index_name = idx_name;
  if ( counter = 1 ) then
    return;
  end if;

  dml_def :=
'create unique index JOBUNIT_ID_OU_IDX on JOB_UNIT (ID, ORGANIZATIONAL_UNIT)
  tablespace &INDEX_TABLESPACE compute statistics
';

  if ( '&ECHO' = 'ON' ) then
    dbms_output.put_line ( dml_def );
  end if;
  execute immediate ( dml_def );

end;
/
set serveroutput off
set verify on


--CREATE AN INDEX
set verify off
set serveroutput on
declare
  curr_user         varchar2(30);
  
  idx_name          varchar2(30) := 'JOBUNIT_OU_ID_IDX';
  dml_def           varchar2(4000);
  
  counter           number(16);
begin
  select trim ( user ) into curr_user from dual;
  select count(1) into counter from all_indexes t where t.owner = curr_user and t.index_name = idx_name;
  if ( counter = 1 ) then
    return;
  end if;

  dml_def :=
'create unique index JOBUNIT_OU_ID_IDX on JOB_UNIT (ORGANIZATIONAL_UNIT, ID)
  tablespace &INDEX_TABLESPACE compute statistics
';

  if ( '&ECHO' = 'ON' ) then
    dbms_output.put_line ( dml_def );
  end if;
  execute immediate ( dml_def );

end;
/
set serveroutput off
set verify on
