alter table AGC_LANGUAGE add COUNTRY VARCHAR2(4 CHAR);
comment on column AGC_LANGUAGE.COUNTRY
  is 'identify the language in two lower char (ISO Country Code, ISO 3166)';

drop index AGC_LANGUAGE_LCODE_IDX;
create unique index AGC_LANGUAGE_LCODE_LCOU_IDX on AGC_LANGUAGE (LOWER(CODE), LOWER(COUNTRY))
  tablespace &INDEX_TABLESPACE compute statistics;

update agc_language set country = 'BR' where lower ( code ) = lower ( 'PT' );
update agc_language set name = 'Brazilian' where lower ( code ) = lower ( 'PT' ) and lower ( country ) = lower ( 'BR' );

update agc_language set country = 'CN' where lower ( code ) = lower ( 'ZH' ) and country is null;
update agc_language set name = 'Simplified Chinese' where lower ( code ) = lower ( 'ZH' ) and lower ( country ) = lower ( 'CN' );

declare
  lan_id             number(16);
  lan_code_old       varchar2(4) := '01';
  lan_code           varchar2(4) := 'ZH';
  lan_country        varchar2(4) := 'TW';
  lan_name           varchar2(256) := 'Traditional Chinese';

  counter            number(16);
begin
  select count(1) into counter from agc_language t where  lower ( code ) = lower ( lan_code_old );
  if ( counter = 0 ) then
    select count(1) into counter from agc_language t
    where  lower ( code ) = lower ( lan_code ) and lower ( country ) = lower ( lan_country );
    if ( counter = 0 ) then
      select max ( id ) + 1 into lan_id from agc_language;
      insert into agc_language ( id, code, country, name )
      values ( lan_id, lan_code, lan_country, lan_name );
    end if;
  else 
    update agc_language set country = lan_country where lower ( code ) = lower ( lan_code_old );
    update agc_language set name = lan_name where lower ( code ) = lower ( lan_code_old );
    update agc_language set code = lan_code where lower ( code ) = lower ( lan_code_old );
  end if;
end;
/
commit;
