alter trigger trg_entitlement_protection disable;
alter trigger trg_entitlement_validator disable;
alter trigger trg_ent_hier_protection disable;
alter trigger trg_add_remove_ent_flat_hier disable;
alter trigger trg_entitlement_history disable;
alter trigger trg_ent_hier_history disable;


declare
  app_id         number(16);
  app_name       varchar2(256) := 'SelfCare';

  it_id          number(16);

  it_old_name    varchar2(256) := 'SelfCare Administrator';
  it_name        varchar2(256) := 'Self Care';

  counter        number(16);
begin
  select count(1) into counter from application where lower ( name ) = lower ( app_name ) and administrative = 1;
  if ( counter = 0 ) then
    return;
  end if;
  select id into app_id from application where lower ( name ) = lower ( app_name ) and administrative = 1;

  select count(1) into counter from entitlement where lower ( name ) = lower ( it_old_name ) and application = app_id and administrative = 1;
  if ( counter = 0 ) then
    return;
  end if;
  select id into it_id from entitlement where lower ( name ) = lower ( it_old_name ) and application = app_id and administrative = 1;

  insert into tmp_codoperation ( code ) values ( 'RENAME ITROLE' );
  update entitlement set name = it_name where id = it_id;
end;
/
commit;

declare
  app_id         number(16);
  tmp_num        number(16);
  ch_id          number(16)    := 1;

  ideas_version  varchar2(256) := '&IDEAS_VERSION';
  counter        number(16);
begin
  if ( instr ( lower ( trim ( user ) ), lower ( 'CCS_' ) ) > 0  ) then
    return;
  end if;

  select count(1) into counter from application where lower ( name ) = lower ( 'AccessGovernanceCore' );
  if ( counter = 1 ) then
    return;
  end if;

  app_id := inst_create_app ( null, 'SelfCare', 'IDEAS - SelfCare Module', 'Ideas' );

  tmp_num := inst_create_profile_type ( null, 'SelfCare', 'IDEAS - SelfCare Module profile type', app_id );

  tmp_num := inst_create_entitlement ( null,
                                  'Self Care',
                                  'Entitlements related to SelfCare',
                                  2, app_id, null, 1, ideas_version);

  ch_id := null;
  ch_id := inst_ent_add_to_ent (null, 'Self Care', 2, ch_id, 'MODIFY_PASSWORD', 1, 'SelfCare', 'SelfCare', ideas_version);
  ch_id := inst_ent_add_to_ent (null, 'Self Care', 2, ch_id, 'FIND_REQUESTS', 1, 'SelfCare', 'SelfCare', ideas_version);
  ch_id := inst_ent_add_to_ent (null, 'Self Care', 2, ch_id, 'MODIFY_QUESTIONS', 1, 'SelfCare', 'SelfCare', ideas_version);

  ch_id := null;
  ch_id := inst_ent_add_to_ent (null, 'Employee', 3, ch_id, 'MODIFY_PASSWORD', 1, 'SelfCare', 'SelfCare', ideas_version);
  ch_id := inst_ent_add_to_ent (null, 'Employee', 3, ch_id, 'FIND_REQUESTS', 1, 'SelfCare', 'SelfCare', ideas_version);
  ch_id := inst_ent_add_to_ent (null, 'Employee', 3, ch_id, 'MODIFY_QUESTIONS', 1, 'SelfCare', 'SelfCare', ideas_version);
  commit;
end;
/


alter trigger trg_entitlement_protection enable;
alter trigger trg_entitlement_validator enable;
alter trigger trg_ent_hier_protection enable;
alter trigger trg_add_remove_ent_flat_hier enable;
alter trigger trg_entitlement_history enable;
alter trigger trg_ent_hier_history enable;

