--ADD A COLUMN TO A TABLE
set verify off
set serveroutput on
declare
  curr_user         varchar(30);
  
  tab_name          varchar(30) := 'EXTERNALMAPPING';
  tab_col_name      varchar(30) := 'DEFAULT_VALUE';
  dml_def           varchar(4000);
  
  counter           numeric(16);
begin
  select trim ( user ) into curr_user from dual;
  select count(1) into counter from syscat.columns t where t.tabschema = curr_user and lower ( t.tabname ) = lower ( tab_name ) and lower ( t.colname ) = lower ( tab_col_name );
  if ( counter = 1 ) then
    return;
  end if;

  dml_def :=
'alter table EXTERNALMAPPING add DEFAULT_VALUE VARCHAR(256)
';

  if ( '&ECHO' = 'ON' ) then
    dbms_output.put_line ( dml_def );
  end if;
  execute immediate ( dml_def );

end;
/
set serveroutput off
set verify on

--ADD A COLUMN TO A TABLE
set verify off
set serveroutput on
declare
  curr_user         varchar(30);
  
  tab_name          varchar(30) := 'EXTERNALMAPPING';
  tab_col_name      varchar(30) := 'EDITABLE';
  dml_def           varchar(4000);
  
  counter           numeric(16);
begin
  select trim ( user ) into curr_user from dual;
  select count(1) into counter from syscat.columns t where t.tabschema = curr_user and lower ( t.tabname ) = lower ( tab_name ) and lower ( t.colname ) = lower ( tab_col_name );
  if ( counter = 1 ) then
    return;
  end if;

  dml_def :=
'alter table EXTERNALMAPPING add EDITABLE NUMERIC(1)
';

  if ( '&ECHO' = 'ON' ) then
    dbms_output.put_line ( dml_def );
  end if;
  execute immediate ( dml_def );

end;
/
set serveroutput off
set verify on

--ADD A COLUMN TO A TABLE
set verify off
set serveroutput on
declare
  curr_user         varchar(30);
  
  tab_name          varchar(30) := 'EXTERNALMAPPING';
  tab_col_name      varchar(30) := 'LOOKUP';
  dml_def           varchar(4000);
  
  counter           numeric(16);
begin
  select trim ( user ) into curr_user from dual;
  select count(1) into counter from syscat.columns t where t.tabschema = curr_user and lower ( t.tabname ) = lower ( tab_name ) and lower ( t.colname ) = lower ( tab_col_name );
  if ( counter = 1 ) then
    return;
  end if;

  dml_def :=
'alter table EXTERNALMAPPING add LOOKUP VARCHAR(256)
';

  if ( '&ECHO' = 'ON' ) then
    dbms_output.put_line ( dml_def );
  end if;
  execute immediate ( dml_def );

end;
/
set serveroutput off
set verify on

--ADD A COLUMN TO A TABLE
set verify off
set serveroutput on
declare
  curr_user         varchar(30);
  
  tab_name          varchar(30) := 'EXTERNALMAPPING';
  tab_col_name      varchar(30) := 'LOOKUP_TYPE';
  dml_def           varchar(4000);
  
  counter           numeric(16);
begin
  select trim ( user ) into curr_user from dual;
  select count(1) into counter from syscat.columns t where t.tabschema = curr_user and lower ( t.tabname ) = lower ( tab_name ) and lower ( t.colname ) = lower ( tab_col_name );
  if ( counter = 1 ) then
    return;
  end if;

  dml_def :=
'alter table EXTERNALMAPPING add LOOKUP_TYPE NUMERIC(1)
';

  if ( '&ECHO' = 'ON' ) then
    dbms_output.put_line ( dml_def );
  end if;
  execute immediate ( dml_def );

end;
/
set serveroutput off
set verify on

--ADD A COLUMN TO A TABLE
set verify off
set serveroutput on
declare
  curr_user         varchar(30);
  
  tab_name          varchar(30) := 'EXTERNALMAPPING';
  tab_col_name      varchar(30) := 'LOCALIZATION';
  dml_def           varchar(4000);
  
  counter           numeric(16);
begin
  select trim ( user ) into curr_user from dual;
  select count(1) into counter from syscat.columns t where t.tabschema = curr_user and lower ( t.tabname ) = lower ( tab_name ) and lower ( t.colname ) = lower ( tab_col_name );
  if ( counter = 1 ) then
    return;
  end if;

  dml_def :=
'alter table EXTERNALMAPPING add LOCALIZATION NUMERIC(16)
';

  if ( '&ECHO' = 'ON' ) then
    dbms_output.put_line ( dml_def );
  end if;
  execute immediate ( dml_def );

end;
/
set serveroutput off
set verify on

--ADD A COLUMN TO A TABLE
set verify off
set serveroutput on
declare
  curr_user         varchar(30);
  
  tab_name          varchar(30) := 'EXTERNALMAPPING';
  tab_col_name      varchar(30) := 'UI_RENDERING';
  dml_def           varchar(4000);
  
  counter           numeric(16);
begin
  select trim ( user ) into curr_user from dual;
  select count(1) into counter from syscat.columns t where t.tabschema = curr_user and lower ( t.tabname ) = lower ( tab_name ) and lower ( t.colname ) = lower ( tab_col_name );
  if ( counter = 1 ) then
    return;
  end if;

  dml_def :=
'alter table EXTERNALMAPPING add UI_RENDERING NUMERIC(2)
';

  if ( '&ECHO' = 'ON' ) then
    dbms_output.put_line ( dml_def );
  end if;
  execute immediate ( dml_def );

end;
/
set serveroutput off
set verify on

comment on column EXTERNALMAPPING.REQUIRED
  is '0: NOT REQUIRED - 1: REQUIRED NOT NULL ON DB - 2: REQUIRED ON UI';
comment on column EXTERNALMAPPING.LOOKUP_TYPE
  is '0: INTERNAL LOOKUP - 1: POPUP WINDOW LOOKUP - 2: SELECTFIELD LOOKUP';

--ADD A FOREIGN KEY
set verify off
set serveroutput on
declare
  curr_user         varchar(30);
  
  tab_name          varchar(30) := 'EXTERNALMAPPING';
  tab_fk_name       varchar(30) := 'EXTMAPPING_LOCALIZATION_FK';
  dml_def           varchar(4000);
  
  counter           numeric(16);
begin
  select trim ( user ) into curr_user from dual;
  select count(1) into counter from syscat.tabconst t where t.tabschema = curr_user and lower ( t.tabname ) = lower ( tab_name ) and lower ( t.constname ) = lower ( tab_fk_name ) and t.type = 'F';
  if ( counter = 1 ) then
    return;
  end if;

  dml_def :=
'alter table EXTERNALMAPPING
  add constraint EXTMAPPING_LOCALIZATION_FK foreign key (LOCALIZATION)
  references localization (ID) on delete set null
';

  if ( '&ECHO' = 'ON' ) then
    dbms_output.put_line ( dml_def );
  end if;
  execute immediate ( dml_def );

end;
/
set serveroutput off
set verify on

--REORGANIZE A TABLE
set verify off
set serveroutput on
declare
  curr_user         varchar(30);
  
  tab_name          varchar(30) := 'EXTERNALMAPPING';
  dml_def           varchar(4000);
  
  counter           numeric(16);
begin
  select trim ( user ) into curr_user from dual;
  select count(1) into counter from sysibm.tables t where ( t.table_type = 'BASE TABLE' or t.table_type is null ) and lower ( t.table_schema ) = lower ( curr_user ) and t.table_name = tab_name;
  if ( counter = 0 ) then
    return;
  end if;

  dml_def :=
'CALL SYSPROC.ADMIN_CMD( ''REORG TABLE EXTERNALMAPPING'' )
';

  if ( '&ECHO' = 'ON' ) then
    dbms_output.put_line ( dml_def );
  end if;
  execute immediate ( dml_def );

end;
/
commit;
set serveroutput off
set verify on
