declare
  im_id                number(16);
  im_code              varchar2(256) := 'PASSWORDSERVICE';

  lan_id               number(16);
  lan_code             varchar2(256) := 'EN';

  pwdcfg_id            number(16);
  pwdcfg_name          varchar2(256) := 'Ideas';

  cr_loc_id            number(16);
  cr_loc_code          varchar2(256);
  cr_loc_type          number(16) := 1;

  pwdchall_id          number(16);
  pwdchall_status      number(16) := 1;

  i18n_mess_id         number(16);
  i18n_mess            varchar2(256);

  cr_loc_code_prefix   varchar2(256) := 'question.';
  i18n_mess_prefix     varchar2(256) := 'Question n#';

  cr_number_begin      number(16) := 1;
  cr_number_end        number(16) := 30;
  current_cr           number(16) := 1;

  counter              number(16);
begin
  if ( instr ( lower ( trim ( user ) ), lower ( 'CCS_' ) ) > 0  ) then
    return;
  end if;

  select count(1) into counter from ideas_module t where lower ( t.code ) = lower ( im_code );
  if ( counter = 0 ) then
    return;
  end if;
  select t.id into im_id from ideas_module t where lower ( t.code ) = lower ( im_code );

  select count(1) into counter from language t where lower ( t.code ) = lower ( lan_code );
  if ( counter = 0 ) then
    return;
  end if;
  select t.id into lan_id from language t where lower ( t.code ) = lower ( lan_code );

  select count(1) into counter from pwdcfg t where lower ( t.name ) = lower ( pwdcfg_name );
  if ( counter = 0 ) then
    return;
  end if;
  select t.id into pwdcfg_id from pwdcfg t where lower ( t.name ) = lower ( pwdcfg_name );

  loop
    cr_loc_code := cr_loc_code_prefix || cast ( current_cr as varchar2 );
    i18n_mess := i18n_mess_prefix || cast ( current_cr as varchar2 );
    
    select count(1) into counter from localization t where t.ideas_module = im_id and lower ( t.code ) = lower ( cr_loc_code );
    if ( counter = 0 ) then
      select localization_seq.nextval into cr_loc_id from dual;
      insert into localization ( id, ideas_module, code, code_type )
      values ( cr_loc_id, im_id, cr_loc_code, cr_loc_type );
    else
      select t.id into cr_loc_id from localization t where t.ideas_module = im_id and lower ( t.code ) = lower ( cr_loc_code );
      update localization set code_type = cr_loc_type where id = cr_loc_id;
    end if;

    select count(1) into counter from pwdcfg_challenge t where t.pwdcfg = pwdcfg_id and t.localization = cr_loc_id;
    if ( counter = 0 ) then
      select pwdcfg_challenge_seq.nextval into pwdchall_id from dual;
      insert into pwdcfg_challenge ( id, pwdcfg, localization, status )
      values ( pwdchall_id, pwdcfg_id, cr_loc_id, pwdchall_status );
    else
      select t.id into pwdchall_id from pwdcfg_challenge t where t.pwdcfg = pwdcfg_id and t.localization = cr_loc_id;
      update pwdcfg_challenge set status = pwdchall_status where id = pwdchall_id;
    end if;
    
    select count(1) into counter from i18n_message t where t.ideas_module = im_id and t.language = lan_id and t.localization = cr_loc_id;
    if ( counter = 0 ) then
      select i18n_message_seq.nextval into i18n_mess_id from dual;
      insert into i18n_message ( id, ideas_module, language, localization, message )
      values ( i18n_mess_id, im_id, lan_id, cr_loc_id, i18n_mess );
    else
      update i18n_message set message = i18n_mess where ideas_module = im_id and language = lan_id and localization = cr_loc_id;
    end if;

    current_cr := current_cr + 1;
    exit when current_cr > cr_number_end;
  end loop;
end;
/
commit;
