CREATE OR REPLACE TRIGGER TRG_PERSON_RES_TO_EVENT_PM
  AFTER INSERT OR UPDATE ON PERSON_RESOURCE
  FOR EACH ROW
declare
  counter       number(16);

  per_id        number(16);
  code_oper     varchar2(128);
  oper          number(2);
  res_id        number(16);
  ent_id        number(16);
  per_res_id    number(16);
  res_name      varchar2(256);
  res_type_name varchar2(256);
  res_fam_name  varchar2(256);
  ent_name      varchar2(256);

  feedB         boolean;
begin
  --si sta inserendo un nuovo record non completo di tutte le informazioni
  if ( inserting ) then
    per_id        := :new.person;
    oper          := 14;
    res_id        := :new.resourc;
    ent_id        := :new.entitlement;
    per_res_id    := :new.id;
  --si stanno aggiornando le informazioni di un record incompleto
  elsif ( updating and :new.res_authorization is not null ) then
    return;
  --si stanno cancellando un record
  elsif ( updating and :new.res_authorization is null ) then
    per_id        := :old.person;
    oper          := 15;
    res_id        := :old.resourc;
    ent_id        := :old.entitlement;
    per_res_id    := :old.id;

    res_name      := :old.resource_name;
    res_type_name := :old.resource_type_name;
    res_fam_name  := :old.resource_fam_name;
    ent_name      := :old.entitlement_name;
  else
    return;
  end if;

  select count(1) into counter from tmp_codoperation;

  if ( counter = 0 ) then
    RAISE_APPLICATION_ERROR ( -20200, 'NO OPERATION CODE FOUND IN TMP_CODOPERATION TABLE');
  elsif ( counter = 1 ) then
    select code into code_oper from tmp_codoperation;
  elsif  ( counter > 1 ) then
    RAISE_APPLICATION_ERROR ( -20201, 'TOO MANY OPERATION CODE FOUND IN TMP_CODOPERATION TABLE');
  end if;

  feedB := code_oper is not null and INSTR(code_oper, 'ARM_', 1, 1) = 1;

  insert into eventpm
    (id,
     person,
     cod_operation,
     operation,
     entity,
     attr1,
     attr2,
     attr3,
     attr4,
     attr5,
     pwdcfg)
  values
    (eventpm_seq.nextval,
     per_id,
     code_oper,
     oper,
     res_id,
     res_name,
     res_type_name,
     res_fam_name,
     ent_name,
     per_res_id,
     ent_id);

    if ( feedB ) then
      insert into feedback
        (id,
         authorizations,
         cod_operation,
         operation)
      values
        (feedback_seq.nextval,
         per_res_id,
         code_oper,
         oper);
    end if;

end TRG_PERSON_RES_TO_EVENT_PM;
/
