create or replace function event_11_account_mod
(
  v_eventpm in eventpm%rowtype,
  v_user_erc_id in number,
  v_state in number,
  v_trace in varchar2,
  v_priority in number,
  oper in number
)
return number is
  cur_pwdcfg      sys_refcursor;

  v_target        varchar2(256);
  v_pwdcfgname    varchar2(256);
  v_code          varchar2(256); -- code utente
  v_pwd           varchar2(256); -- password cifrata
  v_block         varchar2(256); -- attr3 codice blocco
  v_eventpm_attr5 number(16);    -- pwdmanagement ID
begin
  v_eventpm_attr5 := cast ( v_eventpm.attr5 as number );

  v_code  := v_eventpm.attr1;
  v_pwd   := v_eventpm.attr2;
  v_block := v_eventpm.attr3;

  -- elenco dei target legati alla configurazione che ha generato l'evento
  open cur_pwdcfg for
    select distinct t.value, p.name
      from target t, pwdcfg p
     where t.pwdcfg = p.id
       and p.id = v_eventpm.pwdcfg
       and p.sync <> 0;

  loop
    fetch cur_pwdcfg into v_target, v_pwdcfgname;
    exit when cur_pwdcfg%NOTFOUND;

    -- controllo del target
    if ( v_target is not null ) then
      insert into event_out
        (id, person, user_erc, target, cod_operation, operation,
         attr1, attr2, attr3, application, state, trace, date_process, date_event, last_mod_time, last_mod_user, priority, user_id)
      values
         (event_out_seq.nextval, v_eventpm.person, v_user_erc_id, v_target, v_eventpm.cod_operation, oper,
          v_code, v_pwd, v_block, v_pwdcfgname, v_state, v_trace, sysdate, sysdate, sysdate, user, v_priority, v_code);

      update feedback
         set user_erc    = v_user_erc_id
       where authorizations = v_eventpm_attr5
         and operation = v_eventpm.operation;
    end if;

    --evento di modifica user code
    if ( oper = 10 ) then
      update authorizations set account_code = v_eventpm.attr1 where person = v_eventpm.person and profile in
      ( select e.id from entitlement e, application a, target t where e.application = a.id and a.target = t.id
        and t.pwdcfg = v_eventpm.pwdcfg and e.int_type = 1 );
    end if;

  end loop;
  close cur_pwdcfg;

  return 1;
end event_11_account_mod;
/
