alter trigger trg_entitlement_protection disable;
alter trigger trg_entitlement_validator disable;
alter trigger trg_ent_hier_protection disable;
alter trigger trg_add_remove_ent_flat_hier disable;
alter trigger trg_entitlement_history disable;
alter trigger trg_ent_hier_history disable;


declare
  app_id         number(16);
  tmp_num        number(16);
  ch_id          number(16)    := 1;

  ideas_version  varchar2(256) := '&IDEAS_VERSION';
  counter        number(16);

  v_ret          number(16);
  dest_schema    varchar2(30);
begin
  if ( instr ( lower ( trim ( user ) ), lower ( 'CCS_' ) ) > 0  ) then
    return;
  end if;
  
  app_id := inst_create_app ( null, 'Reports', 'IDEAS - Report Client Module', 'Ideas' );

  tmp_num := inst_create_profile_type ( null, 'dashboard', 'IDEAS - Report Module profile type for DashBoards', app_id );

  tmp_num := inst_prop_add_to_app ( 'Reports', 'IDEAS - Report Client Module', 'CROSSREPORT', 'TRUE', ideas_version );
  tmp_num := inst_prop_add_to_app ( 'Reports', 'IDEAS - Report Client Module', 'hide_app', 'TRUE', ideas_version );

  tmp_num := inst_create_entitlement ( null,
                                  'Application Manager',
                                  '',
                                  3, null, null, 1, ideas_version);

  tmp_num := inst_create_entitlement ( null,
                                  'User Manager',
                                  '',
                                  3, null, null, 1, ideas_version);

  tmp_num := inst_create_entitlement ( null,
                                  'Employee',
                                  '',
                                  3, null, null, 1, ideas_version);

  ch_id := null;
  ch_id := inst_ent_add_to_ent (null, 'Application Manager', 3, ch_id, 'Account matching status', 1, 'Reports', 'dashboard', ideas_version);
  ch_id := inst_ent_add_to_ent (null, 'Application Manager', 3, ch_id, 'Accounts created in last x days', 1, 'Reports', 'dashboard', ideas_version);
  ch_id := inst_ent_add_to_ent (null, 'Application Manager', 3, ch_id, 'Accounts expiring in next x days with application scope', 1, 'Reports', 'dashboard', ideas_version);
  ch_id := inst_ent_add_to_ent (null, 'Application Manager', 3, ch_id, 'Activities created in last x days', 1, 'Reports', 'dashboard', ideas_version);
  ch_id := inst_ent_add_to_ent (null, 'Application Manager', 3, ch_id, 'Permissions created in last x days', 1, 'Reports', 'dashboard', ideas_version);
  ch_id := inst_ent_add_to_ent (null, 'Application Manager', 3, ch_id, 'Business activity mapping status', 1, 'Reports', 'dashboard', ideas_version);
  ch_id := inst_ent_add_to_ent (null, 'Application Manager', 3, ch_id, 'Unmatched accounts', 1, 'Reports', 'dashboard', ideas_version);

  ch_id := null;
  --ch_id := inst_ent_add_to_ent (null, 'Employee', 3, ch_id, 'Access request history', 1, 'Reports', 'dashboard', ideas_version);
  ch_id := inst_ent_add_to_ent (null, 'Employee', 3, ch_id, 'My entitlements', 1, 'Reports', 'dashboard', ideas_version);
  --ch_id := inst_ent_add_to_ent (null, 'Employee', 3, ch_id, 'My requests', 1, 'Reports', 'dashboard', ideas_version);
  ch_id := inst_ent_add_to_ent (null, 'Employee', 3, ch_id, 'Recent requests', 1, 'Reports', 'dashboard', ideas_version);

  ch_id := null;
  ch_id := inst_ent_add_to_ent (null, 'User Manager', 3, ch_id, 'Accounts expiring in next x days with OU scope', 1, 'Reports', 'dashboard', ideas_version);
  ch_id := inst_ent_add_to_ent (null, 'User Manager', 3, ch_id, 'Accounts expiring in next x days with OU visibility count', 1, 'Reports', 'dashboard', ideas_version);
  ch_id := inst_ent_add_to_ent (null, 'User Manager', 3, ch_id, 'Delegation assignments', 1, 'Reports', 'dashboard', ideas_version);
  ch_id := inst_ent_add_to_ent (null, 'User Manager', 3, ch_id, 'Illegal user without mitigation', 1, 'Reports', 'dashboard', ideas_version);
  ch_id := inst_ent_add_to_ent (null, 'User Manager', 3, ch_id, 'Locked accounts', 1, 'Reports', 'dashboard', ideas_version);
  ch_id := inst_ent_add_to_ent (null, 'User Manager', 3, ch_id, 'User violations', 1, 'Reports', 'dashboard', ideas_version);

  --UPDATE ENTITLEMENT WITH REPORT'S ID
  select upper ( replace ( lower ( trim ( user ) ), lower ( 'IGA_' ), lower ( 'IGA_REPORT_' ) ) ) into dest_schema from dual;

  --ORACLE ONLY
  dest_schema := replace ( dest_schema, '_MAIN' );

  v_ret := inst_report_update_ent ( dest_schema, 'Reports', 'dashboard' );
end;
/
commit;

alter trigger trg_entitlement_protection enable;
alter trigger trg_entitlement_validator enable;
alter trigger trg_ent_hier_protection enable;
alter trigger trg_add_remove_ent_flat_hier enable;
alter trigger trg_entitlement_history enable;
alter trigger trg_ent_hier_history enable;
