declare
  var_ret    numeric(1);
begin
  var_ret := db2_trg_disable ( 'trg_entitlement_protection' );
end;
/
declare
  var_ret    numeric(1);
begin
  var_ret := db2_trg_disable ( 'trg_entitlement_validator' );
end;
/
declare
  var_ret    numeric(1);
begin
  var_ret := db2_trg_disable ( 'trg_ent_hier_protection' );
end;
/
declare
  var_ret    numeric(1);
begin
  var_ret := db2_trg_disable ( 'trg_add_remove_ent_flat_hier' );
end;
/
declare
  var_ret    numeric(1);
begin
  var_ret := db2_trg_disable ( 'trg_entitlement_history' );
end;
/
declare
  var_ret    numeric(1);
begin
  var_ret := db2_trg_disable ( 'trg_ent_hier_history' );
end;
/


declare
  app_id         numeric(16);
  tmp_num        numeric(16);
  ch_id          numeric(16)  := 1;

  ideas_version  varchar(256) := '&IDEAS_VERSION';
  counter        numeric(16);

  v_ret          numeric(16);
  dest_schema    varchar(30);
begin
  if ( instr ( lower ( trim ( user ) ), lower ( 'CCS' ) ) > 0  ) then
    return;
  end if;
  
  app_id := inst_create_app ( null, 'Reports', 'IDEAS - Report Client Module', 'Ideas' );

  tmp_num := inst_create_profile_type ( null, 'dashboard', 'IDEAS - Report Module profile type for DashBoards', app_id );

  tmp_num := inst_prop_add_to_app ( 'Reports', 'IDEAS - Report Client Module', 'CROSSREPORT', 'TRUE', ideas_version );
  tmp_num := inst_prop_add_to_app ( 'Reports', 'IDEAS - Report Client Module', 'hide_app', 'TRUE', ideas_version );

  tmp_num := inst_create_entitlement ( null,
                                  'Application Manager',
                                  '',
                                  3, null, null, 1, ideas_version);

  tmp_num := inst_create_entitlement ( null,
                                  'User Manager',
                                  '',
                                  3, null, null, 1, ideas_version);

  tmp_num := inst_create_entitlement ( null,
                                  'Employee',
                                  '',
                                  3, null, null, 1, ideas_version);

  ch_id := null;
  ch_id := inst_ent_add_to_ent (null, 'Application Manager', 3, ch_id, 'Account matching status', 1, 'Reports', 'dashboard', ideas_version);
  ch_id := inst_ent_add_to_ent (null, 'Application Manager', 3, ch_id, 'Accounts created in last x days', 1, 'Reports', 'dashboard', ideas_version);
  ch_id := inst_ent_add_to_ent (null, 'Application Manager', 3, ch_id, 'Accounts expiring in next x days with application scope', 1, 'Reports', 'dashboard', ideas_version);
  ch_id := inst_ent_add_to_ent (null, 'Application Manager', 3, ch_id, 'Activities created in last x days', 1, 'Reports', 'dashboard', ideas_version);
  ch_id := inst_ent_add_to_ent (null, 'Application Manager', 3, ch_id, 'Permissions created in last x days', 1, 'Reports', 'dashboard', ideas_version);
  ch_id := inst_ent_add_to_ent (null, 'Application Manager', 3, ch_id, 'Business activity mapping status', 1, 'Reports', 'dashboard', ideas_version);
  ch_id := inst_ent_add_to_ent (null, 'Application Manager', 3, ch_id, 'Unmatched accounts', 1, 'Reports', 'dashboard', ideas_version);

  ch_id := null;
  --ch_id := inst_ent_add_to_ent (null, 'Employee', 3, ch_id, 'Access request history', 1, 'Reports', 'dashboard', ideas_version);
  ch_id := inst_ent_add_to_ent (null, 'Employee', 3, ch_id, 'My entitlements', 1, 'Reports', 'dashboard', ideas_version);
  --ch_id := inst_ent_add_to_ent (null, 'Employee', 3, ch_id, 'My requests', 1, 'Reports', 'dashboard', ideas_version);
  ch_id := inst_ent_add_to_ent (null, 'Employee', 3, ch_id, 'Recent requests', 1, 'Reports', 'dashboard', ideas_version);

  ch_id := null;
  ch_id := inst_ent_add_to_ent (null, 'User Manager', 3, ch_id, 'Accounts expiring in next x days with OU scope', 1, 'Reports', 'dashboard', ideas_version);
  ch_id := inst_ent_add_to_ent (null, 'User Manager', 3, ch_id, 'Accounts expiring in next x days with OU visibility count', 1, 'Reports', 'dashboard', ideas_version);
  ch_id := inst_ent_add_to_ent (null, 'User Manager', 3, ch_id, 'Delegation assignments', 1, 'Reports', 'dashboard', ideas_version);
  ch_id := inst_ent_add_to_ent (null, 'User Manager', 3, ch_id, 'Illegal user without mitigation', 1, 'Reports', 'dashboard', ideas_version);
  ch_id := inst_ent_add_to_ent (null, 'User Manager', 3, ch_id, 'Locked accounts', 1, 'Reports', 'dashboard', ideas_version);
  ch_id := inst_ent_add_to_ent (null, 'User Manager', 3, ch_id, 'User violations', 1, 'Reports', 'dashboard', ideas_version);

  --UPDATE ENTITLEMENT WITH REPORT'S ID
  select upper ( replace ( lower ( trim ( user ) ), lower ( 'IGA' ), lower ( 'REP' ) ) ) into dest_schema from dual;

  --ORACLE ONLY
  --dest_schema := replace ( dest_schema, '_MAIN' );

  v_ret := inst_report_update_ent ( dest_schema, 'Reports', 'dashboard' );
end;
/
commit;


declare
  var_ret    numeric(1);
begin
  var_ret := db2_trg_enable ( 'trg_entitlement_protection' );
end;
/
declare
  var_ret    numeric(1);
begin
  var_ret := db2_trg_enable ( 'trg_entitlement_validator' );
end;
/
declare
  var_ret    numeric(1);
begin
  var_ret := db2_trg_enable ( 'trg_ent_hier_protection' );
end;
/
declare
  var_ret    numeric(1);
begin
  var_ret := db2_trg_enable ( 'trg_add_remove_ent_flat_hier' );
end;
/
declare
  var_ret    numeric(1);
begin
  var_ret := db2_trg_enable ( 'trg_entitlement_history' );
end;
/
declare
  var_ret    numeric(1);
begin
  var_ret := db2_trg_enable ( 'trg_ent_hier_history' );
end;
/

