declare
  br_id          number(16);
  br_name        varchar2(256) := 'Employee';

  app_id         number(16);
  app_name       varchar2(256) := 'Reports';

  pt_id          number(16);
  pt_name        varchar2(256) := 'dashboard';
  
  p_id           number(16);
  p_name         varchar2(256) := 'Access request history';

  counter        number(16);
begin
  select count(1) into counter from entitlement where lower ( name ) = lower ( br_name ) and administrative = 1;
  if ( counter = 0 ) then
    return;
  end if;
  select id into br_id from entitlement where lower ( name ) = lower ( br_name ) and administrative = 1;

  select count(1) into counter from application where lower ( name ) = lower ( app_name ) and administrative = 1;
  if ( counter = 0 ) then
    return;
  end if;
  select id into app_id from application where lower ( name ) = lower ( app_name ) and administrative = 1;

  select count(1) into counter from profile_type where lower ( name ) = lower ( pt_name ) and application = app_id;
  if ( counter = 0 ) then
    return;
  end if;
  select id into pt_id from profile_type where lower ( name ) = lower ( pt_name ) and application = app_id;

  select count(1) into counter from entitlement where lower ( name ) = lower ( p_name ) and application = app_id and profile_type = pt_id and administrative = 1;
  if ( counter = 0 ) then
    return;
  end if;
  select id into p_id from entitlement where lower ( name ) = lower ( p_name ) and application = app_id and profile_type = pt_id and administrative = 1;

  select count(1) into counter from entitlement_hier t where t.parent = br_id and t.child = p_id;
  if ( counter = 0 ) then
    return;
  end if;

  insert into tmp_codoperation ( code ) values ( 'UNASSIGN DASHBOARD' );
  delete from entitlement_hier t where t.parent = br_id and t.child = p_id;
end;
/
commit;

declare
  br_id          number(16);
  br_name        varchar2(256) := 'Employee';

  app_id         number(16);
  app_name       varchar2(256) := 'Reports';

  pt_id          number(16);
  pt_name        varchar2(256) := 'dashboard';
  
  p_id           number(16);
  p_name         varchar2(256) := 'My requests';

  counter        number(16);
begin
  select count(1) into counter from entitlement where lower ( name ) = lower ( br_name ) and administrative = 1;
  if ( counter = 0 ) then
    return;
  end if;
  select id into br_id from entitlement where lower ( name ) = lower ( br_name ) and administrative = 1;

  select count(1) into counter from application where lower ( name ) = lower ( app_name ) and administrative = 1;
  if ( counter = 0 ) then
    return;
  end if;
  select id into app_id from application where lower ( name ) = lower ( app_name ) and administrative = 1;

  select count(1) into counter from profile_type where lower ( name ) = lower ( pt_name ) and application = app_id;
  if ( counter = 0 ) then
    return;
  end if;
  select id into pt_id from profile_type where lower ( name ) = lower ( pt_name ) and application = app_id;

  select count(1) into counter from entitlement where lower ( name ) = lower ( p_name ) and application = app_id and profile_type = pt_id and administrative = 1;
  if ( counter = 0 ) then
    return;
  end if;
  select id into p_id from entitlement where lower ( name ) = lower ( p_name ) and application = app_id and profile_type = pt_id and administrative = 1;

  select count(1) into counter from entitlement_hier t where t.parent = br_id and t.child = p_id;
  if ( counter = 0 ) then
    return;
  end if;

  insert into tmp_codoperation ( code ) values ( 'UNASSIGN DASHBOARD' );
  delete from entitlement_hier t where t.parent = br_id and t.child = p_id;
end;
/
commit;

declare
  br_id          number(16);
  br_name        varchar2(256) := 'User Manager';

  app_id         number(16);
  app_name       varchar2(256) := 'Reports';

  pt_id          number(16);
  pt_name        varchar2(256) := 'dashboard';
  
  p_id           number(16);
  p_name         varchar2(256) := 'Accounts expiring in next x days with OU visibility count';

  counter        number(16);
begin
  select count(1) into counter from entitlement where lower ( name ) = lower ( br_name ) and administrative = 1;
  if ( counter = 0 ) then
    return;
  end if;
  select id into br_id from entitlement where lower ( name ) = lower ( br_name ) and administrative = 1;

  select count(1) into counter from application where lower ( name ) = lower ( app_name ) and administrative = 1;
  if ( counter = 0 ) then
    return;
  end if;
  select id into app_id from application where lower ( name ) = lower ( app_name ) and administrative = 1;

  select count(1) into counter from profile_type where lower ( name ) = lower ( pt_name ) and application = app_id;
  if ( counter = 0 ) then
    return;
  end if;
  select id into pt_id from profile_type where lower ( name ) = lower ( pt_name ) and application = app_id;

  select count(1) into counter from entitlement where lower ( name ) = lower ( p_name ) and application = app_id and profile_type = pt_id and administrative = 1;
  if ( counter = 0 ) then
    return;
  end if;
  select id into p_id from entitlement where lower ( name ) = lower ( p_name ) and application = app_id and profile_type = pt_id and administrative = 1;

  select count(1) into counter from entitlement_hier t where t.parent = br_id and t.child = p_id;
  if ( counter = 0 ) then
    return;
  end if;

  insert into tmp_codoperation ( code ) values ( 'UNASSIGN DASHBOARD' );
  delete from entitlement_hier t where t.parent = br_id and t.child = p_id;
end;
/
commit;

