alter table arm_i18n_message drop constraint arm_i18n_message_loc_code_fk;
alter table mn_role_mapping drop constraint mn_role_map_localiz_code_fk;
alter table mn_tree drop constraint mn_tree_localiz_code_fk;

alter table localization_code drop primary key;

rename localization_code to arm_localization_code;

ALTER TABLE ARM_LOCALIZATION_CODE ADD
  CONSTRAINT ARM_LOCALIZATION_CODE_PK
 PRIMARY KEY (ID);
CALL SYSPROC.ADMIN_CMD ( 'REORG TABLE ARM_LOCALIZATION_CODE' );


ALTER TABLE ARM_I18N_MESSAGE ADD
  CONSTRAINT ARM_I18N_MESSAGE_LOC_CODE_FK
 FOREIGN KEY (LOCALIZATION_CODE)
 REFERENCES ARM_LOCALIZATION_CODE (ID)
    ON DELETE CASCADE;

ALTER TABLE MN_ROLE_MAPPING ADD
  CONSTRAINT MN_ROLE_MAP_LOCALIZ_CODE_FK
 FOREIGN KEY (LOCALIZATION_CODE)
 REFERENCES ARM_LOCALIZATION_CODE (ID)
    ON DELETE SET NULL;

ALTER TABLE MN_TREE ADD
  CONSTRAINT MN_TREE_LOCALIZ_CODE_FK
 FOREIGN KEY (LOCALIZATION_CODE)
 REFERENCES ARM_LOCALIZATION_CODE (ID)
    ON DELETE SET NULL;

CALL SYSPROC.ADMIN_CMD( 'REORG TABLE ARM_LOCALIZATION_CODE' );

drop sequence localization_code_seq;

CREATE SEQUENCE ARM_LOCALIZATION_CODE_SEQ
  AS NUMERIC(18)
  START WITH 100
  INCREMENT BY 1
  MINVALUE 100
  MAXVALUE 999999999999999999
  NO CACHE
  NO CYCLE
  NO ORDER;

grant usage on sequence ARM_LOCALIZATION_CODE_SEQ to &AA_SUPER_ADMIN_USER;
grant usage, alter on sequence ARM_LOCALIZATION_CODE_SEQ to &IDEAS_SUPER_ADMIN_USER;
grant usage on sequence ARM_LOCALIZATION_CODE_SEQ to &IDEAS_REPORT_SUPER_ADMIN_USER;
