--RENAME A TABLE
set verify off
set serveroutput on
declare
  curr_user         varchar2(30);
  
  tab_name_src      varchar2(30) := 'LOCALIZATION_CODE';
  tab_name_dest     varchar2(30) := 'ARM_LOCALIZATION_CODE';
  dml_def           varchar2(4000);
  
  counter           number(16);
begin
  select trim ( user ) into curr_user from dual;
  select count(1) into counter from all_tables t where t.owner = curr_user and t.table_name = tab_name_dest;
  if ( counter = 1 ) then
    return;
  end if;

  dml_def :=
'alter table arm_i18n_message drop constraint arm_i18n_message_loc_code_fk
';

  if ( '&ECHO' = 'ON' ) then
    dbms_output.put_line ( dml_def );
  end if;
  execute immediate ( dml_def );

  dml_def :=
'alter table mn_role_mapping drop constraint mn_role_map_localiz_code_fk
';

  if ( '&ECHO' = 'ON' ) then
    dbms_output.put_line ( dml_def );
  end if;
  execute immediate ( dml_def );

  dml_def :=
'alter table mn_tree drop constraint mn_tree_localiz_code_fk
';

  if ( '&ECHO' = 'ON' ) then
    dbms_output.put_line ( dml_def );
  end if;
  execute immediate ( dml_def );

  dml_def :=
'alter table localization_code drop constraint localization_code_pk cascade drop index
';

  if ( '&ECHO' = 'ON' ) then
    dbms_output.put_line ( dml_def );
  end if;
  execute immediate ( dml_def );

  dml_def :=
'rename localization_code to arm_localization_code
';

  if ( '&ECHO' = 'ON' ) then
    dbms_output.put_line ( dml_def );
  end if;
  execute immediate ( dml_def );

  dml_def :=
'alter table ARM_LOCALIZATION_CODE
  add constraint ARM_LOCALIZATION_CODE_PK primary key (ID)
  using index 
  tablespace IGA_CORE_DATA compute statistics
';

  if ( '&ECHO' = 'ON' ) then
    dbms_output.put_line ( dml_def );
  end if;
  execute immediate ( dml_def );

  dml_def :=
'ALTER TABLE ARM_I18N_MESSAGE ADD (
  CONSTRAINT ARM_I18N_MESSAGE_LOC_CODE_FK
 FOREIGN KEY (LOCALIZATION_CODE)
 REFERENCES ARM_LOCALIZATION_CODE (ID)
    ON DELETE CASCADE)
';

  if ( '&ECHO' = 'ON' ) then
    dbms_output.put_line ( dml_def );
  end if;
  execute immediate ( dml_def );

  dml_def :=
'ALTER TABLE MN_ROLE_MAPPING ADD (
  CONSTRAINT MN_ROLE_MAP_LOCALIZ_CODE_FK
 FOREIGN KEY (LOCALIZATION_CODE)
 REFERENCES ARM_LOCALIZATION_CODE (ID)
    ON DELETE SET NULL)
';

  if ( '&ECHO' = 'ON' ) then
    dbms_output.put_line ( dml_def );
  end if;
  execute immediate ( dml_def );

  dml_def :=
'ALTER TABLE MN_TREE ADD (
  CONSTRAINT MN_TREE_LOCALIZ_CODE_FK
 FOREIGN KEY (LOCALIZATION_CODE)
 REFERENCES ARM_LOCALIZATION_CODE (ID)
    ON DELETE SET NULL)
';

  if ( '&ECHO' = 'ON' ) then
    dbms_output.put_line ( dml_def );
  end if;
  execute immediate ( dml_def );

end;
/
set serveroutput off
set verify on


----RENAME A SEQUENCE
set verify off
set serveroutput on
declare
  curr_user         varchar2(30);
  
  seq_name_src      varchar2(30) := 'LOCALIZATION_CODE_SEQ';
  seq_name_dest     varchar2(30) := 'ARM_LOCALIZATION_CODE_SEQ';
  dml_def           varchar2(4000);
  
  counter           number(16);
begin
  select trim ( user ) into curr_user from dual;
  select count(1) into counter from all_sequences t where t.sequence_owner = curr_user and t.sequence_name = seq_name_dest;
  if ( counter = 1 ) then
    return;
  end if;

  dml_def :=
'rename localization_code_seq to arm_localization_code_seq
';

  if ( '&ECHO' = 'ON' ) then
    dbms_output.put_line ( dml_def );
  end if;
  execute immediate ( dml_def );

end;
/
set serveroutput off
set verify on
