declare
  cur_lan       sys_refcursor;
  lan_id        numeric(16);
  im_id         numeric(16);
  lan_status    numeric(16);
  lan_status_id numeric(16);

  counter       numeric(16);
begin
  open cur_lan for
    select lan.language, im.id as ideas_module, lan.status from ideas_module im,
    (
      select l.id as language, ll.status, 'ARM' as im_code from language l, arm_language ll
      where ll.status > 0 and lower ( l.code ) = lower ( ll.name )
      union
      select l.id as language, ll.status as status, 'ARM' as im_code from language l,
      (
        select 'ZH' as code, 'CN' as country, t.status as status from arm_language t
        where lower ( t.name ) = lower ( '01' ) and t.status > 0
      ) ll where lower ( l.code ) = lower ( ll.code ) and lower ( l.country ) = lower ( ll.country )
     ) lan where lower ( im.code ) = lower ( lan.im_code )
  ;
  loop
    fetch cur_lan into lan_id, im_id, lan_status;
    exit when cur_lan%NOTFOUND;
    
    select count(1) into counter from language_status t where t.language = lan_id and t.ideas_module = im_id;
    if ( counter = 0 ) then
      insert into language_status ( id, language, ideas_module, status )
      values ( language_status_seq.nextval, lan_id, im_id, lan_status );
    else
      select id into lan_status_id from language_status t where t.language = lan_id and t.ideas_module = im_id;
      update language_status set status = lan_status where id = lan_status_id;
    end if;
  end loop;
  close cur_lan;
end;
/
commit;
