--ADD A COLUMN TO A TABLE
set verify off
set serveroutput on
declare
  curr_user         varchar(30);
  
  tab_name          varchar(30) := 'CFG_ACTIVITY';
  tab_col_name      varchar(30) := 'PRODUCT';
  dml_def           varchar(4000);
  
  counter           numeric(16);
begin
  select trim ( user ) into curr_user from dual;
  select count(1) into counter from syscat.columns t where t.tabschema = curr_user and lower ( t.tabname ) = lower ( tab_name ) and lower ( t.colname ) = lower ( tab_col_name );
  if ( counter = 1 ) then
    return;
  end if;

  dml_def :=
'alter table CFG_ACTIVITY add PRODUCT NUMERIC(1) default 0
';

  if ( '&ECHO' = 'ON' ) then
    dbms_output.put_line ( dml_def );
  end if;
  execute immediate ( dml_def );

end;
/
set serveroutput off
set verify on

comment on column CFG_ACTIVITY.PRODUCT
  is '1=true; 0=false';

--REORGANIZE A TABLE
set verify off
set serveroutput on
declare
  curr_user         varchar(30);
  
  tab_name          varchar(30) := 'CFG_ACTIVITY';
  dml_def           varchar(4000);
  
  counter           numeric(16);
begin
  select trim ( user ) into curr_user from dual;
  select count(1) into counter from sysibm.tables t where ( t.table_type = 'BASE TABLE' or t.table_type is null ) and lower ( t.table_schema ) = lower ( curr_user ) and t.table_name = tab_name;
  if ( counter = 0 ) then
    return;
  end if;

  dml_def :=
'CALL SYSPROC.ADMIN_CMD( ''REORG TABLE CFG_ACTIVITY'' )
';

  if ( '&ECHO' = 'ON' ) then
    dbms_output.put_line ( dml_def );
  end if;
  execute immediate ( dml_def );

end;
/
commit;
set serveroutput off
set verify on

declare
  counter     numeric(16);
begin
  select count(1) into counter from cfg_activity where activity_name in (
    'Account Change Request', 'Admin Access Request', 'Auth Request', 'Authorize Account Change Request',
    'Authorize Admin Access Request', 'Authorize Delegation Access', 'Authorize Escalation', 'Create Request',
    'Delegation Request', 'Exec Account Change Request', 'Exec Delegation Request', 'Exec Request',
    'Execute Admin Access Request', 'My Requests', 'Request by Application', 'Request Report', 'Self Create Request'
    ) and product = 0;
  if ( counter > 0 ) then
    update cfg_activity set product = 1
    where activity_name in (
    'Account Change Request', 'Admin Access Request', 'Auth Request', 'Authorize Account Change Request',
    'Authorize Admin Access Request', 'Authorize Delegation Access', 'Authorize Escalation', 'Create Request',
    'Delegation Request', 'Exec Account Change Request', 'Exec Delegation Request', 'Exec Request',
    'Execute Admin Access Request', 'My Requests', 'Request by Application', 'Request Report', 'Self Create Request'
    );
  end if;
end;
/
commit;
