--ADD A COLUMN TO A TABLE
set verify off
set serveroutput on
declare
  curr_user         varchar2(30);
  
  tab_name          varchar2(30) := 'CFG_ACTIVITY';
  tab_col_name      varchar2(30) := 'PRODUCT';
  dml_def           varchar2(4000);
  
  counter           number(16);
begin
  select trim ( user ) into curr_user from dual;
  select count(1) into counter from all_tab_columns t where t.owner = curr_user and t.table_name = tab_name and t.column_name = tab_col_name;
  if ( counter = 1 ) then
    return;
  end if;

  dml_def :=
'alter table CFG_ACTIVITY add PRODUCT NUMBER(1) default 0
';

  if ( '&ECHO' = 'ON' ) then
    dbms_output.put_line ( dml_def );
  end if;
  execute immediate ( dml_def );

end;
/
set serveroutput off
set verify on

comment on column CFG_ACTIVITY.PRODUCT
  is '1=true; 0=false';

declare
  counter     number(16);
begin
  select count(1) into counter from cfg_activity where activity_name in (
    'Account Change Request', 'Admin Access Request', 'Auth Request', 'Authorize Account Change Request',
    'Authorize Admin Access Request', 'Authorize Delegation Access', 'Authorize Escalation', 'Create Request',
    'Delegation Request', 'Exec Account Change Request', 'Exec Delegation Request', 'Exec Request',
    'Execute Admin Access Request', 'My Requests', 'Request by Application', 'Request Report', 'Self Create Request'
    ) and product = 0;
  if ( counter > 0 ) then
    update cfg_activity set product = 1
    where activity_name in (
    'Account Change Request', 'Admin Access Request', 'Auth Request', 'Authorize Account Change Request',
    'Authorize Admin Access Request', 'Authorize Delegation Access', 'Authorize Escalation', 'Create Request',
    'Delegation Request', 'Exec Account Change Request', 'Exec Delegation Request', 'Exec Request',
    'Execute Admin Access Request', 'My Requests', 'Request by Application', 'Request Report', 'Self Create Request'
    );
  end if;
end;
/
commit;
