--ADD A COLUMN TO A TABLE
set verify off
set serveroutput on
declare
  curr_user         varchar2(30);
  
  tab_name          varchar2(30) := 'CFG_PROCESS';
  tab_col_name      varchar2(30) := 'PRODUCT';
  dml_def           varchar2(4000);
  
  counter           number(16);
begin
  select trim ( user ) into curr_user from dual;
  select count(1) into counter from all_tab_columns t where t.owner = curr_user and t.table_name = tab_name and t.column_name = tab_col_name;
  if ( counter = 1 ) then
    return;
  end if;

  dml_def :=
'alter table CFG_PROCESS add PRODUCT NUMBER(1) default 0
';

  if ( '&ECHO' = 'ON' ) then
    dbms_output.put_line ( dml_def );
  end if;
  execute immediate ( dml_def );

end;
/
set serveroutput off
set verify on

comment on column CFG_PROCESS.PRODUCT
  is '1=true; 0=false';

declare
  counter     number(16);
begin
  select count(1) into counter from cfg_process where name in (
    'Access_Request', 'Account_Change', 'Admin_Access_Request', 'Authorize_Escalation', 'Delegation_Request',
    'Personal_Access_Request', 'Report_Request', 'Report_Request_by_Application', 'Report_Request_For_Me'
    ) and product = 0;
  if ( counter > 0 ) then
    update cfg_process set product = 1
    where name in (
    'Access_Request', 'Account_Change', 'Admin_Access_Request', 'Authorize_Escalation', 'Delegation_Request',
    'Personal_Access_Request', 'Report_Request', 'Report_Request_by_Application', 'Report_Request_For_Me'
    );
  end if;
end;
/
commit;
