--ADD A COLUMN TO A TABLE
set verify off
set serveroutput on
declare
  curr_user         varchar(30);
  
  tab_name          varchar(30) := 'CFG_PROCESS';
  tab_col_name      varchar(30) := 'PRODUCT';
  dml_def           varchar(4000);
  
  counter           numeric(16);
begin
  select trim ( user ) into curr_user from dual;
  select count(1) into counter from syscat.columns t where t.tabschema = curr_user and lower ( t.tabname ) = lower ( tab_name ) and lower ( t.colname ) = lower ( tab_col_name );
  if ( counter = 1 ) then
    return;
  end if;

  dml_def :=
'alter table CFG_PROCESS add PRODUCT NUMERIC(1) default 0
';

  if ( '&ECHO' = 'ON' ) then
    dbms_output.put_line ( dml_def );
  end if;
  execute immediate ( dml_def );

end;
/
set serveroutput off
set verify on

comment on column CFG_PROCESS.PRODUCT
  is '1=true; 0=false';

--REORGANIZE A TABLE
set verify off
set serveroutput on
declare
  curr_user         varchar(30);
  
  tab_name          varchar(30) := 'CFG_PROCESS';
  dml_def           varchar(4000);
  
  counter           numeric(16);
begin
  select trim ( user ) into curr_user from dual;
  select count(1) into counter from sysibm.tables t where ( t.table_type = 'BASE TABLE' or t.table_type is null ) and lower ( t.table_schema ) = lower ( curr_user ) and t.table_name = tab_name;
  if ( counter = 0 ) then
    return;
  end if;

  dml_def :=
'CALL SYSPROC.ADMIN_CMD( ''REORG TABLE CFG_PROCESS'' )
';

  if ( '&ECHO' = 'ON' ) then
    dbms_output.put_line ( dml_def );
  end if;
  execute immediate ( dml_def );

end;
/
commit;
set serveroutput off
set verify on

declare
  counter     numeric(16);
begin
  select count(1) into counter from cfg_process where name in (
    'Access_Request', 'Account_Change', 'Admin_Access_Request', 'Authorize_Escalation', 'Delegation_Request',
    'Personal_Access_Request', 'Report_Request', 'Report_Request_by_Application', 'Report_Request_For_Me'
    ) and product = 0;
  if ( counter > 0 ) then
    update cfg_process set product = 1
    where name in (
    'Access_Request', 'Account_Change', 'Admin_Access_Request', 'Authorize_Escalation', 'Delegation_Request',
    'Personal_Access_Request', 'Report_Request', 'Report_Request_by_Application', 'Report_Request_For_Me'
    );
  end if;
end;
/
commit;
