declare
  act_id             numeric(16);
  act_funct          varchar(256) := 'ACCOUNT_CHANGE_GEN';
  act_act_name       varchar(256) := 'ForgotPasswordGEN';
  act_desc           varchar(256) := '';
  act_userscope      numeric(16) := 1;
  act_appscope       numeric(16) := 1;
  act_appfil         varchar(256) := '';
  act_owner          numeric(16)  := 0;
  act_wfstatus       varchar(256) := 'GEN';
  act_type           numeric(16) := 1;
  act_modality       varchar(256) := 'GEN';
  act_repscope       numeric(16);
  act_resscope       numeric(16);
  act_rescospe_fil   varchar(256) := '';
  act_status         numeric(16) := 0;
  act_to_sync        numeric(16) := 0;
  act_entscope       numeric(16);
  act_entcospe_fil   varchar(256) := '';
  act_product        numeric(16) := 1;

  act_rd_id          numeric(16);
  act_rd_key         varchar(256);
  act_rd_value       varchar(256);
  act_rd_type        numeric(16);

  act_rd_key_01      varchar(256) := 'AccountOperation';
  act_rd_value_01    varchar(256) := 'ChangePassword';
  act_rd_type_01     numeric(16) := 1;

  act_rd_key_02      varchar(256) := 'ChangePwdMode';
  act_rd_value_02    varchar(256) := 'PwdByApplicant';
  act_rd_type_02     numeric(16) := 1;

  act_rd_key_03      varchar(256) := 'LockType';
  act_rd_value_03    varchar(256) := 'Auth.Suspend';
  act_rd_type_03     numeric(16) := 2;

  act_rd_key_04      varchar(256) := 'LockType';
  act_rd_value_04    varchar(256) := 'Expired';
  act_rd_type_04     numeric(16) := 2;

  act_rd_key_05      varchar(256) := 'LockType';
  act_rd_value_05    varchar(256) := 'Maint.Suspend';
  act_rd_type_05     numeric(16) := 2;

  act_rd_key_06      varchar(256) := 'LockType';
  act_rd_value_06    varchar(256) := 'Sec.Suspend';
  act_rd_type_06     numeric(16) := 2;

  act_rd_key_07      varchar(256) := 'LockType';
  act_rd_value_07    varchar(256) := 'Tech.Suspend';
  act_rd_type_07     numeric(16) := 2;

  act_rd_key_08      varchar(256) := 'LockType';
  act_rd_value_08    varchar(256) := 'Terminated';
  act_rd_type_08     numeric(16) := 2;

  act_rd_key_09      varchar(256) := 'PwdEmailConfig';
  act_rd_value_09    varchar(256) := 'DoNotEmail';
  act_rd_type_09     numeric(16) := 1;

  act_rd_key_10      varchar(256) := 'ShowPwd';
  act_rd_value_10    varchar(256) := 'false';
  act_rd_type_10     numeric(16) := 1;

  act_rd_key_11      varchar(256) := 'UserIdentification';
  act_rd_value_11    varchar(256) := 'NoId';
  act_rd_type_11     numeric(16) := 1;

  counter            numeric(16);
begin
  select count(1) into counter from application where lower ( name ) = lower ( 'AccessGovernanceCore' );
  if ( counter = 1 ) then
    return;
  end if;

  select count(1) into counter from cfg_activity t where lower ( t.activity_name ) = lower ( act_act_name );
  if ( counter = 0 ) then
    select cfg_activity_seq.nextval into act_id from dual;
    act_wfstatus := act_wfstatus || act_id;

    insert into cfg_activity
      ( id, functionality, activity_name, description, userscope, appscope, apps_filter, ownership, wf_status,
        activity_type, modality, representedscope, resourcescope, resourcescope_filter, activity_status,
        to_sinchronize, entitlementscope, entitlement_filter, product )
    values
      ( act_id, act_funct, act_act_name, act_desc, act_userscope, act_appscope, act_appfil, act_owner, act_wfstatus,
        act_type, act_modality, act_repscope, act_resscope, act_rescospe_fil, act_status,
        act_to_sync, act_entscope, act_entcospe_fil, act_product );
  else
    select t.id into act_id from cfg_activity t where lower ( t.activity_name ) = lower ( act_act_name );
    act_wfstatus := act_wfstatus || act_id;

    update cfg_activity set
      functionality = act_funct, description = act_desc, userscope = act_userscope, appscope = act_appscope, apps_filter = act_appfil,
      ownership = act_owner, wf_status = act_wfstatus, activity_type = act_type, modality = act_modality, representedscope = act_repscope,
      resourcescope = act_resscope, resourcescope_filter = act_rescospe_fil, activity_status = act_status, to_sinchronize = act_to_sync,
      entitlementscope = act_entscope, entitlement_filter = act_entcospe_fil, product = act_product
    where id = act_id;
  end if;
  
  --CFG_ACTIVITY_REQUIREDDATA 01
  act_rd_key   := act_rd_key_01;
  act_rd_value := act_rd_value_01;
  act_rd_type  := act_rd_type_01;

  select count(1) into counter from cfg_activity_requireddata t
  where t.activity_id = act_id and lower ( t.required_key ) = lower ( act_rd_key ) and lower ( t.required_value ) = lower ( act_rd_value );
  if ( counter = 0 ) then
    insert into cfg_activity_requireddata ( activity_id, required_key, required_value, required_type )
    values ( act_id, act_rd_key, act_rd_value, act_rd_type );
  end if;

  --CFG_ACTIVITY_REQUIREDDATA 02
  act_rd_key   := act_rd_key_02;
  act_rd_value := act_rd_value_02;
  act_rd_type  := act_rd_type_02;

  select count(1) into counter from cfg_activity_requireddata t
  where t.activity_id = act_id and lower ( t.required_key ) = lower ( act_rd_key ) and lower ( t.required_value ) = lower ( act_rd_value );
  if ( counter = 0 ) then
    insert into cfg_activity_requireddata ( activity_id, required_key, required_value, required_type )
    values ( act_id, act_rd_key, act_rd_value, act_rd_type );
  end if;

  --CFG_ACTIVITY_REQUIREDDATA 03
  act_rd_key   := act_rd_key_03;
  act_rd_value := act_rd_value_03;
  act_rd_type  := act_rd_type_03;

  select count(1) into counter from cfg_activity_requireddata t
  where t.activity_id = act_id and lower ( t.required_key ) = lower ( act_rd_key ) and lower ( t.required_value ) = lower ( act_rd_value );
  if ( counter = 0 ) then
    insert into cfg_activity_requireddata ( activity_id, required_key, required_value, required_type )
    values ( act_id, act_rd_key, act_rd_value, act_rd_type );
  end if;

  --CFG_ACTIVITY_REQUIREDDATA 04
  act_rd_key   := act_rd_key_04;
  act_rd_value := act_rd_value_04;
  act_rd_type  := act_rd_type_04;

  select count(1) into counter from cfg_activity_requireddata t
  where t.activity_id = act_id and lower ( t.required_key ) = lower ( act_rd_key ) and lower ( t.required_value ) = lower ( act_rd_value );
  if ( counter = 0 ) then
    insert into cfg_activity_requireddata ( activity_id, required_key, required_value, required_type )
    values ( act_id, act_rd_key, act_rd_value, act_rd_type );
  end if;

  --CFG_ACTIVITY_REQUIREDDATA 05
  act_rd_key   := act_rd_key_05;
  act_rd_value := act_rd_value_05;
  act_rd_type  := act_rd_type_05;

  select count(1) into counter from cfg_activity_requireddata t
  where t.activity_id = act_id and lower ( t.required_key ) = lower ( act_rd_key ) and lower ( t.required_value ) = lower ( act_rd_value );
  if ( counter = 0 ) then
    insert into cfg_activity_requireddata ( activity_id, required_key, required_value, required_type )
    values ( act_id, act_rd_key, act_rd_value, act_rd_type );
  end if;

  --CFG_ACTIVITY_REQUIREDDATA 06
  act_rd_key   := act_rd_key_06;
  act_rd_value := act_rd_value_06;
  act_rd_type  := act_rd_type_06;

  select count(1) into counter from cfg_activity_requireddata t
  where t.activity_id = act_id and lower ( t.required_key ) = lower ( act_rd_key ) and lower ( t.required_value ) = lower ( act_rd_value );
  if ( counter = 0 ) then
    insert into cfg_activity_requireddata ( activity_id, required_key, required_value, required_type )
    values ( act_id, act_rd_key, act_rd_value, act_rd_type );
  end if;

  --CFG_ACTIVITY_REQUIREDDATA 07
  act_rd_key   := act_rd_key_07;
  act_rd_value := act_rd_value_07;
  act_rd_type  := act_rd_type_07;

  select count(1) into counter from cfg_activity_requireddata t
  where t.activity_id = act_id and lower ( t.required_key ) = lower ( act_rd_key ) and lower ( t.required_value ) = lower ( act_rd_value );
  if ( counter = 0 ) then
    insert into cfg_activity_requireddata ( activity_id, required_key, required_value, required_type )
    values ( act_id, act_rd_key, act_rd_value, act_rd_type );
  end if;

  --CFG_ACTIVITY_REQUIREDDATA 08
  act_rd_key   := act_rd_key_08;
  act_rd_value := act_rd_value_08;
  act_rd_type  := act_rd_type_08;

  select count(1) into counter from cfg_activity_requireddata t
  where t.activity_id = act_id and lower ( t.required_key ) = lower ( act_rd_key ) and lower ( t.required_value ) = lower ( act_rd_value );
  if ( counter = 0 ) then
    insert into cfg_activity_requireddata ( activity_id, required_key, required_value, required_type )
    values ( act_id, act_rd_key, act_rd_value, act_rd_type );
  end if;

  --CFG_ACTIVITY_REQUIREDDATA 09
  act_rd_key   := act_rd_key_09;
  act_rd_value := act_rd_value_09;
  act_rd_type  := act_rd_type_09;

  select count(1) into counter from cfg_activity_requireddata t
  where t.activity_id = act_id and lower ( t.required_key ) = lower ( act_rd_key ) and lower ( t.required_value ) = lower ( act_rd_value );
  if ( counter = 0 ) then
    insert into cfg_activity_requireddata ( activity_id, required_key, required_value, required_type )
    values ( act_id, act_rd_key, act_rd_value, act_rd_type );
  end if;

  --CFG_ACTIVITY_REQUIREDDATA 10
  act_rd_key   := act_rd_key_10;
  act_rd_value := act_rd_value_10;
  act_rd_type  := act_rd_type_10;

  select count(1) into counter from cfg_activity_requireddata t
  where t.activity_id = act_id and lower ( t.required_key ) = lower ( act_rd_key ) and lower ( t.required_value ) = lower ( act_rd_value );
  if ( counter = 0 ) then
    insert into cfg_activity_requireddata ( activity_id, required_key, required_value, required_type )
    values ( act_id, act_rd_key, act_rd_value, act_rd_type );
  end if;

  --CFG_ACTIVITY_REQUIREDDATA 11
  act_rd_key   := act_rd_key_11;
  act_rd_value := act_rd_value_11;
  act_rd_type  := act_rd_type_11;

  select count(1) into counter from cfg_activity_requireddata t
  where t.activity_id = act_id and lower ( t.required_key ) = lower ( act_rd_key ) and lower ( t.required_value ) = lower ( act_rd_value );
  if ( counter = 0 ) then
    insert into cfg_activity_requireddata ( activity_id, required_key, required_value, required_type )
    values ( act_id, act_rd_key, act_rd_value, act_rd_type );
  end if;

end;
/
commit;
