set define off
declare
  pa_id             numeric(16);
  pa_prc_name       varchar(256) := 'ForgotPassword';
  pa_prc_escal_name varchar(256) := '';
  pa_prc_link_name  varchar(256) := '';
  pa_act_name       varchar(256) := 'ForgotPasswordEXE';
  pa_act_next_name  varchar(256) := '';
  pa_act_escal_name varchar(256) := '';
  pa_act_link_name  varchar(256) := '';
  pa_permission     varchar(256) := 'EXE/ForgotPasswordEXE$ForgotPassword';
  pa_authmode       numeric(16) := 0;
  pa_counter        numeric(16) := 2;
  pa_status         numeric(16) := 1;
  pa_approver       numeric(16);
  pa_req_approver   numeric(16) := 0;

  pa_prc_id         numeric(16);
  pa_prc_escal_id   numeric(16);
  pa_prc_link_id    numeric(16);
  pa_act_id         numeric(16);
  pa_act_next_id    numeric(16);
  pa_act_escal_id   numeric(16);
  pa_act_link_id    numeric(16);

  counter            numeric(16);
begin
  select count(1) into counter from cfg_process t where lower ( t.name ) = lower ( pa_prc_name );
  if ( counter = 1 ) then
    select t.id into pa_prc_id from cfg_process t where lower ( t.name ) = lower ( pa_prc_name );
  else
    return;
  end if;

  select count(1) into counter from cfg_activity t where lower ( t.activity_name ) = lower ( pa_act_name );
  if ( counter = 1 ) then
    select t.id into pa_act_id from cfg_activity t where lower ( t.activity_name ) = lower ( pa_act_name );
  else
    return;
  end if;
  
  if ( pa_prc_escal_name is not null or length ( pa_prc_escal_name ) > 0 ) then
    select count(1) into counter from cfg_process t where lower ( t.name ) = lower ( pa_prc_escal_name );
    if ( counter = 1 ) then
      select t.id into pa_prc_escal_id from cfg_process t where lower ( t.name ) = lower ( pa_prc_escal_name );
    end if;
  end if;

  if ( pa_prc_link_name is not null or length ( pa_prc_link_name ) > 0 ) then
    select count(1) into counter from cfg_process t where lower ( t.name ) = lower ( pa_prc_link_name );
    if ( counter = 1 ) then
      select t.id into pa_prc_link_id from cfg_process t where lower ( t.name ) = lower ( pa_prc_link_name );
    end if;
  end if;

  if ( pa_act_next_name is not null or length ( pa_act_next_name ) > 0 ) then
    select count(1) into counter from cfg_activity t where lower ( t.activity_name ) = lower ( pa_act_next_name );
    if ( counter = 1 ) then
      select t.id into pa_act_next_id from cfg_activity t where lower ( t.activity_name ) = lower ( pa_act_next_name );
    end if;
  end if;
  
  if ( pa_act_escal_name is not null or length ( pa_act_escal_name ) > 0 ) then
    select count(1) into counter from cfg_activity t where lower ( t.activity_name ) = lower ( pa_act_escal_name );
    if ( counter = 1 ) then
      select t.id into pa_act_escal_id from cfg_activity t where lower ( t.activity_name ) = lower ( pa_act_escal_name );
    end if;
  end if;
  
  if ( pa_act_link_name is not null or length ( pa_act_link_name ) > 0 ) then
    select count(1) into counter from cfg_activity t where lower ( t.activity_name ) = lower ( pa_act_link_name );
    if ( counter = 1 ) then
      select t.id into pa_act_link_id from cfg_activity t where lower ( t.activity_name ) = lower ( pa_act_link_name );
    end if;
  end if;
  
  select count(1) into counter from cfg_processactivity pa where pa.process = pa_prc_id and pa.activity = pa_act_id;
  if ( counter = 0 ) then
    select cfg_processactivity_seq.nextval into pa_id from dual;
    insert into cfg_processactivity
      ( id, process, escalation_process, linked_process, activity, next_activity, escalation_activity,
        linked_activity, permission, authmode, counter, status, approver, required_approver )
    values
      ( pa_id, pa_prc_id, pa_prc_escal_id, pa_prc_link_id, pa_act_id, pa_act_next_id, pa_act_escal_id,
        pa_act_link_id, pa_permission, pa_authmode, pa_counter, pa_status, pa_approver, pa_req_approver );
  else
    select pa.id into pa_id from cfg_processactivity pa where pa.process = pa_prc_id and pa.activity = pa_act_id;

    update cfg_processactivity set escalation_process = pa_prc_escal_id, linked_process = pa_prc_link_id,
    next_activity = pa_act_next_id, escalation_activity = pa_act_escal_id, linked_activity = pa_act_link_id,
    permission = pa_permission, authmode = pa_authmode, counter = pa_counter, status = pa_status, /*approver = pa_approver,*/
    required_approver = pa_req_approver where id = pa_id;
  end if;
end;
/
commit;
set define on
