declare
  act_id             number(16);
  act_funct          varchar2(256) := 'UPDATE_USER_EXE';
  act_act_name       varchar2(256) := 'Exe User Modify';
  act_desc           varchar2(256) := '';
  act_userscope      number(16);
  act_appscope       number(16);
  act_appfil         varchar2(256) := '';
  act_owner          number(16)  := 0;
  act_wfstatus       varchar2(256) := 'EXE';
  act_type           number(16) := 1;
  act_modality       varchar2(256) := 'EXE';
  act_repscope       number(16);
  act_resscope       number(16);
  act_rescospe_fil   varchar2(256) := '';
  act_status         number(16) := 0;
  act_to_sync        number(16) := 0;
  act_entscope       number(16);
  act_entcospe_fil   varchar2(256) := '';
  act_product        number(16) := 1;

  counter            number(16);
begin
  select count(1) into counter from application where lower ( name ) = lower ( 'AccessGovernanceCore' );
  if ( counter = 1 ) then
    return;
  end if;

  select count(1) into counter from cfg_activity t where lower ( t.activity_name ) = lower ( act_act_name );
  if ( counter = 0 ) then
    select cfg_activity_seq.nextval into act_id from dual;
    act_wfstatus := act_wfstatus || act_id;

    insert into cfg_activity
      ( id, functionality, activity_name, description, userscope, appscope, apps_filter, ownership, wf_status,
        activity_type, modality, representedscope, resourcescope, resourcescope_filter, activity_status,
        to_sinchronize, entitlementscope, entitlement_filter, product )
    values
      ( act_id, act_funct, act_act_name, act_desc, act_userscope, act_appscope, act_appfil, act_owner, act_wfstatus,
        act_type, act_modality, act_repscope, act_resscope, act_rescospe_fil, act_status,
        act_to_sync, act_entscope, act_entcospe_fil, act_product );
  else
    select t.id into act_id from cfg_activity t where lower ( t.activity_name ) = lower ( act_act_name );
    act_wfstatus := act_wfstatus || act_id;

    update cfg_activity set
      functionality = act_funct, description = act_desc, userscope = act_userscope, appscope = act_appscope, apps_filter = act_appfil,
      ownership = act_owner, wf_status = act_wfstatus, activity_type = act_type, modality = act_modality, representedscope = act_repscope,
      resourcescope = act_resscope, resourcescope_filter = act_rescospe_fil, activity_status = act_status, to_sinchronize = act_to_sync,
      entitlementscope = act_entscope, entitlement_filter = act_entcospe_fil, product = act_product
    where id = act_id;
  end if;

end;
/
commit;
