declare
  act_id             number(16);
  act_funct          varchar2(256) := 'UPDATE_ENTITLEMENT_GEN';
  act_act_name       varchar2(256) := 'Update Entitlement';
  act_desc           varchar2(256) := '';
  act_userscope      number(16);
  act_appscope       number(16) := 1;
  act_appfil         varchar2(256) := '';
  act_owner          number(16)  := 0;
  act_wfstatus       varchar2(256) := 'GEN';
  act_type           number(16) := 1;
  act_modality       varchar2(256) := 'GEN';
  act_repscope       number(16);
  act_resscope       number(16);
  act_rescospe_fil   varchar2(256) := '';
  act_status         number(16) := 0;
  act_to_sync        number(16) := 0;
  act_entscope       number(16) := 1;
  act_entcospe_fil   varchar2(256) := '';
  act_product        number(16) := 1;

  act_rd_id          number(16);
  act_rd_key         varchar2(256);
  act_rd_value       varchar2(256);
  act_rd_type        number(16);

  act_rd_key_01      varchar2(256) := 'EntityDataType';
  act_rd_value_01    varchar2(256) := 'Details';
  act_rd_type_01     number(16) := 2;

  act_rd_key_02      varchar2(256) := 'EntityDataType';
  act_rd_value_02    varchar2(256) := 'Structure';
  act_rd_type_02     number(16) := 2;

  act_rd_key_03      varchar2(256) := 'RoleTypeAssignable';
  act_rd_value_03    varchar2(256) := 'BusinessRole';
  act_rd_type_03     number(16) := 2;

  act_rd_key_04      varchar2(256) := 'RoleTypeAssignable';
  act_rd_value_04    varchar2(256) := 'ExternalPermission';
  act_rd_type_04     number(16) := 2;

  act_rd_key_05      varchar2(256) := 'RoleTypeAssignable';
  act_rd_value_05    varchar2(256) := 'ITRole';
  act_rd_type_05     number(16) := 2;

  act_rd_key_06      varchar2(256) := 'RoleTypeAssignable';
  act_rd_value_06    varchar2(256) := 'Permission';
  act_rd_type_06     number(16) := 2;
  
  act_fes_ent        varchar2(256);
  act_fes_rep        varchar2(256);
  act_fes_field      varchar2(256);
  act_fes_vis        number(16);
  act_fes_mand       number(16);
  act_fes_pos        number(16);

  act_fes_ent_01     varchar2(256) := 'ENTITLEMENT';
  act_fes_rep_01     varchar2(256) := 'NO-REPOSITORY';
  act_fes_field_01   varchar2(256) := 'none';
  act_fes_vis_01     number(16) := 0;
  act_fes_mand_01    number(16) := 0;
  act_fes_pos_01     number(16) := 0;

  counter            number(16);
begin
  select count(1) into counter from application where lower ( name ) = lower ( 'AccessGovernanceCore' );
  if ( counter = 1 ) then
    return;
  end if;

  select count(1) into counter from cfg_activity t where lower ( t.activity_name ) = lower ( act_act_name );
  if ( counter = 0 ) then
    select cfg_activity_seq.nextval into act_id from dual;
    act_wfstatus := act_wfstatus || act_id;

    insert into cfg_activity
      ( id, functionality, activity_name, description, userscope, appscope, apps_filter, ownership, wf_status,
        activity_type, modality, representedscope, resourcescope, resourcescope_filter, activity_status,
        to_sinchronize, entitlementscope, entitlement_filter, product )
    values
      ( act_id, act_funct, act_act_name, act_desc, act_userscope, act_appscope, act_appfil, act_owner, act_wfstatus,
        act_type, act_modality, act_repscope, act_resscope, act_rescospe_fil, act_status,
        act_to_sync, act_entscope, act_entcospe_fil, act_product );
  else
    select t.id into act_id from cfg_activity t where lower ( t.activity_name ) = lower ( act_act_name );
    act_wfstatus := act_wfstatus || act_id;

    update cfg_activity set
      functionality = act_funct, description = act_desc, userscope = act_userscope, appscope = act_appscope, apps_filter = act_appfil,
      ownership = act_owner, wf_status = act_wfstatus, activity_type = act_type, modality = act_modality, representedscope = act_repscope,
      resourcescope = act_resscope, resourcescope_filter = act_rescospe_fil, activity_status = act_status, to_sinchronize = act_to_sync,
      entitlementscope = act_entscope, entitlement_filter = act_entcospe_fil, product = act_product
    where id = act_id;
  end if;
  
  --CFG_ACTIVITY_REQUIREDDATA 01
  act_rd_key   := act_rd_key_01;
  act_rd_value := act_rd_value_01;
  act_rd_type  := act_rd_type_01;

  select count(1) into counter from cfg_activity_requireddata t
  where t.activity_id = act_id and lower ( t.required_key ) = lower ( act_rd_key ) and lower ( t.required_value ) = lower ( act_rd_value );
  if ( counter = 0 ) then
    insert into cfg_activity_requireddata ( activity_id, required_key, required_value, required_type )
    values ( act_id, act_rd_key, act_rd_value, act_rd_type );
  end if;

  --CFG_ACTIVITY_REQUIREDDATA 02
  act_rd_key   := act_rd_key_02;
  act_rd_value := act_rd_value_02;
  act_rd_type  := act_rd_type_02;

  select count(1) into counter from cfg_activity_requireddata t
  where t.activity_id = act_id and lower ( t.required_key ) = lower ( act_rd_key ) and lower ( t.required_value ) = lower ( act_rd_value );
  if ( counter = 0 ) then
    insert into cfg_activity_requireddata ( activity_id, required_key, required_value, required_type )
    values ( act_id, act_rd_key, act_rd_value, act_rd_type );
  end if;

  --CFG_ACTIVITY_REQUIREDDATA 03
  act_rd_key   := act_rd_key_03;
  act_rd_value := act_rd_value_03;
  act_rd_type  := act_rd_type_03;

  select count(1) into counter from cfg_activity_requireddata t
  where t.activity_id = act_id and lower ( t.required_key ) = lower ( act_rd_key ) and lower ( t.required_value ) = lower ( act_rd_value );
  if ( counter = 0 ) then
    insert into cfg_activity_requireddata ( activity_id, required_key, required_value, required_type )
    values ( act_id, act_rd_key, act_rd_value, act_rd_type );
  end if;

  --CFG_ACTIVITY_REQUIREDDATA 04
  act_rd_key   := act_rd_key_04;
  act_rd_value := act_rd_value_04;
  act_rd_type  := act_rd_type_04;

  select count(1) into counter from cfg_activity_requireddata t
  where t.activity_id = act_id and lower ( t.required_key ) = lower ( act_rd_key ) and lower ( t.required_value ) = lower ( act_rd_value );
  if ( counter = 0 ) then
    insert into cfg_activity_requireddata ( activity_id, required_key, required_value, required_type )
    values ( act_id, act_rd_key, act_rd_value, act_rd_type );
  end if;

  --CFG_ACTIVITY_REQUIREDDATA 05
  act_rd_key   := act_rd_key_05;
  act_rd_value := act_rd_value_05;
  act_rd_type  := act_rd_type_05;

  select count(1) into counter from cfg_activity_requireddata t
  where t.activity_id = act_id and lower ( t.required_key ) = lower ( act_rd_key ) and lower ( t.required_value ) = lower ( act_rd_value );
  if ( counter = 0 ) then
    insert into cfg_activity_requireddata ( activity_id, required_key, required_value, required_type )
    values ( act_id, act_rd_key, act_rd_value, act_rd_type );
  end if;

  --CFG_ACTIVITY_REQUIREDDATA 06
  act_rd_key   := act_rd_key_06;
  act_rd_value := act_rd_value_06;
  act_rd_type  := act_rd_type_06;

  select count(1) into counter from cfg_activity_requireddata t
  where t.activity_id = act_id and lower ( t.required_key ) = lower ( act_rd_key ) and lower ( t.required_value ) = lower ( act_rd_value );
  if ( counter = 0 ) then
    insert into cfg_activity_requireddata ( activity_id, required_key, required_value, required_type )
    values ( act_id, act_rd_key, act_rd_value, act_rd_type );
  end if;
  
  --FIXED_ENTITY_SCOPE 01
  act_fes_ent   := act_fes_ent_01;
  act_fes_rep   := act_fes_rep_01;
  act_fes_field := act_fes_field_01;
  act_fes_vis   := act_fes_vis_01;
  act_fes_mand  := act_fes_mand_01;
  act_fes_pos   := act_fes_pos_01;

  select count(1) into counter from fixed_entity_scope t
  where t.cfg_activity = act_id and lower ( t.entity ) = lower ( act_fes_ent ) and lower ( t.field ) = lower ( act_fes_field );
  if ( counter = 0 ) then
    insert into fixed_entity_scope ( cfg_activity, entity, repository, field, visible, mandatory, position )
    values ( act_id, act_fes_ent, act_fes_rep, act_fes_field, act_fes_vis, act_fes_mand, act_fes_pos );
  else
    update fixed_entity_scope set repository = act_fes_rep, visible = act_fes_vis, mandatory = act_fes_mand, position = act_fes_pos
    where cfg_activity = act_id and lower ( entity ) = lower ( act_fes_ent ) and lower ( field ) = lower ( act_fes_field );
  end if;
end;
/
commit;
