declare
  act_id             numeric(16);
  act_funct          varchar(256) := 'INSERT_ENTITLEMENT_GEN';
  act_act_name       varchar(256) := 'Insert Entitlement';
  act_desc           varchar(256) := '';
  act_userscope      numeric(16);
  act_appscope       numeric(16);
  act_appfil         varchar(256) := '';
  act_owner          numeric(16)  := 0;
  act_wfstatus       varchar(256) := 'GEN';
  act_type           numeric(16) := 1;
  act_modality       varchar(256) := 'GEN';
  act_repscope       numeric(16);
  act_resscope       numeric(16);
  act_rescospe_fil   varchar(256) := '';
  act_status         numeric(16) := 0;
  act_to_sync        numeric(16) := 0;
  act_entscope       numeric(16) := 1;
  act_entcospe_fil   varchar(256) := '';
  act_product        numeric(16) := 1;

  act_fes_ent        varchar(256);
  act_fes_rep        varchar(256);
  act_fes_field      varchar(256);
  act_fes_vis        numeric(16);
  act_fes_mand       numeric(16);
  act_fes_pos        numeric(16);

  act_fes_ent_01     varchar(256) := 'ENTITLEMENT';
  act_fes_rep_01     varchar(256) := 'NO-REPOSITORY';
  act_fes_field_01   varchar(256) := 'none';
  act_fes_vis_01     numeric(16) := 0;
  act_fes_mand_01    numeric(16) := 0;
  act_fes_pos_01     numeric(16) := 0;

  counter            numeric(16);
begin
  select count(1) into counter from application where lower ( name ) = lower ( 'AccessGovernanceCore' );
  if ( counter = 1 ) then
    return;
  end if;

  select count(1) into counter from cfg_activity t where lower ( t.activity_name ) = lower ( act_act_name );
  if ( counter = 0 ) then
    select cfg_activity_seq.nextval into act_id from dual;
    act_wfstatus := act_wfstatus || act_id;

    insert into cfg_activity
      ( id, functionality, activity_name, description, userscope, appscope, apps_filter, ownership, wf_status,
        activity_type, modality, representedscope, resourcescope, resourcescope_filter, activity_status,
        to_sinchronize, entitlementscope, entitlement_filter, product )
    values
      ( act_id, act_funct, act_act_name, act_desc, act_userscope, act_appscope, act_appfil, act_owner, act_wfstatus,
        act_type, act_modality, act_repscope, act_resscope, act_rescospe_fil, act_status,
        act_to_sync, act_entscope, act_entcospe_fil, act_product );
  else
    select t.id into act_id from cfg_activity t where lower ( t.activity_name ) = lower ( act_act_name );
    act_wfstatus := act_wfstatus || act_id;

    update cfg_activity set
      functionality = act_funct, description = act_desc, userscope = act_userscope, appscope = act_appscope, apps_filter = act_appfil,
      ownership = act_owner, wf_status = act_wfstatus, activity_type = act_type, modality = act_modality, representedscope = act_repscope,
      resourcescope = act_resscope, resourcescope_filter = act_rescospe_fil, activity_status = act_status, to_sinchronize = act_to_sync,
      entitlementscope = act_entscope, entitlement_filter = act_entcospe_fil, product = act_product
    where id = act_id;
  end if;

  --FIXED_ENTITY_SCOPE 01
  act_fes_ent   := act_fes_ent_01;
  act_fes_rep   := act_fes_rep_01;
  act_fes_field := act_fes_field_01;
  act_fes_vis   := act_fes_vis_01;
  act_fes_mand  := act_fes_mand_01;
  act_fes_pos   := act_fes_pos_01;

  select count(1) into counter from fixed_entity_scope t
  where t.cfg_activity = act_id and lower ( t.entity ) = lower ( act_fes_ent ) and lower ( t.field ) = lower ( act_fes_field );
  if ( counter = 0 ) then
    insert into fixed_entity_scope ( cfg_activity, entity, repository, field, visible, mandatory, position )
    values ( act_id, act_fes_ent, act_fes_rep, act_fes_field, act_fes_vis, act_fes_mand, act_fes_pos );
  else
    update fixed_entity_scope set repository = act_fes_rep, visible = act_fes_vis, mandatory = act_fes_mand, position = act_fes_pos
    where cfg_activity = act_id and lower ( entity ) = lower ( act_fes_ent ) and lower ( field ) = lower ( act_fes_field );
  end if;
end;
/
commit;
