declare
  prc_id             numeric(16);
  prc_name           varchar(256) := 'Update Entitlement';
  prc_desc           varchar(512) := '';
  prc_context        varchar(256) := 'ENTITLEMENT_MANAGEMENT';
  prc_type           numeric(16) := 1;
  prc_status         numeric(16) := 0;
  prc_ext_escal      numeric(16);
  prc_updatable      numeric(16) := 0;
  prc_code           varchar(256) := '';
  prc_product        numeric(16) := 1;

  counter            numeric(16);
begin
  select count(1) into counter from application where lower ( name ) = lower ( 'AccessGovernanceCore' );
  if ( counter = 1 ) then
    return;
  end if;

  select count(1) into counter from cfg_process t where lower ( t.name ) = lower ( prc_name );
  if ( counter = 0 ) then
    select cfg_process_seq.nextval into prc_id from dual;

    insert into cfg_process
      ( id, name, description, functionality_context, process_type, process_status,
        extended_escalation, updatable, code, creation_date, product )
    values
      ( prc_id, prc_name, prc_desc, prc_context, prc_type, prc_status,
        prc_ext_escal, prc_updatable, prc_code, current_date, prc_product );
  else
    select t.id into prc_id from cfg_process t where lower ( t.name ) = lower ( prc_name );

    update cfg_process set
      description = prc_desc, functionality_context = prc_context, process_type = prc_type, /*process_status = prc_status,*/
      extended_escalation = prc_ext_escal, updatable = prc_updatable, code = prc_code, creation_date = current_date, product = prc_product
    where id = prc_id;
  end if;
end;
/
commit;
