declare
  cur_realm       sys_refcursor;
  app_id          number(16);
  app_name        varchar2(256) := 'SELFCARE';
  app_name_old    varchar2(256);
  app_label       varchar2(256) := 'Self Care';
  app_label_old   varchar2(256);
  app_type        number(1) := 3;
  app_prop_id     number(16);
  app_prop_name   varchar2(256);
  app_prop_value  varchar2(256);

  app_prop_name1  varchar2(256) := 'URL';
  app_prop_value1 varchar2(256) := '../ideas/sc';
  
  app_prop_name2  varchar2(256) := 'HELPONLINE';
  app_prop_value2 varchar2(256) := '/ideas/help/CrossIdeasHOL/Default.htm#cshid=CrossIdeas_Topics/SC';
  
  realm_id        number(16);
  cfg_prop_id     number(16);
  cfg_prop_order  number(2);

  counter           number(16);
begin
  select count(1) into counter from cfg_application t where lower ( t.name ) = lower ( app_name );
  if ( counter = 0 ) then
    select max(id) + 1 into app_id from cfg_application;
    insert into cfg_application ( id, name, value, label, type, state )
    values ( app_id, app_name, '', app_label, app_type, 0);
  else
    select t.id, t.name, t.label into app_id, app_name_old, app_label_old from cfg_application t where lower ( t.name ) = lower ( app_name );
    if ( app_name_old <> app_name ) then
      update cfg_application set name = app_name where id = app_id;
    elsif ( app_label_old <> app_label ) then
      update cfg_application set label = app_label where id = app_id;
    end if;
  end if;
  
  --PROP1
  app_prop_name  := app_prop_name1;
  app_prop_value := app_prop_value1;
  select count(1) into counter from cfg_application_prop t where t.cfg_application = app_id and t.name = app_prop_name;
  if ( counter = 0 ) then
    select max(id) + 1 into app_prop_id from cfg_application_prop;
    insert into cfg_application_prop ( id, cfg_application, name, value, state )
    values ( app_prop_id, app_id, app_prop_name, app_prop_value, 0 );
  else
    select id into app_prop_id from cfg_application_prop t where t.cfg_application = app_id and t.name = app_prop_name;

    select count(1) into counter from cfg_application_prop t where t.id = app_prop_id and lower ( t.value ) = lower ( app_prop_value );
    if ( counter = 0 ) then
      update cfg_application_prop set value = app_prop_value where id = app_prop_id;
    end if;
  end if;

  --PROP2
  app_prop_name  := app_prop_name2;
  app_prop_value := app_prop_value2;
  select count(1) into counter from cfg_application_prop t where t.cfg_application = app_id and t.name = app_prop_name;
  if ( counter = 0 ) then
    select max(id) + 1 into app_prop_id from cfg_application_prop;
    insert into cfg_application_prop ( id, cfg_application, name, value, state )
    values ( app_prop_id, app_id, app_prop_name, app_prop_value, 0 );
  else
    select id into app_prop_id from cfg_application_prop t where t.cfg_application = app_id and t.name = app_prop_name;

    select count(1) into counter from cfg_application_prop t where t.id = app_prop_id and lower ( t.value ) = lower ( app_prop_value );
    if ( counter = 0 ) then
      update cfg_application_prop set value = app_prop_value where id = app_prop_id;
    end if;
  end if;

  open cur_realm for select id from realm where is_admin = 0;
  loop
    fetch cur_realm into realm_id;
    exit when cur_realm%NOTFOUND;
    
    select count(1) into counter from cfg_config_prop t where t.realm = realm_id and t.cfg_application = app_id and t.key = 'DESK';
    if ( counter = 0 ) then
      select max ( cast ( value as number ) ) + 1 into cfg_prop_order
      from cfg_config_prop t
      where t.realm = realm_id and t.key = 'DESK'
      and cfg_application in ( select id from cfg_application where type = app_type );
      
      select max(id) + 1 into cfg_prop_id from cfg_config_prop;
      insert into cfg_config_prop ( id, realm, cfg_application, key, name, value, state  )
      values ( cfg_prop_id, realm_id, app_id, 'DESK', 'ORDER', cast ( cfg_prop_order as varchar2(256) ), 0 );
      
    end if;
  end loop;
  close cur_realm;
end;
/
commit;
