rename ems_localization_tmp to ems_localization;

ALTER TABLE EMS_LOCALIZATION ADD
  CONSTRAINT EMS_LOCALIZATION_PK
 PRIMARY KEY (ID);
CALL SYSPROC.ADMIN_CMD ( 'REORG TABLE EMS_LOCALIZATION' );

ALTER TABLE EMS_I18N_MESSAGE ADD
  CONSTRAINT EMS_I18N_LOCALIZATION_FK
 FOREIGN KEY (LOCALIZATION)
 REFERENCES EMS_LOCALIZATION (ID)
    ON DELETE CASCADE;

ALTER TABLE EMS_TEMPLATE ADD
  CONSTRAINT EMS_TEMPLATE_BODY_FK
 FOREIGN KEY (BODY)
 REFERENCES EMS_LOCALIZATION (ID)
    ON DELETE CASCADE;

ALTER TABLE EMS_TEMPLATE ADD
  CONSTRAINT EMS_TEMPLATE_SUBJECT_FK
 FOREIGN KEY (SUBJECT)
 REFERENCES EMS_LOCALIZATION (ID)
    ON DELETE CASCADE;

create unique index EMS_LOCALIZATION_LNAME_IDX on EMS_LOCALIZATION (LOWER(CODE))
;

CREATE SEQUENCE EMS_LOCALIZATION_SEQ
  AS NUMERIC(18)
  START WITH 100
  INCREMENT BY 1
  MINVALUE 100
  MAXVALUE 999999999999999999
  NO CACHE
  NO CYCLE
  NO ORDER;

grant usage on sequence EMS_LOCALIZATION_SEQ to &AA_SUPER_ADMIN_USER;
grant usage, alter on sequence EMS_LOCALIZATION_SEQ to &IDEAS_SUPER_ADMIN_USER;
grant usage on sequence EMS_LOCALIZATION_SEQ to &IDEAS_REPORT_SUPER_ADMIN_USER;
