--RENAME A TABLE
set verify off
set serveroutput on
declare
  curr_user         varchar2(30);
  
  tab_name_src      varchar2(30) := 'EMS_LOCALIZATION_TMP';
  tab_name_dest     varchar2(30) := 'EMS_LOCALIZATION';
  dml_def           varchar2(4000);
  
  counter           number(16);
begin
  select trim ( user ) into curr_user from dual;
  select count(1) into counter from all_tables t where t.owner = curr_user and t.table_name = tab_name_dest;
  if ( counter = 1 ) then
    return;
  end if;

  dml_def :=
'rename ems_localization_tmp to ems_localization
';

  if ( '&ECHO' = 'ON' ) then
    dbms_output.put_line ( dml_def );
  end if;
  execute immediate ( dml_def );

  dml_def :=
'ALTER TABLE EMS_LOCALIZATION ADD (
  CONSTRAINT EMS_LOCALIZATION_PK
 PRIMARY KEY
 (ID)
  USING INDEX TABLESPACE IGA_CORE_DATA COMPUTE STATISTICS)
';

  if ( '&ECHO' = 'ON' ) then
    dbms_output.put_line ( dml_def );
  end if;
  execute immediate ( dml_def );

  dml_def :=
'ALTER TABLE EMS_I18N_MESSAGE ADD (
  CONSTRAINT EMS_I18N_LOCALIZATION_FK
 FOREIGN KEY (LOCALIZATION)
 REFERENCES EMS_LOCALIZATION (ID)
    ON DELETE CASCADE)
';

  if ( '&ECHO' = 'ON' ) then
    dbms_output.put_line ( dml_def );
  end if;
  execute immediate ( dml_def );

  dml_def :=
'ALTER TABLE EMS_TEMPLATE ADD (
  CONSTRAINT EMS_TEMPLATE_BODY_FK
 FOREIGN KEY (BODY)
 REFERENCES EMS_LOCALIZATION (ID)
    ON DELETE CASCADE)
';

  if ( '&ECHO' = 'ON' ) then
    dbms_output.put_line ( dml_def );
  end if;
  execute immediate ( dml_def );

  dml_def :=
'ALTER TABLE EMS_TEMPLATE ADD (
  CONSTRAINT EMS_TEMPLATE_SUBJECT_FK
 FOREIGN KEY (SUBJECT)
 REFERENCES EMS_LOCALIZATION (ID)
    ON DELETE CASCADE)
';

  if ( '&ECHO' = 'ON' ) then
    dbms_output.put_line ( dml_def );
  end if;
  execute immediate ( dml_def );

  dml_def :=
'create unique index EMS_LOCALIZATION_LNAME_IDX on EMS_LOCALIZATION (LOWER(CODE))
  TABLESPACE IGA_CORE_INDX COMPUTE STATISTICS
';

  if ( '&ECHO' = 'ON' ) then
    dbms_output.put_line ( dml_def );
  end if;
  execute immediate ( dml_def );

end;
/
set serveroutput off
set verify on


--RENAME A SEQUENCE
set verify off
set serveroutput on
declare
  curr_user         varchar2(30);
  
  seq_name_src      varchar2(30) := 'EMS_LOCALIZATION_TMP_SEQ';
  seq_name_dest     varchar2(30) := 'EMS_LOCALIZATION_SEQ';
  dml_def           varchar2(4000);
  
  counter           number(16);
begin
  select trim ( user ) into curr_user from dual;
  select count(1) into counter from all_sequences t where t.sequence_owner = curr_user and t.sequence_name = seq_name_dest;
  if ( counter = 1 ) then
    return;
  end if;

  dml_def :=
'rename ems_localization_tmp_seq to ems_localization_seq
';

  if ( '&ECHO' = 'ON' ) then
    dbms_output.put_line ( dml_def );
  end if;
  execute immediate ( dml_def );

end;
/
set serveroutput off
set verify on
