alter table EMS_LANGUAGE add COUNTRY VARCHAR2(4 CHAR);
comment on column EMS_LANGUAGE.COUNTRY
  is 'identify the language in two lower char (ISO Country Code, ISO 3166)';

drop index EMS_LANGUAGE_LNAME_IDX;
create unique index EMS_LANGUAGE_LNAME_LCOU_IDX on EMS_LANGUAGE (LOWER(NAME), LOWER(COUNTRY))
  tablespace IGA_CORE_INDX compute statistics;

update EMS_LANGUAGE set country = lower ( 'BR' ) where lower ( name ) = lower ( 'PT' );

update EMS_LANGUAGE set country = lower ( 'CN' ) where lower ( name ) = lower ( 'ZH' ) and country is null;

declare
  lan_id             number(16);
  lan_code_old       varchar2(4) := '01';
  lan_code           varchar2(4) := 'ZH';
  lan_country        varchar2(4) := 'TW';

  counter            number(16);
begin
  select count(1) into counter from EMS_LANGUAGE t where  lower ( name ) = lower ( lan_code_old );
  if ( counter = 0 ) then
    select count(1) into counter from EMS_LANGUAGE t
    where  lower ( name ) = lower ( lan_code ) and lower ( country ) = lower ( lan_country );
    if ( counter = 0 ) then
      select max ( id ) + 1 into lan_id from EMS_LANGUAGE;
      insert into EMS_LANGUAGE ( id, name, country )
      values ( lan_id, lower ( lan_code ), lower ( lan_country ) );
    end if;
  else 
    update EMS_LANGUAGE set country = lower ( lan_country ) where lower ( name ) = lower ( lan_code_old );
    update EMS_LANGUAGE set name = lower ( lan_code ) where lower ( name ) = lower ( lan_code_old );
  end if;
end;
/
commit;
