--ADD A COLUMN TO A TABLE
set verify off
set serveroutput on
declare
  curr_user         varchar2(30);
  
  tab_name          varchar2(30) := 'EMS_LANGUAGE';
  tab_col_name      varchar2(30) := 'COUNTRY';
  dml_def           varchar2(4000);
  
  counter           number(16);
begin
  select trim ( user ) into curr_user from dual;
  select count(1) into counter from all_tab_columns t where t.owner = curr_user and t.table_name = tab_name and t.column_name = tab_col_name;
  if ( counter = 1 ) then
    return;
  end if;

  dml_def :=
'alter table EMS_LANGUAGE add COUNTRY VARCHAR2(4 CHAR)
';

  if ( '&ECHO' = 'ON' ) then
    dbms_output.put_line ( dml_def );
  end if;
  execute immediate ( dml_def );

end;
/
set serveroutput off
set verify on

comment on column EMS_LANGUAGE.COUNTRY
  is 'identify the language in two lower char (ISO Country Code, ISO 3166)';

--DROP AN INDEX
set verify off
set serveroutput on
declare
  curr_user         varchar2(30);
  
  idx_name          varchar2(30) := 'EMS_LANGUAGE_LNAME_IDX';
  dml_def           varchar2(4000);
  
  counter           number(16);
begin
  select trim ( user ) into curr_user from dual;
  select count(1) into counter from all_indexes t where t.owner = curr_user and t.index_name = idx_name;
  if ( counter = 0 ) then
    return;
  end if;

  dml_def :=
'drop index EMS_LANGUAGE_LNAME_IDX
';

  if ( '&ECHO' = 'ON' ) then
    dbms_output.put_line ( dml_def );
  end if;
  execute immediate ( dml_def );

end;
/
set serveroutput off
set verify on

--CREATE AN INDEX
set verify off
set serveroutput on
declare
  curr_user         varchar2(30);
  
  idx_name          varchar2(30) := 'EMS_LANGUAGE_LNAME_LCOU_IDX';
  dml_def           varchar2(4000);
  
  counter           number(16);
begin
  select trim ( user ) into curr_user from dual;
  select count(1) into counter from all_indexes t where t.owner = curr_user and t.index_name = idx_name;
  if ( counter = 1 ) then
    return;
  end if;

  dml_def :=
'create unique index EMS_LANGUAGE_LNAME_LCOU_IDX on EMS_LANGUAGE (LOWER(NAME), LOWER(COUNTRY))
  tablespace IGA_CORE_INDX compute statistics
';

  if ( '&ECHO' = 'ON' ) then
    dbms_output.put_line ( dml_def );
  end if;
  execute immediate ( dml_def );

end;
/
set serveroutput off
set verify on

declare
  counter             number(16);  
begin
  select count(1) into counter from EMS_LANGUAGE where lower ( name ) = lower ( 'PT' ) and country is null;
  if ( counter = 1 ) then
    update EMS_LANGUAGE set country = lower ( 'BR' ) where lower ( name ) = lower ( 'PT' );
  end if;
end;
/
declare
  counter             number(16);  
begin
  select count(1) into counter from EMS_LANGUAGE where lower ( name ) = lower ( 'ZH' ) and country is null;
  if ( counter = 1 ) then
   update EMS_LANGUAGE set country = lower ( 'CN' ) where lower ( name ) = lower ( 'ZH' ) and country is null;
  end if;
end;
/

declare
  lan_id             number(16);
  lan_code_old       varchar2(4) := '01';
  lan_code           varchar2(4) := 'ZH';
  lan_country        varchar2(4) := 'TW';

  counter            number(16);
begin
  select count(1) into counter from EMS_LANGUAGE t where  lower ( name ) = lower ( lan_code_old );
  if ( counter = 0 ) then
    select count(1) into counter from EMS_LANGUAGE t
    where  lower ( name ) = lower ( lan_code ) and lower ( country ) = lower ( lan_country );
    if ( counter = 0 ) then
      select max ( id ) + 1 into lan_id from EMS_LANGUAGE;
      insert into EMS_LANGUAGE ( id, name, country )
      values ( lan_id, lower ( lan_code ), lower ( lan_country ) );
    end if;
  else 
    update EMS_LANGUAGE set country = lower ( lan_country ) where lower ( name ) = lower ( lan_code_old );
    update EMS_LANGUAGE set name = lower ( lan_code ) where lower ( name ) = lower ( lan_code_old );
  end if;
end;
/
commit;
