create table I18N_MESSAGE
(
  ID            NUMERIC(16) not null,
  IDEAS_MODULE  NUMERIC(16) not null,
  LOCALIZATION  NUMERIC(16) not null,
  LANGUAGE      NUMERIC(16) not null,
  MESSAGE       VARCHAR(4000),
  MESSAGE_LOB   CLOB,
  ATTR1         VARCHAR(256),
  ATTR2         VARCHAR(256),
  ATTR3         VARCHAR(256),
  ATTR4         VARCHAR(256),
  ATTR5         VARCHAR(256),
  CREATION_USER VARCHAR(128),
  CREATION_DATE DATE default CURRENT_DATE,
  LAST_MOD_USER VARCHAR(128),
  LAST_MOD_TIME DATE default CURRENT_DATE
)
IN &DATA_TABLESPACE
INDEX IN &INDEX_TABLESPACE
LONG IN &LOB_TABLESPACE
;

ALTER TABLE I18N_MESSAGE ADD
  CONSTRAINT I18N_MESSAGE_PK 
 PRIMARY KEY (ID);

alter table I18N_MESSAGE
  add constraint I18N_MESS_IM_FK foreign key (IDEAS_MODULE)
  references IDEAS_MODULE (ID) on delete cascade;
alter table I18N_MESSAGE
  add constraint I18N_MESS_LANGUAGE_FK foreign key (LANGUAGE)
  references LANGUAGE (ID) on delete cascade;
alter table I18N_MESSAGE
  add constraint I18N_MESS_LOCALIZATION_FK foreign key (LOCALIZATION)
  references LOCALIZATION (ID) on delete cascade;

create index I18N_MESS_IM_IDX on I18N_MESSAGE (IDEAS_MODULE)
;
create index I18N_MESS_LANGUAGE_IDX on I18N_MESSAGE (LANGUAGE)
;
create index I18N_MESS_LOCALIZATION_IDX on I18N_MESSAGE (LOCALIZATION)
;

create unique index I18N_MESS_IM_LOC_LANG_IDX on I18N_MESSAGE (IDEAS_MODULE, LOCALIZATION, LANGUAGE)
;

CALL SYSPROC.ADMIN_CMD ( 'REORG TABLE I18N_MESSAGE' );

grant select on I18N_MESSAGE to &AA_SUPER_ADMIN_USER;
grant select, insert, update, delete, references on I18N_MESSAGE to &IDEAS_SUPER_ADMIN_USER;
grant select, insert, update, delete, references on I18N_MESSAGE to &IDEAS_CONN_SUPER_ADMIN_USER;
grant select on I18N_MESSAGE to &IDEAS_REPORT_SUPER_ADMIN_USER;


create sequence I18N_MESSAGE_SEQ
  AS NUMERIC(18)
  START WITH 100
  INCREMENT BY 1
  MINVALUE 100
  MAXVALUE 999999999999999999
  NO CACHE
  NO CYCLE
  NO ORDER;

grant usage on sequence I18N_MESSAGE_SEQ to &AA_SUPER_ADMIN_USER;
grant usage, alter on sequence I18N_MESSAGE_SEQ to &IDEAS_SUPER_ADMIN_USER;
grant usage, alter on sequence I18N_MESSAGE_SEQ to &IDEAS_CONN_SUPER_ADMIN_USER;
grant usage on sequence I18N_MESSAGE_SEQ to &IDEAS_REPORT_SUPER_ADMIN_USER;
