--ADD A COLUMN TO A TABLE
set verify off
set serveroutput on
declare
  curr_user         varchar(30);
  
  tab_name          varchar(30) := 'REPORT';
  tab_col_name      varchar(30) := 'DASHBOARD';
  dml_def           varchar(4000);
  
  counter           numeric(16);
begin
  select trim ( user ) into curr_user from dual;
  select count(1) into counter from syscat.columns t where t.tabschema = curr_user and lower ( t.tabname ) = lower ( tab_name ) and lower ( t.colname ) = lower ( tab_col_name );
  if ( counter = 1 ) then
    return;
  end if;

  dml_def :=
'alter table REPORT add DASHBOARD NUMERIC(1) default 0
';

  if ( '&ECHO' = 'ON' ) then
    dbms_output.put_line ( dml_def );
  end if;
  execute immediate ( dml_def );

end;
/
set serveroutput off
set verify on

--ADD A COLUMN TO A TABLE
set verify off
set serveroutput on
declare
  curr_user         varchar(30);
  
  tab_name          varchar(30) := 'REPORT';
  tab_col_name      varchar(30) := 'REPORT';
  dml_def           varchar(4000);
  
  counter           numeric(16);
begin
  select trim ( user ) into curr_user from dual;
  select count(1) into counter from syscat.columns t where t.tabschema = curr_user and lower ( t.tabname ) = lower ( tab_name ) and lower ( t.colname ) = lower ( tab_col_name );
  if ( counter = 1 ) then
    return;
  end if;

  dml_def :=
'alter table REPORT add REPORT NUMERIC(16)
';

  if ( '&ECHO' = 'ON' ) then
    dbms_output.put_line ( dml_def );
  end if;
  execute immediate ( dml_def );

end;
/
set serveroutput off
set verify on

comment on column REPORT.DASHBOARD
  is '0: REPORT - 1:DASHBOARD';
comment on column REPORT.R_QUERY
  is 'Report Query/Dashboard Query reference';
comment on column REPORT.REPORT
  is 'Dashboard Report reference';

--ADD A FOREIGN KEY
set verify off
set serveroutput on
declare
  curr_user         varchar(30);
  
  tab_name          varchar(30) := 'REPORT';
  tab_fk_name       varchar(30) := 'REPORT_REPORT_FK';
  dml_def           varchar(4000);
  
  counter           numeric(16);
begin
  select trim ( user ) into curr_user from dual;
  select count(1) into counter from syscat.tabconst t where t.tabschema = curr_user and lower ( t.tabname ) = lower ( tab_name ) and lower ( t.constname ) = lower ( tab_fk_name ) and t.type = 'F';
  if ( counter = 1 ) then
    return;
  end if;

  dml_def :=
'alter table REPORT
  add constraint REPORT_REPORT_FK foreign key (REPORT)
  references REPORT (ID)
';

  if ( '&ECHO' = 'ON' ) then
    dbms_output.put_line ( dml_def );
  end if;
  execute immediate ( dml_def );

end;
/
set serveroutput off
set verify on

--DROP AN INDEX
set verify off
set serveroutput on
declare
  curr_user         varchar(30);
  
  idx_name          varchar(30) := 'REPORT_LNAME_IDX';
  dml_def           varchar(4000);
  
  counter           numeric(16);
begin
  select trim ( user ) into curr_user from dual;
  select count(1) into counter from syscat.indexes t where t.indschema = curr_user and lower ( indname ) = lower ( idx_name );
  if ( counter = 0 ) then
    return;
  end if;

  dml_def :=
'drop index REPORT_LNAME_IDX
';

  if ( '&ECHO' = 'ON' ) then
    dbms_output.put_line ( dml_def );
  end if;
  execute immediate ( dml_def );

end;
/
set serveroutput off
set verify on

--CREATE AN INDEX
set verify off
set serveroutput on
declare
  curr_user         varchar(30);
  
  idx_name          varchar(30) := 'REPORT_LNAME_DASHBOARD_IDX';
  dml_def           varchar(4000);
  
  counter           numeric(16);
begin
  select trim ( user ) into curr_user from dual;
  select count(1) into counter from syscat.indexes t where t.indschema = curr_user and lower ( indname ) = lower ( idx_name );
  if ( counter = 1 ) then
    return;
  end if;

  dml_def :=
'create unique index REPORT_LNAME_DASHBOARD_IDX on REPORT (lower(name), dashboard)
';

  if ( '&ECHO' = 'ON' ) then
    dbms_output.put_line ( dml_def );
  end if;
  execute immediate ( dml_def );

end;
/
set serveroutput off
set verify on

--REORGANIZE A TABLE
set verify off
set serveroutput on
declare
  curr_user         varchar(30);
  
  tab_name          varchar(30) := 'REPORT';
  dml_def           varchar(4000);
  
  counter           numeric(16);
begin
  select trim ( user ) into curr_user from dual;
  select count(1) into counter from sysibm.tables t where ( t.table_type = 'BASE TABLE' or t.table_type is null ) and lower ( t.table_schema ) = lower ( curr_user ) and t.table_name = tab_name;
  if ( counter = 0 ) then
    return;
  end if;

  dml_def :=
'CALL SYSPROC.ADMIN_CMD( ''REORG TABLE REPORT'' )
';

  if ( '&ECHO' = 'ON' ) then
    dbms_output.put_line ( dml_def );
  end if;
  execute immediate ( dml_def );

end;
/
commit;
set serveroutput off
set verify on
