--ADD A COLUMN TO A TABLE
set verify off
set serveroutput on
declare
  curr_user         varchar2(30);
  
  tab_name          varchar2(30) := 'REPORT';
  tab_col_name      varchar2(30) := 'DASHBOARD';
  dml_def           varchar2(4000);
  
  counter           number(16);
begin
  select trim ( user ) into curr_user from dual;
  select count(1) into counter from all_tab_columns t where t.owner = curr_user and t.table_name = tab_name and t.column_name = tab_col_name;
  if ( counter = 1 ) then
    return;
  end if;

  dml_def :=
'alter table REPORT add DASHBOARD NUMBER(1) default 0
';

  if ( '&ECHO' = 'ON' ) then
    dbms_output.put_line ( dml_def );
  end if;
  execute immediate ( dml_def );

end;
/
set serveroutput off
set verify on

--ADD A COLUMN TO A TABLE
set verify off
set serveroutput on
declare
  curr_user         varchar2(30);
  
  tab_name          varchar2(30) := 'REPORT';
  tab_col_name      varchar2(30) := 'REPORT';
  dml_def           varchar2(4000);
  
  counter           number(16);
begin
  select trim ( user ) into curr_user from dual;
  select count(1) into counter from all_tab_columns t where t.owner = curr_user and t.table_name = tab_name and t.column_name = tab_col_name;
  if ( counter = 1 ) then
    return;
  end if;

  dml_def :=
'alter table REPORT add REPORT NUMBER(16)
';

  if ( '&ECHO' = 'ON' ) then
    dbms_output.put_line ( dml_def );
  end if;
  execute immediate ( dml_def );

end;
/
set serveroutput off
set verify on

comment on column REPORT.DASHBOARD
  is '0: REPORT - 1:DASHBOARD';
comment on column REPORT.R_QUERY
  is 'Report Query/Dashboard Query reference';
comment on column REPORT.REPORT
  is 'Dashboard Report reference';

--ADD A FOREIGN KEY
set verify off
set serveroutput on
declare
  curr_user         varchar2(30);
  
  tab_name          varchar2(30) := 'REPORT';
  tab_fk_name       varchar2(30) := 'REPORT_REPORT_FK';
  dml_def           varchar2(4000);
  
  counter           number(16);
begin
  select trim ( user ) into curr_user from dual;
  select count(1) into counter from all_constraints t where t.owner = curr_user and t.table_name = tab_name and t.constraint_name = tab_fk_name and t.constraint_type = 'R';
  if ( counter = 1 ) then
    return;
  end if;

  dml_def :=
'alter table REPORT
  add constraint REPORT_REPORT_FK foreign key (REPORT)
  references REPORT (ID)
';

  if ( '&ECHO' = 'ON' ) then
    dbms_output.put_line ( dml_def );
  end if;
  execute immediate ( dml_def );

end;
/
set serveroutput off
set verify on

--DROP AN INDEX
set verify off
set serveroutput on
declare
  curr_user         varchar2(30);
  
  idx_name          varchar2(30) := 'REPORT_LNAME_IDX';
  dml_def           varchar2(4000);
  
  counter           number(16);
begin
  select trim ( user ) into curr_user from dual;
  select count(1) into counter from all_indexes t where t.owner = curr_user and t.index_name = idx_name;
  if ( counter = 0 ) then
    return;
  end if;

  dml_def :=
'drop index REPORT_LNAME_IDX
';

  if ( '&ECHO' = 'ON' ) then
    dbms_output.put_line ( dml_def );
  end if;
  execute immediate ( dml_def );

end;
/
set serveroutput off
set verify on

--CREATE AN INDEX
set verify off
set serveroutput on
declare
  curr_user         varchar2(30);
  
  idx_name          varchar2(30) := 'REPORT_LNAME_DASHBOARD_IDX';
  dml_def           varchar2(4000);
  
  counter           number(16);
begin
  select trim ( user ) into curr_user from dual;
  select count(1) into counter from all_indexes t where t.owner = curr_user and t.index_name = idx_name;
  if ( counter = 1 ) then
    return;
  end if;

  dml_def :=
'create unique index REPORT_LNAME_DASHBOARD_IDX on REPORT (lower(name), dashboard)
  tablespace IGA_REPORT_INDX compute statistics
';

  if ( '&ECHO' = 'ON' ) then
    dbms_output.put_line ( dml_def );
  end if;
  execute immediate ( dml_def );

end;
/
set serveroutput off
set verify on
