declare
  rq_id            number(16);
  rq_name          varchar2(256) := 'Account matching status';
  rq_desc          varchar2(512) := 'Account matching status';
  rqd              clob;

  counter          number(16);
begin
  rqd := 'select
'||'  pwdc.name as pwdconfig_name,
'||'  case
'||'    when pwdm.state = 0 then ''Identity Matched''
'||'    when pwdm.state = 1 then ''Orphan''
'||'    when pwdm.state = 2 then ''Unmatched''
'||'  end as account_status,
'||'  count(1) as account_count
'||'from
'||'  #pmschema#.pwdmanagement pwdm,
'||'  #pmschema#.pwdcfg pwdc
'||'where
'||'  pwdm.pwdcfg = pwdc.id
'||'  and lower ( pwdc.name ) like lower ( ''#pwdconfig_name#'' )
'||'group by
'||'  pwdc.name, pwdm.state
'||'';

  select count(1) into counter from r_query t where lower ( t.name ) = lower ( rq_name );
  if ( counter = 1 ) then
    select t.id into rq_id from r_query t where lower ( t.name ) = lower ( rq_name );

    update r_query_data set query = rqd where r_query = rq_id;
  end if;
  
end;
/

commit;
