declare
  rq_id            numeric(16);
  rq_name          varchar(256) := 'Account matching status DB';
  rq_desc          varchar(512) := 'Account matching status DB';
  rqd              clob;

  counter          numeric(16);
begin
  rqd := 'select
'||'  a.name as application_name,
'||'  count(1) as account_count,
'||'  case
'||'    when pwdm.state = 0 then ''Identity Matched''
'||'    when pwdm.state = 1 then ''Orphan''
'||'    when pwdm.state = 2 then ''Unmatched''
'||'  end as account_status
'||'from
'||'  #schema_tmp#.tmp_rep_application tmpa,
'||'  #pmschema#.application a,
'||'  #pmschema#.target t,
'||'  #pmschema#.pwdcfg pwdc,
'||'  #pmschema#.pwdmanagement pwdm
'||'where
'||'  tmpa.id = a.id
'||'  and a.target = t.id
'||'  and t.pwdcfg = pwdc.id
'||'  and pwdc.id = pwdm.pwdcfg
'||'  and lower ( pwdc.name ) like lower ( ''#pwdconfig_name#'' )
'||'group by
'||'  a.name, pwdm.state
'||'';

  select count(1) into counter from r_query t where lower ( t.name ) = lower ( rq_name );
  if ( counter = 1 ) then
    select t.id into rq_id from r_query t where lower ( t.name ) = lower ( rq_name );

    update r_query_data set query = rqd where r_query = rq_id;
  end if;
  
end;
/

commit;
