declare
  rq_id            number(16);
  rq_name_old      varchar2(256) := 'Technical transformation status DB';
  rq_name          varchar2(256) := 'Business activity mapping status DB';
  rq_desc          varchar2(512) := '';
  rqd              clob;

  counter          number(16);
begin
  rqd := 'select
'||'  t.permission_status,
'||'  count(1) as permission_count
'||'from
'||'(
'||'  select
'||'  --t.permission_id,
'||'   case
'||'     when t.permission_status = 0 then ''TBD''
'||'     when t.permission_status = 1 then ''Linked''
'||'     when t.permission_status = 2 then ''Ignored''
'||'     when t.permission_status = 3 then ''Missing Activities''
'||'     else ''-''
'||'   end as permission_status,
'||'  --t.permission as ''permission_name'',
'||'  --t.permission_description as permission_desc,
'||'  t.application_name as application_name,
'||'  --t.permission_type_name as profile_type,
'||'  --tp.activity as activity_name,
'||'  --tp.activity_path as activity_path,
'||'  tp.activity_code as activity_code--,
'||'  --tp.env_id,
'||'  --t.permission_code
'||'    from (select e.id     as permission_id,
'||'          e.state         as permission_status,
'||'          --e.name        as permission,
'||'          --e.code        as permission_code,
'||'          --e.description as permission_description,
'||'          a.name        as application_name--,
'||'          --pt.name       as permission_type_name
'||'            from #pmschema#.entitlement  e,
'||'                 #schema_tmp#.tmp_rep_application tmpa,
'||'                 #pmschema#.application  a,
'||'                 #pmschema#.profile_type pt
'||'           where e.ext_type = a.sod_ext_level
'||'             and e.application = tmpa.id
'||'             and tmpa.id = a.id
'||'             and e.profile_type = pt.id
'||'             and e.administrative = 0
'||'             and pt.application = a.id
'||'             and lower ( e.name ) like lower ( ''#permission_name#'' )
'||'             and e.state in (0, 1, 2, 3)) t
'||'    left outer join (select distinct tp.profile,
'||'                                     tp.task,
'||'                                     --t.name as activity,
'||'                                     --t.path as activity_path,
'||'                                     t.code as activity_code,
'||'                                     env.id as env_id
'||'                       from (select pgr.profile, t.task, t.environment
'||'                               from #pmschema#.profile_group pgr,
'||'                                    (select tp.task, pg.root, tp.environment
'||'                                       from #pmschema#.task_profile  tp,
'||'                                            #pmschema#.entitlement   e,
'||'                                            #pmschema#.profile_group pg
'||'                                      where e.int_type = 0
'||'                                        and tp.profile = e.id
'||'                                        and e.administrative = 0
'||'                                        and e.id = pg.profile) t
'||'                              where pgr.root = t.root
'||'                                and pgr.type = 3
'||'                             union
'||'                             select tp.profile, tp.task, tp.environment
'||'                               from #pmschema#.task_profile tp,
'||'                                    #pmschema#.entitlement  e,
'||'                                    #pmschema#.application  a
'||'                              where e.application = a.id
'||'                                and e.ext_type = a.sod_ext_level
'||'                                and e.administrative = 0
'||'                                and tp.profile = e.id) tp,
'||'                            #pmschema#.environment env,
'||'                            #pmschema#.task t
'||'                      where env.working = 1
'||'                        and env.id = tp.environment
'||'                        and tp.environment = t.environment
'||'                        and tp.task = t.id) tp on tp.profile = t.permission_id
'||'   where 1 = 1
'||'     and t.permission_status = #permission_status#
'||'     and lower ( t.application_name ) like lower ( ''#application_name#'' )
'||'     and ( lower ( tp.activity_code ) like lower ( ''#activity_code#'' ) or tp.activity_code is null )
'||') t
'||'group by t.permission_status
'||'';

  select count(1) into counter from r_query t where lower ( t.name ) = lower ( rq_name );
  if ( counter = 1 ) then
    select t.id into rq_id from r_query t where lower ( t.name ) = lower ( rq_name );

    update r_query_data set query = rqd where r_query = rq_id;
  end if;
  
end;
/

commit;
