declare
  rq_id            numeric(16);
  rq_name          varchar(256) := 'Accounts created in last x days DB';
  rq_desc          varchar(512) := '';
  rqd              clob;

  counter          numeric(16);
begin
  rqd := 'select
'||'  count(1) as account_count
'||'from 
'||'(
'||'  select distinct
'||'    --t.name as target_name,
'||'    --a.name as application_name,
'||'    --pwdm.code as account_code,
'||'    --case
'||'    --  when pwdm.name is null then p.name
'||'    --end as user_name,
'||'    --case
'||'    --  when pwdm.surname is null then p.surname
'||'    --end as user_surname,
'||'    --case
'||'    --  when pwdm.email is null then p.email
'||'    --end as user_email,
'||'    --pwdm.last_mod_time as account_creation_date
'||'    pwdm.id
'||'  from
'||'    #schema_tmp#.tmp_rep_application tmpa,
'||'    #pmschema#.application a,
'||'    #pmschema#.target t,
'||'    #pmschema#.pwdcfg pwdc,
'||'    #pmschema#.pwdmanagement pwdm
'||'  left outer join #pmschema#.person p on pwdm.person = p.id
'||'  where
'||'    tmpa.id = a.id
'||'    and a.target = t.id
'||'    and t.pwdcfg = pwdc.id
'||'    and pwdc.id = pwdm.pwdcfg
'||'    and a.administrative = 0
'||'    and pwdm.last_mod_time >=
'||'         to_date(extract(year from current_date - #day_number#) || ''/'' ||
'||'                 extract(month from current_date - #day_number#) || ''/'' ||
'||'                 extract(day from current_date - #day_number#) || '' 00:00:01'',  ''yyyy/mm/dd hh24:mi:ss'')
'||') t
'||'';

  select count(1) into counter from r_query t where lower ( t.name ) = lower ( rq_name );
  if ( counter = 1 ) then
    select t.id into rq_id from r_query t where lower ( t.name ) = lower ( rq_name );

    update r_query_data set query = rqd where r_query = rq_id;
  end if;
  
end;
/

commit;
