declare
  rq_id            numeric(16);
  rq_name          varchar(256) := 'Recent requests DB';
  rq_desc          varchar(512) := '';
  rqd              clob;

  counter          numeric(16);
begin
  rqd := 'select distinct
'||'  case
'||'    when req.req_type = 4 then ''Admin Access Change''
'||'    when req.req_type = 5 then ''User Access Change''
'||'    when req.req_type = 6 then ''Role Assign''
'||'    when req.req_type = 8 then ''Role Removal''
'||'    when req.req_type = 9 then ''Role Renewal''
'||'    when req.req_type = 10 then ''Delegation Assign''
'||'    when req.req_type = 12 then ''Delegation Removal''
'||'    when req.req_type = 13 then ''Delegation Change''
'||'    when req.req_type = 18 then ''Password Reset''
'||'    when req.req_type = 19 then ''Password Change''
'||'    when req.req_type = 32 then ''Account Suspend''
'||'    when req.req_type = 33 then ''Account Restore''
'||'    when req.req_type = 58 then ''Account Management''
'||'    when req.req_type = 61 then ''Delegation Renewal''
'||'    when req.req_type = 70 then ''Entity Change''
'||'    when req.req_type = 71 then ''User Create''
'||'    when req.req_type = 72 then ''User Update''
'||'    when req.req_type = 73 then ''User Delete''
'||'    when req.req_type = 77 then ''Entitlement Create''
'||'    when req.req_type = 78 then ''Entitlement Update''
'||'    when req.req_type = 79 then ''Entitlement Delete''
'||'    when req.req_type = 80 then ''Entitlement details Update''
'||'    else cast ( req.req_type as varchar(256) )
'||'  end as request_type,
'||'  req.entity_name as request_entity_name,
'||'  req.created_on request_created_on
'||'from
'||'(
'||'  select
'||'    req.beneficiary,
'||'    req.req_type,
'||'    ap.application_name as entity_name,
'||'    req.created_on
'||'  from
'||'    #pmschema#.person                             p,
'||'    #swimschema#.request                            req,
'||'    #swimschema#.applications                       ap
'||'  where p.s_user = req.beneficiary
'||'    and lower ( p.code ) like lower (''#ideas_userlogged#'')
'||'    and req.id = ap.request
'||'    and req.parent is not null
'||'  union
'||'  select
'||'    req.beneficiary,
'||'    req.req_type,
'||'    ro.ent_name as entity_name,
'||'    req.created_on
'||'  from
'||'    #pmschema#.person                             p,
'||'    #swimschema#.request                            req,
'||'    #swimschema#.roles                              ro
'||'  where p.s_user = req.beneficiary
'||'    and lower ( p.code ) like lower (''#ideas_userlogged#'')
'||'    and req.id = ro.request
'||'    and req.parent is not null
'||'  union
'||'  select
'||'    req.beneficiary,
'||'    req.req_type,
'||'    ef.entity as entity_name,
'||'    req.created_on
'||'  from
'||'    #pmschema#.person                             p,
'||'    #swimschema#.request                            req,
'||'    #swimschema#.entity_fields                      ef
'||'  where p.s_user = req.beneficiary
'||'    and lower ( p.code ) like lower (''#ideas_userlogged#'')
'||'    and req.id = ef.request
'||'    and req.parent is not null
'||'  union
'||'  select distinct
'||'    req.beneficiary,
'||'    req.req_type,
'||'    ad.name as entity_name,
'||'    req.created_on
'||'  from
'||'    #pmschema#.person                             p,
'||'    #swimschema#.request                            req,
'||'    #swimschema#.additional_data                    ad
'||'  where p.s_user = req.beneficiary
'||'    and lower ( p.code ) like lower (''#ideas_userlogged#'')
'||'    and req.id = ad.request
'||'    and req.parent is not null
'||') req
'||'where req.created_on >=
'||'         to_date(extract(year from current_date - #day_number#) || ''/'' ||
'||'                 extract(month from current_date - #day_number#) || ''/'' ||
'||'                 extract(day from current_date - #day_number#) || '' 00:00:01'',  ''yyyy/mm/dd hh24:mi:ss'') 
'||'';

  select count(1) into counter from r_query t where lower ( t.name ) = lower ( rq_name );
  if ( counter = 1 ) then
    select t.id into rq_id from r_query t where lower ( t.name ) = lower ( rq_name );

    update r_query_data set query = rqd where r_query = rq_id;
  end if;
  
end;
/

commit;
