declare
  rq_id            number(16);
  rq_name          varchar2(256) := 'Activities created in last x days';
  rq_desc          varchar2(512) := '';
  rqd              clob;

  counter          number(16);
begin
  rqd := 'select distinct
'||'  t.name as activity_name,
'||'  t.path as activity_path,
'||'  t.creation_date as activity_creation_date
'||'from
'||'  #pmschema#.environment e,
'||'  #pmschema#.task t
'||'where e.id = t.environment
'||'and e.working = 1
'||'and t.creation_date >=
'||'       to_date(extract(year from sysdate - #day_number#) || ''/'' ||
'||'               extract(month from sysdate - #day_number#) || ''/'' ||
'||'               extract(day from sysdate - #day_number#) || '' 00:00:01'',  ''yyyy/mm/dd hh24:mi:ss'')
'||'';

  select count(1) into counter from r_query t where lower ( t.name ) = lower ( rq_name );
  if ( counter = 1 ) then
    select t.id into rq_id from r_query t where lower ( t.name ) = lower ( rq_name );

    update r_query_data set query = rqd where r_query = rq_id;
  end if;
  
end;
/

commit;
