declare
  rq_id            numeric(16);
  rq_name          varchar(256) := 'Permissions created in last x days';
  rq_desc          varchar(512) := '';
  rqd              clob;

  counter          numeric(16);
begin
  rqd := 'select distinct
'||'  a.name as application_name,
'||'  e.name as permission_name,
'||'  e.ext_ref as permission_ext_ref,
'||'  pt.name as profile_type,
'||'  e.creation_date as permission_creation_date
'||'from
'||'  #pmschema#.application a,
'||'  #pmschema#.entitlement e,
'||'  #pmschema#.profile_type pt
'||'where a.id = e.application
'||'  and e.profile_type = pt.id
'||'  and e.int_type in ( -1, 1 )
'||'  --and e.ext_type in ( 3, 4 )
'||'  and a.sod_ext_level = e.ext_type
'||'  and e.administrative = 0
'||'  and e.creation_date >=
'||'       to_date(extract(year from current_date - #day_number#) || ''/'' ||
'||'               extract(month from current_date - #day_number#) || ''/'' ||
'||'               extract(day from current_date - #day_number#) || '' 00:00:01'',  ''yyyy/mm/dd hh24:mi:ss'')
'||'';

  select count(1) into counter from r_query t where lower ( t.name ) = lower ( rq_name );
  if ( counter = 1 ) then
    select t.id into rq_id from r_query t where lower ( t.name ) = lower ( rq_name );

    update r_query_data set query = rqd where r_query = rq_id;
  end if;
  
end;
/

commit;
