declare
  rq_id            number(16);
  rq_name          varchar2(256) := 'Requests with escalation DB';
  rq_desc          varchar2(512) := '';
  rqd              clob;

  counter          number(16);
begin
  rqd := 'select distinct
'||'  case
'||'    when req.req_type = 4 then ''Admin Access Change''
'||'    when req.req_type = 5 then ''User Access Change''
'||'    when req.req_type = 6 then ''Role Assign''
'||'    when req.req_type = 8 then ''Role Removal''
'||'    when req.req_type = 9 then ''Role Renewal''
'||'    when req.req_type = 10 then ''Delegation Assign''
'||'    when req.req_type = 12 then ''Delegation Removal''
'||'    when req.req_type = 13 then ''Delegation Change''
'||'    when req.req_type = 18 then ''Password Reset''
'||'    when req.req_type = 19 then ''Password Change''
'||'    when req.req_type = 32 then ''Account Suspend''
'||'    when req.req_type = 33 then ''Account Restore''
'||'    when req.req_type = 58 then ''Account Management''
'||'    when req.req_type = 61 then ''Delegation Renewal''
'||'    when req.req_type = 70 then ''Entitlement Management''
'||'    when req.req_type = 71 then ''Insert User''
'||'    when req.req_type = 72 then ''Update User''
'||'    when req.req_type = 73 then ''User Delete''
'||'    when req.req_type = 77 then ''Entitlement Create''
'||'    when req.req_type = 78 then ''Entitlement Update''
'||'    when req.req_type = 79 then ''Entitlement Delete''
'||'    when req.req_type = 80 then ''User Management''
'||'    else cast ( req.req_type as varchar(256) )
'||'  end request_type,
'||'  p.code as user_code,
'||'  req.last_mod_time as request_last_update
'||'from
'||'  #schema_tmp#.tmp_rep_organizational_unit tmpou,
'||'  #pmschema#.group_person                       gp,
'||'  #pmschema#.person                             p,
'||'  #swimschema#.request                            req
'||'where tmpou.id = gp.organizational_unit
'||'  and gp.person = p.id
'||'  and p.s_user = req.beneficiary
'||'  and gp.hierarchy = 1
'||'  --and req.req_type in ( 6 )
'||'  and req.req_status in ( 10 )
'||'  and req.parent is not null
'||'';

  select count(1) into counter from r_query t where lower ( t.name ) = lower ( rq_name );
  if ( counter = 1 ) then
    select t.id into rq_id from r_query t where lower ( t.name ) = lower ( rq_name );

    update r_query_data set query = rqd where r_query = rq_id;
  end if;
  
end;
/

commit;
