declare
  rq_id            numeric(16);
  rq_name          varchar(256) := 'Days until the next password expiration DB';
  rq_desc          varchar(512) := '';
  rqd              clob;

  counter          numeric(16);
begin
  rqd := 'select
'||'  case
'||'    when t.account_next_expiry_date is null then ''--''
'||'    else cast ( account_next_expiry_date as varchar(256) )
'||'  end as account_next_expiry_date
'||'from
'||'(
'||'  select
'||'    case when t.expire_pass is not null and t.today is not null then
'||'      case when t.expire_pass - t.today > 0 then
'||'        cast ( t.expire_pass - t.today as varchar(256) )
'||'      else
'||'        ''Expired''
'||'      end
'||'    else
'||'      null
'||'    end as account_next_expiry_date
'||'  from
'||'  (
'||'    select
'||'      case when pwdcnt.value is not null and pwdcnt.value <> ''0'' then
'||'        to_date ( to_char ( pwdm.lastchangepwd + cast ( pwdcnt.value as numeric ), ''yyyy/mm/dd'' ), ''yyyy/mm/dd'' )
'||'      else
'||'        null
'||'      end as expire_pass,
'||'      case when pwdcnt.value is not null and pwdcnt.value <> ''0'' then
'||'        to_date ( to_char ( current_date, ''yyyy/mm/dd'' ), ''yyyy/mm/dd'' )
'||'      else
'||'        null
'||'      end as today
'||'    from
'||'      #pmschema#.person                             p,
'||'      #pmschema#.pwdmanagement                      pwdm,
'||'      #pmschema#.pwdcfg                             pwdc,
'||'      #pmschema#.pwdcfgcnt                          pwdcnt
'||'    where p.id = pwdm.person
'||'      and pwdm.pwdcfg = pwdc.id
'||'      and pwdc.id = pwdcnt.pwdcfg
'||'      and lower ( p.code ) like lower (''#ideas_userlogged#'')
'||'      and lower ( pwdc.name ) like lower ( ''Ideas'' )
'||'      and pwdcnt.name = ''ACCOUNT_PWD_LIFE''
'||'  ) t
'||') t
'||'';

  select count(1) into counter from r_query t where lower ( t.name ) = lower ( rq_name );
  if ( counter = 1 ) then
    select t.id into rq_id from r_query t where lower ( t.name ) = lower ( rq_name );

    update r_query_data set query = rqd where r_query = rq_id;
  end if;
  
end;
/

commit;
