declare
  counter          number(16);
  
  rq_id            number(16);
  rq_name_old      varchar2(256) := 'Recent requests DB';
  rq_name          varchar2(256) := 'Recent requests DB';
  rq_desc          varchar2(512) := '';
  rqd              clob;

  rqf_type_def     varchar2(256) := 'java.lang.String';
  rqf_width_def    number(16) := 300;

  rqf_id           number(16);
  rqf_name_old     varchar2(256);
  rqf_name         varchar2(256);
  rqf_type         varchar2(256);
  rqf_width        number(16);
  rqf_ord_by       number(1);
  rqf_ord_by_clau  varchar2(256);
  rqf_ord_pos      number(16);
  loc_id           number(16);
  loc_code_old     varchar2(256);
  loc_code         varchar2(256);
  i18n_msg         varchar2(256);
  repf_pos_id      number(16);
  repf_pos_id_old  number(16);

  --Si puo' modificare un campo esistente, se null si inserisce
  rqf_name1_old    varchar2(256) := null;
  rqf_name1        varchar2(256) := 'REQUEST_STATUS';
  rqf_type1        varchar2(256) := rqf_type_def;
  rqf_width1       varchar2(256) := rqf_width_def;
  rqf_ord_by1      number(1)     := 0;
  rqf_ord_by_clau1 varchar2(256) := 'ASC';
  --Si puo' modificare un campo esistente, se null si inserisce
  loc_code1_old    varchar2(256) := null;
  loc_code1        varchar2(256) := 'request.status';
  i18n_msg1        varchar2(256) := 'Step Status';
  --Si puo' scegliere la posizione della colonna nel report. Gli indici iniziano da 0
  --Se il campo e' null viene lasciato per ultimo
  repf_pos_id1     number(16)    := 1;
  
  cur_lan          sys_refcursor;
  lan_id           number(16);
  
  cur_rep          sys_refcursor;
  rep_id           number(16);

begin
  rqd := 'select distinct
'||'  case
'||'    when req.req_type = 4 then ''Admin Access Change''
'||'    when req.req_type = 5 then ''User Access Change''
'||'    when req.req_type = 6 then ''Role Assign''
'||'    when req.req_type = 8 then ''Role Removal''
'||'    when req.req_type = 9 then ''Role Renewal''
'||'    when req.req_type = 10 then ''Delegation Assign''
'||'    when req.req_type = 12 then ''Delegation Removal''
'||'    when req.req_type = 13 then ''Delegation Change''
'||'    when req.req_type = 18 then ''Password Reset''
'||'    when req.req_type = 19 then ''Password Change''
'||'    when req.req_type = 32 then ''Account Suspend''
'||'    when req.req_type = 33 then ''Account Restore''
'||'    when req.req_type = 58 then ''Account Management''
'||'    when req.req_type = 61 then ''Delegation Renewal''
'||'    when req.req_type = 70 then ''Entitlement Management''
'||'    when req.req_type = 71 then ''Insert User''
'||'    when req.req_type = 72 then ''Update User''
'||'    when req.req_type = 73 then ''User Delete''
'||'    when req.req_type = 77 then ''Entitlement Create''
'||'    when req.req_type = 78 then ''Entitlement Update''
'||'    when req.req_type = 79 then ''Entitlement Delete''
'||'    when req.req_type = 80 then ''User Management''
'||'    else cast ( req.req_type as varchar(256) )
'||'  end as request_type,
'||'  case
'||'    when req.req_status = 2 then ''Authorizable''
'||'    when req.req_status = 3 then ''Approved''
'||'    when req.req_status = 4 then ''Suspended''
'||'    when req.req_status = 5 then ''Rejected''
'||'    when req.req_status = 6 then ''Performed''
'||'    when req.req_status = 7 then ''Completed''
'||'    when req.req_status = 8 then ''Failed Completion''
'||'    when req.req_status = 9 then ''Pending ''
'||'    when req.req_status = 10 then ''Escalation''
'||'    when req.req_status = 12 then ''Partially Authorizable''
'||'    when req.req_status = 13 then ''Partially Approved''
'||'    when req.req_status = 14 then ''Partially Executed''
'||'    when req.req_status = 15 then ''Partially Completed''
'||'    when req.req_status = 19 then ''Incompatibility''
'||'    when req.req_status = 30 then ''Terminated pending confirmation''
'||'    when req.req_status = 31 then ''Partially Terminated''
'||'    else cast ( req.req_status as varchar(256) )
'||'  end request_status,
'||'  req.entity_name as request_entity_name,
'||'  req.created_on request_created_on
'||'from
'||'(
'||'  select
'||'    req.beneficiary,
'||'    req.req_type,
'||'    req.req_status,
'||'    ap.application_name as entity_name,
'||'    req.created_on
'||'  from
'||'    #pmschema#.person                             p,
'||'    #swimschema#.request                            req,
'||'    #swimschema#.applications                       ap
'||'  where p.s_user = req.beneficiary
'||'    and lower ( p.code ) like lower (''#ideas_userlogged#'')
'||'    and req.id = ap.request
'||'    and req.parent is not null
'||'  union
'||'  select
'||'    req.beneficiary,
'||'    req.req_type,
'||'    req.req_status,
'||'    ro.ent_name as entity_name,
'||'    req.created_on
'||'  from
'||'    #pmschema#.person                             p,
'||'    #swimschema#.request                            req,
'||'    #swimschema#.roles                              ro
'||'  where p.s_user = req.beneficiary
'||'    and lower ( p.code ) like lower (''#ideas_userlogged#'')
'||'    and req.id = ro.request
'||'    and req.parent is not null
'||'  union
'||'  select
'||'    req.beneficiary,
'||'    req.req_type,
'||'    req.req_status,
'||'    ef.entity as entity_name,
'||'    req.created_on
'||'  from
'||'    #pmschema#.person                             p,
'||'    #swimschema#.request                            req,
'||'    #swimschema#.entity_fields                      ef
'||'  where p.s_user = req.beneficiary
'||'    and lower ( p.code ) like lower (''#ideas_userlogged#'')
'||'    and req.id = ef.request
'||'    and req.parent is not null
'||'  union
'||'  select distinct
'||'    req.beneficiary,
'||'    req.req_type,
'||'    req.req_status,
'||'    ad.name as entity_name,
'||'    req.created_on
'||'  from
'||'    #pmschema#.person                             p,
'||'    #swimschema#.request                            req,
'||'    #swimschema#.additional_data                    ad
'||'  where p.s_user = req.beneficiary
'||'    and lower ( p.code ) like lower (''#ideas_userlogged#'')
'||'    and req.id = ad.request
'||'    and req.parent is not null
'||') req
'||'where req.created_on >=
'||'         to_date(extract(year from sysdate - #day_number#) || ''/'' ||
'||'                 extract(month from sysdate - #day_number#) || ''/'' ||
'||'                 extract(day from sysdate - #day_number#) || '' 00:00:01'',  ''yyyy/mm/dd hh24:mi:ss'') 
'||'';
  --modifica il nome della query
  if ( rq_name <> rq_name_old ) then
    update r_query set name = rq_name where name = rq_name_old;
  end if;

  select count(1) into counter from r_query t where lower ( t.name ) = lower ( rq_name );
  if ( counter = 1 ) then
    select t.id into rq_id from r_query t where lower ( t.name ) = lower ( rq_name );

    update r_query_data set query = rqd where r_query = rq_id;
  end if;
  
  --QUERY FIELD 1: BEGIN
  rqf_id          := null;
  rqf_name_old    := rqf_name1_old;
  rqf_name        := rqf_name1;
  rqf_type        := rqf_type1;
  rqf_width       := rqf_width1;
  rqf_ord_by      := rqf_ord_by1;
  rqf_ord_by_clau := rqf_ord_by_clau1;
  rqf_ord_pos     := null;
  loc_id          := null;
  loc_code_old    := loc_code1_old;
  loc_code        := loc_code1;
  i18n_msg        := i18n_msg1;
  repf_pos_id_old := null;
  repf_pos_id     := repf_pos_id1;
    
  if ( rqf_name_old is null or rqf_name_old = rqf_name ) then
    select count(1) into counter from r_query_field t where t.r_query = rq_id and lower ( t.column_name ) = lower ( rqf_name );
    if ( counter = 0 ) then
      select r_query_field_seq.nextval into rqf_id from dual;
      
      insert into r_query_field ( id, r_query, column_name, title, type, width )
      values ( rqf_id, rq_id, rqf_name, loc_code, rqf_type, rqf_width );
    end if;
  elsif ( rqf_name_old is not null and rqf_name_old <> rqf_name ) then
    select count(1) into counter from r_query_field t where t.r_query = rq_id and lower ( t.column_name ) = lower ( rqf_name_old );
    if ( counter = 1 ) then
      select t.id into rqf_id from r_query_field t where t.r_query = rq_id and lower ( t.column_name ) = lower ( rqf_name_old );
      update r_query_field set column_name = rqf_name where id = rqf_id;
    end if;  
  end if;
  if ( rqf_id is null ) then
    select t.id into rqf_id from r_query_field t where t.r_query = rq_id and lower ( t.column_name ) = lower ( rqf_name );
  end if;
  
  if ( loc_code_old is null or loc_code_old = loc_code ) then
    select count(1) into counter from localization t where lower ( t.code ) = lower ( loc_code );
    if ( counter = 0 ) then
      select localization_seq.nextval into loc_id from dual;
      
      insert into localization ( id, code, code_type )
      values ( loc_id, loc_code, 0 );
    end if;
  elsif ( loc_code_old is not null and loc_code_old <> loc_code ) then
    select count(1) into counter from localization t where lower ( t.code ) = lower ( loc_code_old );
    if ( counter = 1 ) then
      select t.id into loc_id from localization t where lower ( t.code ) = lower ( loc_code_old );
      update localization set code = loc_code where id = loc_id;
      update r_query_field set title = loc_code where id = rqf_id;
    end if;
  end if;
  if ( loc_id is null ) then
    select t.id into loc_id from localization t where lower ( t.code ) = lower ( loc_code );
  end if;

  open cur_lan for select t.id from language t where t.language_status > 0;
  loop
    fetch cur_lan into lan_id;
    exit when cur_lan%NOTFOUND;
    
    select count(1) into counter from i18n_message t where t.language = lan_id and t.localization = loc_id;
    if ( counter = 0 ) then
      insert into i18n_message ( id, localization, language, message )
      values ( i18n_message_seq.nextval, loc_id, lan_id, i18n_msg );
    else
      update i18n_message set message = i18n_msg where language = lan_id and localization = loc_id;
    end if;

  end loop;
  close cur_lan;

  open cur_rep for select t.id from report t where t.r_query = rq_id;
  loop
    fetch cur_rep into rep_id;
    exit when cur_rep%NOTFOUND;
    
    select count(1) into counter from report_field t where t.report = rep_id and t.r_query_field = rqf_id;
    if ( counter = 0 ) then
      if ( repf_pos_id is null ) then
        select max ( t.position ) + 1 into repf_pos_id from report_field t where t.report = rep_id;
        if ( repf_pos_id is null ) then
          repf_pos_id := 0;
        end if;
      else
        select count(1) into counter from report_field t where t.report = rep_id and position = repf_pos_id;
        if ( counter > 0 ) then
          --modificare le posizioni del corrente e dei successivi
          update report_field set position = ( position + 1 ) where report = rep_id and position >= repf_pos_id;
        end if;
      end if;
      
      if ( rqf_ord_by = 1 ) then
        select max(t.order_by) + 1 into rqf_ord_pos from report_field t where t.report = rep_id;
        if ( rqf_ord_pos is null ) then
          rqf_ord_pos := 0;
        end if;
      else
        rqf_ord_by_clau := null;
      end if;

      insert into report_field ( id, report, r_query_field, localization, width, position, order_by, order_by_clause )
      values ( report_field_seq.nextval, rep_id, rqf_id, loc_id, rqf_width, repf_pos_id, rqf_ord_pos, rqf_ord_by_clau );
    elsif ( counter = 1 and repf_pos_id is not null ) then
      select t.position into repf_pos_id_old from report_field t where t.report = rep_id and t.r_query_field = rqf_id;
      --spostiamo il campo in una posizione speciale
      update report_field set position = -1 where report = rep_id and position = repf_pos_id_old;
      if ( repf_pos_id_old > repf_pos_id ) then
        update report_field set position = ( position + 1 ) where report = rep_id and position >= repf_pos_id and position <= repf_pos_id_old;
      else
        update report_field set position = ( position - 1 ) where report = rep_id and position >= repf_pos_id_old and position <= repf_pos_id;
      end if;
      --spostiamo il campo in una posizione finale
      update report_field set position = repf_pos_id where report = rep_id and position = -1;
    end if;
    
    update report_field set width = rqf_width where report = rep_id;
  end loop;
  close cur_rep;
  --QUERY FIELD 1: END

end;
/

commit;
