declare
  counter          number(16);
  
  rq_id            number(16);
  rq_name          varchar2(256) := 'User violations DB';
  
  rqf_type_def     varchar2(256) := 'java.lang.String';
  rqf_width_def    number(16) := 300;

  rqf_id           number(16);
  rqf_name_old     varchar2(256);
  rqf_name         varchar2(256);
  rqf_type         varchar2(256);
  rqf_width        number(16);
  rqf_ord_by       number(1);
  rqf_ord_by_clau  varchar2(256);
  rqf_ord_pos      number(16);
  loc_id           number(16);
  loc_code_old     varchar2(256);
  loc_code         varchar2(256);
  loc_rename       boolean;
  i18n_msg         varchar2(256);
  repf_pos_id      number(16);
  repf_pos_id_old  number(16);

  --Si puo' modificare un campo esistente, se null si inserisce
  rqf_name1_old    varchar2(256) := null;
  rqf_name1        varchar2(256) := 'USER_CODE';
  rqf_type1        varchar2(256) := rqf_type_def;
  rqf_width1       varchar2(256) := rqf_width_def;
  rqf_ord_by1      number(1)     := 0;
  rqf_ord_by_clau1 varchar2(256) := 'ASC';
  --Si puo' modificare un campo esistente, se null si inserisce
  loc_code1_old    varchar2(256) := 'user.code';
  loc_code1        varchar2(256) := 'dashboard.user.code';
  loc_rename1      boolean       := false;
  i18n_msg1        varchar2(256) := 'User Id';
  --Si puo' scegliere la posizione della colonna nel report. Gli indici iniziano da 0
  --Se il campo e' null viene lasciato per ultimo
  repf_pos_id1     number(16)    := null;

  cur_lan          sys_refcursor;
  lan_id           number(16);
  
  cur_rep          sys_refcursor;
  rep_id           number(16);
begin
  select count(1) into counter from r_query t where lower ( t.name ) = lower ( rq_name );
  if ( counter = 1 ) then
    select t.id into rq_id from r_query t where lower ( t.name ) = lower ( rq_name );
  else
    return;
  end if;

  --QUERY FIELD 1: BEGIN
  rqf_id          := null;
  rqf_name_old    := rqf_name1_old;
  rqf_name        := rqf_name1;
  rqf_type        := rqf_type1;
  rqf_width       := rqf_width1;
  rqf_ord_by      := rqf_ord_by1;
  rqf_ord_by_clau := rqf_ord_by_clau1;
  rqf_ord_pos     := null;
  loc_id          := null;
  loc_code_old    := loc_code1_old;
  loc_code        := loc_code1;
  loc_rename      := loc_rename1;
  i18n_msg        := i18n_msg1;
  repf_pos_id_old := null;
  repf_pos_id     := repf_pos_id1;
    
  if ( rqf_name_old is null or rqf_name_old = rqf_name ) then
    select count(1) into counter from r_query_field t where t.r_query = rq_id and lower ( t.column_name ) = lower ( rqf_name );
    if ( counter = 0 ) then
      select r_query_field_seq.nextval into rqf_id from dual;
      
      insert into r_query_field ( id, r_query, column_name, title, type, width )
      values ( rqf_id, rq_id, rqf_name, loc_code, rqf_type, rqf_width );
    end if;
  elsif ( rqf_name_old is not null and rqf_name_old <> rqf_name ) then
    select count(1) into counter from r_query_field t where t.r_query = rq_id and lower ( t.column_name ) = lower ( rqf_name_old );
    if ( counter = 1 ) then
      select t.id into rqf_id from r_query_field t where t.r_query = rq_id and lower ( t.column_name ) = lower ( rqf_name_old );
      update r_query_field set column_name = rqf_name where id = rqf_id;
    end if;  
  end if;
  if ( rqf_id is null ) then
    select t.id into rqf_id from r_query_field t where t.r_query = rq_id and lower ( t.column_name ) = lower ( rqf_name );
  end if;
  
  if ( loc_code_old is null or loc_code_old = loc_code ) then
    select count(1) into counter from localization t where lower ( t.code ) = lower ( loc_code );
    if ( counter = 0 ) then
      select localization_seq.nextval into loc_id from dual;
      
      insert into localization ( id, code, code_type )
      values ( loc_id, loc_code, 0 );
    end if;
  elsif ( loc_code_old is not null and loc_code_old <> loc_code ) then
    if ( loc_rename = true ) then
      select count(1) into counter from localization t where lower ( t.code ) = lower ( loc_code_old );
      if ( counter = 1 ) then
        select count(1) into counter from localization t where lower ( t.code ) = lower ( loc_code );
        if ( counter = 0 ) then
          select t.id into loc_id from localization t where lower ( t.code ) = lower ( loc_code_old );
          update localization set code = loc_code where id = loc_id;
        end if;
        update r_query_field set title = loc_code where id = rqf_id;
      end if;
    else
      select count(1) into counter from localization t where lower ( t.code ) = lower ( loc_code_old );
      if ( counter = 1 ) then
        select count(1) into counter from localization t where lower ( t.code ) = lower ( loc_code );
        if ( counter = 0 ) then
          select localization_seq.nextval into loc_id from dual;
          
          insert into localization ( id, code, code_type )
          values ( loc_id, loc_code, 0 );
        end if;
        update r_query_field set title = loc_code where id = rqf_id;
      end if;
    end if;
  end if;
  if ( loc_id is null ) then
    select t.id into loc_id from localization t where lower ( t.code ) = lower ( loc_code );
  end if;

  open cur_lan for select t.id from language t where t.language_status > 0;
  loop
    fetch cur_lan into lan_id;
    exit when cur_lan%NOTFOUND;
    
    select count(1) into counter from i18n_message t where t.language = lan_id and t.localization = loc_id;
    if ( counter = 0 ) then
      insert into i18n_message ( id, localization, language, message )
      values ( i18n_message_seq.nextval, loc_id, lan_id, i18n_msg );
    else
      update i18n_message set message = i18n_msg where language = lan_id and localization = loc_id;
    end if;

  end loop;
  close cur_lan;

  open cur_rep for select t.id from report t where t.r_query = rq_id;
  loop
    fetch cur_rep into rep_id;
    exit when cur_rep%NOTFOUND;
    
    select count(1) into counter from report_field t where t.report = rep_id and t.r_query_field = rqf_id;
    if ( counter = 0 ) then
      if ( repf_pos_id is null ) then
        select max ( t.position ) + 1 into repf_pos_id from report_field t where t.report = rep_id;
        if ( repf_pos_id is null ) then
          repf_pos_id := 0;
        end if;
      else
        select count(1) into counter from report_field t where t.report = rep_id and position = repf_pos_id;
        if ( counter > 0 ) then
          --modificare le posizioni del corrente e dei successivi
          update report_field set position = ( position + 1 ) where report = rep_id and position >= repf_pos_id;
        end if;
      end if;
      
      if ( rqf_ord_by = 1 ) then
        select max(t.order_by) + 1 into rqf_ord_pos from report_field t where t.report = rep_id;
        if ( rqf_ord_pos is null ) then
          rqf_ord_pos := 0;
        end if;
      else
        rqf_ord_by_clau := null;
      end if;

      insert into report_field ( id, report, r_query_field, localization, width, position, order_by, order_by_clause )
      values ( report_field_seq.nextval, rep_id, rqf_id, loc_id, rqf_width, repf_pos_id, rqf_ord_pos, rqf_ord_by_clau );
    elsif ( counter = 1 and repf_pos_id is not null ) then
      select t.position into repf_pos_id_old from report_field t where t.report = rep_id and t.r_query_field = rqf_id;
      --spostiamo il campo in una posizione speciale
      update report_field set position = -1 where report = rep_id and position = repf_pos_id_old;
      if ( repf_pos_id_old > repf_pos_id ) then
        update report_field set position = ( position + 1 ) where report = rep_id and position >= repf_pos_id and position <= repf_pos_id_old;
      else
        update report_field set position = ( position - 1 ) where report = rep_id and position >= repf_pos_id_old and position <= repf_pos_id;
      end if;
      --spostiamo il campo in una posizione finale
      update report_field set position = repf_pos_id where report = rep_id and position = -1;
      update report_field set localization = loc_id where report = rep_id and r_query_field = rqf_id;
    end if;
    
    if ( loc_rename = false ) then
      update report_field set localization = loc_id where report = rep_id and r_query_field = rqf_id;
    end if;

    update report_field set width = rqf_width where report = rep_id;
  end loop;
  close cur_rep;
  --QUERY FIELD 1: END

end;
/
commit;
