declare
  counter          numeric(16);
  idx              numeric(16);
  
  r_id             numeric(16);
  ra_id            numeric(16);
  ra_name          varchar(256);
  ra_value         varchar(256);
  
  cur              sys_refcursor;
  cur_ra           sys_refcursor;
begin
  open cur for
    select t.report, t.name, t.value, count(1) from report_attribute t group by t.report, t.name, t.value having count(1) > 1;
  loop
    fetch cur into r_id, ra_name, ra_value, counter;
    exit when cur%NOTFOUND;
    
    open cur_ra for 
      select t.id from report_attribute t where t.report = r_id and t.name = ra_name and t.value = ra_value order by id desc;
        idx := 1;
        loop
          fetch cur_ra into ra_id;
          exit when cur_ra%NOTFOUND or idx >= counter;
          delete from report_attribute where id = ra_id;
          idx :=idx + 1;
        end loop;
     close cur_ra;
  end loop;
  close cur;
end;
/
commit;

declare
  r_name            varchar(256) := 'IDEAS Report Visibility';
  ra_name           varchar(256) := 'EMAIL_TEMPLATE_NAME';
  ra_value          varchar(256) := 'Report';

  counter           numeric(16);
  ra_id             numeric(16);

  cur               sys_refcursor;
begin
  select count(1) into counter from report r, report_attribute ra where r.id = ra.report and lower ( r.name ) = lower ( r_name )
  and lower ( ra.name ) = lower ( ra_name ) and lower ( ra.value ) not in lower ( ra_value );
  if ( counter > 0 ) then
    open cur for
      select ra.id from report r, report_attribute ra where r.id = ra.report and lower ( r.name ) = lower ( r_name )
      and lower ( ra.name ) = lower ( ra_name ) and lower ( ra.value ) not in lower ( ra_value );
    loop
      fetch cur into ra_id;
      exit when cur%NOTFOUND;
      delete from report_attribute where id = ra_id;
    end loop;
    close cur;
  end if;  
end;
/
commit;

declare
  r_name            varchar(256) := 'Certification  - Status summary by OU';
  ra_name           varchar(256) := 'EMAIL_TEMPLATE_NAME';
  ra_value          varchar(256) := 'Campaign Started';

  counter           numeric(16);
  ra_id             numeric(16);

  cur               sys_refcursor;
begin
  select count(1) into counter from report r, report_attribute ra where r.id = ra.report and lower ( r.name ) = lower ( r_name )
  and lower ( ra.name ) = lower ( ra_name ) and lower ( ra.value ) not in lower ( ra_value );
  if ( counter > 0 ) then
    open cur for
      select ra.id from report r, report_attribute ra where r.id = ra.report and lower ( r.name ) = lower ( r_name )
      and lower ( ra.name ) = lower ( ra_name ) and lower ( ra.value ) not in lower ( ra_value );
    loop
      fetch cur into ra_id;
      exit when cur%NOTFOUND;
      delete from report_attribute where id = ra_id;
    end loop;
    close cur;
  end if;  
end;
/
commit;

declare
  r_name            varchar(256) := 'User Violations Count';
  ra_name           varchar(256) := 'EMAIL_TEMPLATE_NAME';
  ra_value          varchar(256) := 'Report';

  counter           numeric(16);
  ra_id             numeric(16);

  cur               sys_refcursor;
begin
  select count(1) into counter from report r, report_attribute ra where r.id = ra.report and lower ( r.name ) = lower ( r_name )
  and lower ( ra.name ) = lower ( ra_name ) and lower ( ra.value ) not in lower ( ra_value );
  if ( counter > 0 ) then
    open cur for
      select ra.id from report r, report_attribute ra where r.id = ra.report and lower ( r.name ) = lower ( r_name )
      and lower ( ra.name ) = lower ( ra_name ) and lower ( ra.value ) not in lower ( ra_value );
    loop
      fetch cur into ra_id;
      exit when cur%NOTFOUND;
      delete from report_attribute where id = ra_id;
    end loop;
    close cur;
  end if;  
end;
/
commit;

set define off
declare
  r_name            varchar(256) := 'Business activity mapping status';
  ra_name           varchar(256) := 'DRILL_FILTER';
  ra_value          varchar(256) := 'status,$application';

  counter           numeric(16);
  ra_id             numeric(16);

  cur               sys_refcursor;
begin
  select count(1) into counter from report r, report_attribute ra where r.id = ra.report and lower ( r.name ) = lower ( r_name )
  and lower ( ra.name ) = lower ( ra_name ) and lower ( ra.value ) not in lower ( ra_value );
  if ( counter > 0 ) then
    open cur for
      select ra.id from report r, report_attribute ra where r.id = ra.report and lower ( r.name ) = lower ( r_name )
      and lower ( ra.name ) = lower ( ra_name ) and lower ( ra.value ) not in lower ( ra_value );
    loop
      fetch cur into ra_id;
      exit when cur%NOTFOUND;
      delete from report_attribute where id = ra_id;
    end loop;
    close cur;
  end if;  
end;
/
commit;
set define on
