declare
  r_name_old           varchar(256) := 'Technical transformation status';
  r_name               varchar(256) := 'Business activity mapping status';
  --se 0  un report, se 1  un dashboard
  r_dashboard          numeric(1) := 1;

  rq_name_old          varchar(256) := 'Technical transformation status DB';
  rq_name              varchar(256) := 'Business activity mapping status DB';

  r_rename             boolean := false;
  rq_rename            boolean := false;

  r_id                 numeric(16);
  rq_id                numeric(16);

  counter              numeric(16);
begin
  --sezione query
  if ( rq_name <> rq_name_old ) then
    select count(1) into counter from r_query t where lower ( t.name ) = lower ( rq_name_old ) and t.product = 1;
    if ( counter = 1 ) then
      rq_rename := true;
    end if;
  end if;

  if ( rq_rename = true ) then
    select count(1) into counter from r_query t where lower ( t.name ) = lower ( rq_name_old ) and t.product = 1;
  else
    select count(1) into counter from r_query t where lower ( t.name ) = lower ( rq_name ) and t.product = 1;
  end if;

  if ( r_name <> r_name_old ) then
    select count(1) into counter from report t where lower ( t.name ) = lower ( r_name_old ) and t.dashboard = r_dashboard and t.product = 1;
    if ( counter = 1 ) then
      r_rename := true;
    end if;
  end if;

  if ( r_rename = true ) then
    select count(1) into counter from report t where lower ( t.name ) = lower ( r_name_old ) and t.dashboard = r_dashboard and t.product = 1;
  else
    select count(1) into counter from report t where lower ( t.name ) = lower ( r_name ) and t.dashboard = r_dashboard and t.product = 1;
  end if;

  select t.id, t.r_query into r_id, rq_id from report t where lower ( t.name ) = lower ( r_name ) and t.dashboard = r_dashboard;

  select count(1) into counter from r_query_field t where t.r_query = rq_id;
  if ( counter > 0 ) then
    delete from r_query_field where r_query = rq_id;
  end if;

  select count(1) into counter from r_query_visibility t where t.r_query = rq_id;
  if ( counter > 0 ) then
    delete from r_query_visibility where r_query = rq_id;
  end if;

  select count(1) into counter from report_visibility t where t.report = r_id;
  if ( counter > 0 ) then
    delete from report_visibility where report = r_id;
  end if;

  select count(1) into counter from report_filter t where t.report = r_id;
  if ( counter > 0 ) then
    delete from report_filter where report = r_id;
  end if;
end;
/
commit;

declare
  counter              numeric(16);
  
  --report type
  rt_id                numeric(16);
  rt_name              varchar(256) := '';
  rt_desc              varchar(512) := '';

  --report parent
  rp_id                numeric(16);
  rp_name              varchar(256) := '';

  r_id                 numeric(16);
  r_name_old           varchar(256) := 'Technical transformation status';
  r_name               varchar(256) := 'Business activity mapping status';
  r_desc               varchar(512) := '';
  r_code               varchar(256) := null;
  r_i18n_mess          varchar(256) := null;
  --se 0  un report, se 1  un dashboard
  r_dashboard          numeric(1) := 1;
  
  ra_name01            varchar(256) := 'CHART';
  ra_value01           varchar(256) := '2';

  ra_id                numeric(16);
  ra_name              varchar(256);
  ra_value             varchar(256);

  r_loc_id             numeric(16);
  r_loc_code           varchar(256);

  r_rename             boolean := false;

  rq_id                numeric(16);
  rq_name_old          varchar(256) := 'Technical transformation status DB';
  rq_name              varchar(256) := 'Business activity mapping status DB';
  rq_desc              varchar(512) := '';
  rqd                  clob;

  rq_rename            boolean := false;

  rv_name01            varchar(256) := 'AG-Core Application';
  repv_vis_type01      numeric(2) := 3;

  rv_id                numeric(16);
  rv_name              varchar(256);
  rv_ent_id            numeric(16);
  repv_vis_type        numeric(2);
  rq_vis_pos           numeric(16);

  rqf_type_def         varchar(256) := 'java.lang.String';
  rqf_width_def        numeric(16) := 300;

  rqf_id               numeric(16);
  rqf_name_old         varchar(256);
  rqf_name             varchar(256);
  rqf_type             varchar(256);
  rqf_width            numeric(16);
  rqf_ord_by           numeric(1);
  rqf_ord_by_clau      varchar(256);
  rqf_ord_pos          numeric(16);
  loc_id               numeric(16);
  loc_code_old         varchar(256);
  loc_code             varchar(256);
  loc_rename           boolean;
  i18n_msg             varchar(256);
  repf_pos_id          numeric(16);
  repf_pos_id_old      numeric(16);

  --Si puo' modificare un campo esistente, se null si inserisce
  rqf_name01_old       varchar(256) := null;
  rqf_name01           varchar(256) := 'PERMISSION_STATUS';
  rqf_type01           varchar(256) := rqf_type_def;
  rqf_width01          varchar(256) := rqf_width_def;
  rqf_ord_by01         numeric(1)     := 0;
  rqf_ord_by_clau01    varchar(256) := 'ASC';
  --Si puo' modificare un campo esistente, se null si inserisce
  loc_code01_old       varchar(256) := null;
  loc_code01           varchar(256) := 'permission.status';
  loc_rename01         boolean       := true;
  i18n_msg01           varchar(256) := 'Permission Status';
  --Si puo' scegliere la posizione della colonna nel report. Gli indici iniziano da 0
  --Se il campo e' null viene lasciato per ultimo
  repf_pos_id01        numeric(16)    := null;

  --Si puo' modificare un campo esistente, se null si inserisce
  rqf_name02_old       varchar(256) := null;
  rqf_name02           varchar(256) := 'PERMISSION_COUNT';
  rqf_type02           varchar(256) := rqf_type_def;
  rqf_width02          varchar(256) := rqf_width_def;
  rqf_ord_by02         numeric(1)     := 0;
  rqf_ord_by_clau02    varchar(256) := 'ASC';
  --Si puo' modificare un campo esistente, se null si inserisce
  loc_code02_old       varchar(256) := null;
  loc_code02           varchar(256) := 'permission.count';
  loc_rename02         boolean       := true;
  i18n_msg02           varchar(256) := 'Permission Count';
  --Si puo' scegliere la posizione della colonna nel report. Gli indici iniziano da 0
  --Se il campo e' null viene lasciato per ultimo
  repf_pos_id02        numeric(16)    := null;

  repfr_id             numeric(16);
  repfr_name_old       varchar(256);
  repfr_name           varchar(256);
  repfr_value          varchar(256);
  repfr_l_id           numeric(16);
  repfr_l_code_old     varchar(256);
  repfr_l_code         varchar(256);
  repfr_i18n_msg       varchar(256);
  repfr_vis            numeric(16);
  repfr_mand           numeric(16);
  repfr_type           numeric(16);
  repfr_cust_id        numeric(16);
  repfr_cust_name      varchar(256);
  repfr_pos_id         numeric(16);
  repfr_pos_id_old     numeric(16);

  --Si puo' modificare un campo esistente, se null si inserisce
  repfr_name01_old     varchar(256);
  repfr_name01         varchar(256) := 'application_name';
  repfr_value01        varchar(256) := null;
  --Si puo' modificare un campo esistente, se null si inserisce
  repfr_l_code01_old   varchar(256) := null;
  repfr_l_code01       varchar(256) := 'application.name';
  repfr_i18n_msg01     varchar(256) := 'Application';
  repfr_vis01          numeric(16)    := 0;
  repfr_mand01         numeric(16)    := 0;
  repfr_type01         numeric(16)    := 0;
  repfr_cust_name01    varchar(256) := null;
  --Si puo' scegliere la posizione del filtro nel report. Gli indici iniziano da 0
  --Se il campo e' null viene lasciato per ultimo
  repfr_pos_id01       numeric(16);
  repfr_pos_id01_old   numeric(16);

  cur_lan              sys_refcursor;
  lan_id               numeric(16);

  cur_rep              sys_refcursor;
  rep_id               numeric(16);

begin
  rqd := 'select
'||'  t.permission_status,
'||'  count(1) as permission_count
'||'from
'||'(
'||'  select
'||'  --t.permission_id,
'||'   case
'||'     when t.permission_status = 0 then ''TBD''
'||'     when t.permission_status = 1 then ''Linked''
'||'     when t.permission_status = 2 then ''Ignored''
'||'     when t.permission_status = 3 then ''Missing Activities''
'||'     else ''-''
'||'   end as permission_status,
'||'  --t.permission as ''permission_name'',
'||'  --t.permission_description as permission_desc,
'||'  t.application_name as application_name,
'||'  --t.permission_type_name as profile_type,
'||'  --tp.activity as activity_name,
'||'  --tp.activity_path as activity_path,
'||'  tp.activity_code as activity_code--,
'||'  --tp.env_id,
'||'  --t.permission_code
'||'    from (select e.id     as permission_id,
'||'          e.state         as permission_status,
'||'          --e.name        as permission,
'||'          --e.code        as permission_code,
'||'          --e.description as permission_description,
'||'          a.name        as application_name--,
'||'          --pt.name       as permission_type_name
'||'            from #pmschema#.entitlement  e,
'||'                 #schema_tmp#.tmp_rep_application tmpa,
'||'                 #pmschema#.application  a,
'||'                 #pmschema#.profile_type pt
'||'           where e.ext_type = a.sod_ext_level
'||'             and e.application = tmpa.id
'||'             and tmpa.id = a.id
'||'             and e.profile_type = pt.id
'||'             and e.administrative = 0
'||'             and pt.application = a.id
'||'             and e.state in (0, 1, 2, 3)) t
'||'    left outer join (select distinct tp.profile,
'||'                                     tp.task,
'||'                                     --t.name as activity,
'||'                                     --t.path as activity_path,
'||'                                     t.code as activity_code,
'||'                                     env.id as env_id
'||'                       from (select pgr.profile, t.task, t.environment
'||'                               from #pmschema#.profile_group pgr,
'||'                                    (select tp.task, pg.root, tp.environment
'||'                                       from #pmschema#.task_profile  tp,
'||'                                            #pmschema#.entitlement   e,
'||'                                            #pmschema#.profile_group pg
'||'                                      where e.int_type = 0
'||'                                        and tp.profile = e.id
'||'                                        and e.administrative = 0
'||'                                        and e.id = pg.profile) t
'||'                              where pgr.root = t.root
'||'                                and pgr.type = 3
'||'                             union
'||'                             select tp.profile, tp.task, tp.environment
'||'                               from #pmschema#.task_profile tp,
'||'                                    #pmschema#.entitlement  e,
'||'                                    #pmschema#.application  a
'||'                              where e.application = a.id
'||'                                and e.ext_type = a.sod_ext_level
'||'                                and e.administrative = 0
'||'                                and tp.profile = e.id) tp,
'||'                            #pmschema#.environment env,
'||'                            #pmschema#.task t
'||'                      where env.working = 1
'||'                        and env.id = tp.environment
'||'                        and tp.environment = t.environment
'||'                        and tp.task = t.id) tp on tp.profile = t.permission_id
'||'   where 1 = 1
'||'     and lower ( t.application_name ) like lower ( ''#application_name#'' )
'||') t
'||'group by t.permission_status
'||'';

  --sezione query
  if ( rq_name <> rq_name_old ) then
    select count(1) into counter from r_query t where lower ( t.name ) = lower ( rq_name_old ) and t.product = 1;
    if ( counter = 1 ) then
      rq_rename := true;
    end if;
  end if;

  if ( rq_rename = true ) then
    select count(1) into counter from r_query t where lower ( t.name ) = lower ( rq_name_old ) and t.product = 1;
  else
    select count(1) into counter from r_query t where lower ( t.name ) = lower ( rq_name ) and t.product = 1;
  end if;
  if ( counter = 0 ) then
    select max(id) + 1 into rq_id from r_query t;

    insert into r_query ( id, name, description, product )
    values ( rq_id, rq_name, rq_desc, 1 );

    insert into r_query_data ( r_query, query )
    values ( rq_id, rqd );
  else
    if ( rq_rename = true ) then
      select t.id into rq_id from r_query t where lower ( t.name ) = lower ( rq_name_old ) and t.product = 1;
    else
      select t.id into rq_id from r_query t where lower ( t.name ) = lower ( rq_name ) and t.product = 1;
    end if;
    
    update r_query_data set query = rqd where r_query = rq_id;
  end if;
  
  --modifica il nome della query
  if ( rq_rename = true ) then
    update r_query set name = rq_name where id = rq_id;
  end if;
  
  --sezione report
  if ( r_name <> r_name_old ) then
    select count(1) into counter from report t where lower ( t.name ) = lower ( r_name_old ) and t.dashboard = r_dashboard and t.product = 1;
    if ( counter = 1 ) then
      r_rename := true;
    end if;
  end if;

  if ( r_rename = true ) then
    select count(1) into counter from report t where lower ( t.name ) = lower ( r_name_old ) and t.dashboard = r_dashboard and t.product = 1;
  else
    select count(1) into counter from report t where lower ( t.name ) = lower ( r_name ) and t.dashboard = r_dashboard and t.product = 1;
  end if;
  if ( counter = 0 ) then
    --localization code for report
    if ( r_loc_code is null ) then
      /*DBALT-BEGIN*/
      /*select dbms_random.random into r_loc_code from dual;*/
      /*PG*select trunc(random()*1000) into r_loc_code from generate_series(1,1000) limit 1;*PG*/
      select int((rand()-0.5) * 32768) into r_loc_code from dual;
      /*DBALT-END*/

      select count(1) into counter from localization t where lower ( t.code ) = lower ( r_loc_code );
      if ( counter = 0 ) then
        select localization_seq.nextval into r_loc_id from dual;
        
        insert into localization ( id, code, code_type )
        values ( r_loc_id, r_loc_code, 0 );
      end if;
    elsif ( r_loc_code is not null ) then
      select count(1) into counter from localization t where lower ( t.code ) = lower ( r_loc_code );
      if ( counter = 1 ) then
        select t.id into r_loc_id from localization t where lower ( t.code ) = lower ( r_loc_code );
      end if;
    end if;
    if ( r_loc_id is null ) then
      select t.id into r_loc_id from localization t where lower ( t.code ) = lower ( r_loc_code );
    end if;

    select max(id) + 1 into r_id from report t;
    
    if ( rt_name is not null or length ( rt_name ) > 0 ) then
      select count(1) into counter from report_type t where lower ( t.name ) = lower ( rt_name );
      if ( counter = 0 ) then
        select ( max(id) +1 ) into rt_id from report_type t;

        insert into report_type ( id, name, description )
        values ( rt_id, rt_name, rt_desc );
      else
        select t.id into rt_id from report_type t where lower ( t.name ) = lower ( rt_name );
      end if;
    end if;


    insert into report ( id, name, description, localization, r_query, status, report_type, code, product, parent, dashboard )
    values ( r_id, r_name, r_desc, r_loc_id, rq_id, 0, rt_id, r_code, 1, 1, r_dashboard );
    
    insert into report_attribute ( id, report, name, value )
    values ( report_attribute_seq.nextval, r_id, 'PRIORITY', '0' );
    if ( r_dashboard = 0 ) then 
      insert into report_attribute ( id, report, name, value )
      values ( report_attribute_seq.nextval, r_id, 'ORIENTATION', '1' );
      insert into report_attribute ( id, report, name, value )
      values ( report_attribute_seq.nextval, r_id, 'MAX_ROW', null );
      insert into report_attribute ( id, report, name, value )
      values ( report_attribute_seq.nextval, r_id, 'FORMAT', 'pdf' );
      insert into report_attribute ( id, report, name, value )
      values ( report_attribute_seq.nextval, r_id, 'FORMAT', 'xlsx' );
    elsif ( r_dashboard = 1 ) then
      null;
    end if;    
  else
    --ORACLE BUG ON REPORT_LNAME_DASHBOARD_IDX INDEX
    --ORA-03113 end-of-file on communication channel
    --caused by
    --ORA-07445: trovata eccezione: dump della memoria [qcdlgcd()+70] [SIGSEGV] [ADDR:0x4] [PC:0xCEA8796] [Address not mapped to object] []
    if ( r_rename = true ) then
      select t.id, t.name into r_id, r_name_old from report t where lower ( t.name ) = lower ( r_name_old ) and t.dashboard = r_dashboard and t.product = 1;
    else
      select t.id, t.name into r_id, r_name from report t where lower ( t.name ) = lower ( r_name ) and t.dashboard = r_dashboard and t.product = 1;
    end if;
    
    select t.localization into r_loc_id from report t where t.id = r_id;
  end if;

  if ( r_i18n_mess is null or length ( r_i18n_mess ) = 0 ) then
    r_i18n_mess := r_name;
  end if;

  --modifica il nome del report
  if ( r_rename = true ) then
    update report set name = r_name where id = r_id;
    update i18n_message set message = r_i18n_mess where localization = ( select t.localization from report t where t.id = r_id );
  end if;
  
  --inserimento o modifica dei messaggi di localizzazione
  open cur_lan for select t.id from language t where t.language_status > 0;
  loop
    fetch cur_lan into lan_id;
    exit when cur_lan%NOTFOUND;
      
    select count(1) into counter from i18n_message t where t.language = lan_id and t.localization = r_loc_id;
    if ( counter = 0 ) then
      insert into i18n_message ( id, localization, language, message )
      values ( i18n_message_seq.nextval, r_loc_id, lan_id, r_i18n_mess );
    else
      update i18n_message set message = r_i18n_mess where language = lan_id and localization = r_loc_id;
    end if;

  end loop;
  close cur_lan;

  --report parent
  select count(1) into counter from (
    select distinct r.id from report r, localization l, i18n_message i18
    where r.localization = l.id and r.leaf = 0 and l.id = i18.localization
    and i18.message = rp_name and r.dashboard = r_dashboard ) t;
  if ( counter = 1 ) then
    select distinct r.id into rp_id from report r, localization l, i18n_message i18
    where r.localization = l.id and r.leaf = 0 and l.id = i18.localization
    and i18.message = rp_name and r.dashboard = r_dashboard;
    
    update report set parent = rp_id where id = r_id;
  end if;

  --REPORT ATTRIBUTE 01: BEGIN
  ra_name         := ra_name01;
  ra_value        := ra_value01;
  select count(1) into counter from report_attribute t where t.report = r_id and lower ( t.name ) = lower ( ra_name );
  if ( counter = 0 ) then
    insert into report_attribute ( id, report, name, value )
    values ( report_attribute_seq.nextval, r_id, ra_name, ra_value );
  else
    select t.id into ra_id from report_attribute t where t.report = r_id and lower ( t.name ) = lower ( ra_name );
    update report_attribute set value = ra_value where id = ra_id;
  end if;
  --REPORT ATTRIBUTE 01: END

  --QUERY FIELD 01: BEGIN
  rqf_id          := null;
  rqf_name_old    := rqf_name01_old;
  rqf_name        := rqf_name01;
  rqf_type        := rqf_type01;
  rqf_width       := rqf_width01;
  rqf_ord_by      := rqf_ord_by01;
  rqf_ord_by_clau := rqf_ord_by_clau01;
  rqf_ord_pos     := null;
  loc_id          := null;
  loc_code_old    := loc_code01_old;
  loc_code        := loc_code01;
  loc_rename      := loc_rename01;
  i18n_msg        := i18n_msg01;
  repf_pos_id_old := null;
  repf_pos_id     := repf_pos_id01;

  if ( rqf_name_old is null or rqf_name_old = rqf_name ) then
    select count(1) into counter from r_query_field t where t.r_query = rq_id and lower ( t.column_name ) = lower ( rqf_name );
    if ( counter = 0 ) then
      select r_query_field_seq.nextval into rqf_id from dual;
      
      insert into r_query_field ( id, r_query, column_name, title, type, width )
      values ( rqf_id, rq_id, rqf_name, loc_code, rqf_type, rqf_width );
    end if;
  elsif ( rqf_name_old is not null and rqf_name_old <> rqf_name ) then
    select count(1) into counter from r_query_field t where t.r_query = rq_id and lower ( t.column_name ) = lower ( rqf_name_old );
    if ( counter = 1 ) then
      select t.id into rqf_id from r_query_field t where t.r_query = rq_id and lower ( t.column_name ) = lower ( rqf_name_old );
      update r_query_field set column_name = rqf_name where id = rqf_id;
    end if;  
  end if;
  if ( rqf_id is null ) then
    select t.id into rqf_id from r_query_field t where t.r_query = rq_id and lower ( t.column_name ) = lower ( rqf_name );
  end if;
  
  if ( loc_code_old is null or loc_code_old = loc_code ) then
    select count(1) into counter from localization t where lower ( t.code ) = lower ( loc_code );
    if ( counter = 0 ) then
      select localization_seq.nextval into loc_id from dual;
      
      insert into localization ( id, code, code_type )
      values ( loc_id, loc_code, 0 );
    end if;
  elsif ( loc_code_old is not null and loc_code_old <> loc_code ) then
    if ( loc_rename = true ) then
      select count(1) into counter from localization t where lower ( t.code ) = lower ( loc_code_old );
      if ( counter = 1 ) then
        select count(1) into counter from localization t where lower ( t.code ) = lower ( loc_code );
        if ( counter = 0 ) then
          select t.id into loc_id from localization t where lower ( t.code ) = lower ( loc_code_old );
          update localization set code = loc_code where id = loc_id;
        end if;
        update r_query_field set title = loc_code where id = rqf_id;
      end if;
    else
      select count(1) into counter from localization t where lower ( t.code ) = lower ( loc_code_old );
      if ( counter = 1 ) then
        select count(1) into counter from localization t where lower ( t.code ) = lower ( loc_code );
        if ( counter = 0 ) then
          select localization_seq.nextval into loc_id from dual;
          
          insert into localization ( id, code, code_type )
          values ( loc_id, loc_code, 0 );
        end if;
        update r_query_field set title = loc_code where id = rqf_id;
      end if;
    end if;
  end if;
  if ( loc_id is null ) then
    select t.id into loc_id from localization t where lower ( t.code ) = lower ( loc_code );
  end if;

  open cur_lan for select t.id from language t where t.language_status > 0;
  loop
    fetch cur_lan into lan_id;
    exit when cur_lan%NOTFOUND;
    
    select count(1) into counter from i18n_message t where t.language = lan_id and t.localization = loc_id;
    if ( counter = 0 ) then
      insert into i18n_message ( id, localization, language, message )
      values ( i18n_message_seq.nextval, loc_id, lan_id, i18n_msg );
    else
      update i18n_message set message = i18n_msg where language = lan_id and localization = loc_id;
    end if;

  end loop;
  close cur_lan;

  open cur_rep for select t.id from report t where t.r_query = rq_id;
  loop
    fetch cur_rep into rep_id;
    exit when cur_rep%NOTFOUND;
    
    select count(1) into counter from report_field t where t.report = rep_id and t.r_query_field = rqf_id;
    if ( counter = 0 ) then
      if ( repf_pos_id is null ) then
        select max ( t.position ) + 1 into repf_pos_id from report_field t where t.report = rep_id;
        if ( repf_pos_id is null ) then
          repf_pos_id := 0;
        end if;
      else
        select count(1) into counter from report_field t where t.report = rep_id and position = repf_pos_id;
        if ( counter > 0 ) then
          --modificare le posizioni del corrente e dei successivi
          update report_field set position = ( position + 1 ) where report = rep_id and position >= repf_pos_id;
        end if;
      end if;
      
      if ( rqf_ord_by = 1 ) then
        select max(t.order_by) + 1 into rqf_ord_pos from report_field t where t.report = rep_id;
        if ( rqf_ord_pos is null ) then
          rqf_ord_pos := 0;
        end if;
      else
        rqf_ord_by_clau := null;
      end if;

      insert into report_field ( id, report, r_query_field, localization, width, position, order_by, order_by_clause )
      values ( report_field_seq.nextval, rep_id, rqf_id, loc_id, rqf_width, repf_pos_id, rqf_ord_pos, rqf_ord_by_clau );
    elsif ( counter = 1 and repf_pos_id is not null ) then
      select t.position into repf_pos_id_old from report_field t where t.report = rep_id and t.r_query_field = rqf_id;
      --spostiamo il campo in una posizione speciale
      update report_field set position = -1 where report = rep_id and position = repf_pos_id_old;
      if ( repf_pos_id_old > repf_pos_id ) then
        update report_field set position = ( position + 1 ) where report = rep_id and position >= repf_pos_id and position <= repf_pos_id_old;
      else
        update report_field set position = ( position - 1 ) where report = rep_id and position >= repf_pos_id_old and position <= repf_pos_id;
      end if;
      --spostiamo il campo in una posizione finale
      update report_field set position = repf_pos_id where report = rep_id and position = -1;
      update report_field set localization = loc_id where report = rep_id and r_query_field = rqf_id;
    end if;
    
    if ( loc_rename = false ) then
      update report_field set localization = loc_id where report = rep_id and r_query_field = rqf_id;
    end if;

    update report_field set width = rqf_width where report = rep_id;
  end loop;
  close cur_rep;
  --QUERY FIELD 01: END

  --QUERY FIELD 02: BEGIN
  rqf_id          := null;
  rqf_name_old    := rqf_name02_old;
  rqf_name        := rqf_name02;
  rqf_type        := rqf_type02;
  rqf_width       := rqf_width02;
  rqf_ord_by      := rqf_ord_by02;
  rqf_ord_by_clau := rqf_ord_by_clau02;
  rqf_ord_pos     := null;
  loc_id          := null;
  loc_code_old    := loc_code02_old;
  loc_code        := loc_code02;
  loc_rename      := loc_rename02;
  i18n_msg        := i18n_msg02;
  repf_pos_id_old := null;
  repf_pos_id     := repf_pos_id02;

  if ( rqf_name_old is null or rqf_name_old = rqf_name ) then
    select count(1) into counter from r_query_field t where t.r_query = rq_id and lower ( t.column_name ) = lower ( rqf_name );
    if ( counter = 0 ) then
      select r_query_field_seq.nextval into rqf_id from dual;
      
      insert into r_query_field ( id, r_query, column_name, title, type, width )
      values ( rqf_id, rq_id, rqf_name, loc_code, rqf_type, rqf_width );
    end if;
  elsif ( rqf_name_old is not null and rqf_name_old <> rqf_name ) then
    select count(1) into counter from r_query_field t where t.r_query = rq_id and lower ( t.column_name ) = lower ( rqf_name_old );
    if ( counter = 1 ) then
      select t.id into rqf_id from r_query_field t where t.r_query = rq_id and lower ( t.column_name ) = lower ( rqf_name_old );
      update r_query_field set column_name = rqf_name where id = rqf_id;
    end if;  
  end if;
  if ( rqf_id is null ) then
    select t.id into rqf_id from r_query_field t where t.r_query = rq_id and lower ( t.column_name ) = lower ( rqf_name );
  end if;
  
  if ( loc_code_old is null or loc_code_old = loc_code ) then
    select count(1) into counter from localization t where lower ( t.code ) = lower ( loc_code );
    if ( counter = 0 ) then
      select localization_seq.nextval into loc_id from dual;
      
      insert into localization ( id, code, code_type )
      values ( loc_id, loc_code, 0 );
    end if;
  elsif ( loc_code_old is not null and loc_code_old <> loc_code ) then
    if ( loc_rename = true ) then
      select count(1) into counter from localization t where lower ( t.code ) = lower ( loc_code_old );
      if ( counter = 1 ) then
        select count(1) into counter from localization t where lower ( t.code ) = lower ( loc_code );
        if ( counter = 0 ) then
          select t.id into loc_id from localization t where lower ( t.code ) = lower ( loc_code_old );
          update localization set code = loc_code where id = loc_id;
        end if;
        update r_query_field set title = loc_code where id = rqf_id;
      end if;
    else
      select count(1) into counter from localization t where lower ( t.code ) = lower ( loc_code_old );
      if ( counter = 1 ) then
        select count(1) into counter from localization t where lower ( t.code ) = lower ( loc_code );
        if ( counter = 0 ) then
          select localization_seq.nextval into loc_id from dual;
          
          insert into localization ( id, code, code_type )
          values ( loc_id, loc_code, 0 );
        end if;
        update r_query_field set title = loc_code where id = rqf_id;
      end if;
    end if;
  end if;
  if ( loc_id is null ) then
    select t.id into loc_id from localization t where lower ( t.code ) = lower ( loc_code );
  end if;

  open cur_lan for select t.id from language t where t.language_status > 0;
  loop
    fetch cur_lan into lan_id;
    exit when cur_lan%NOTFOUND;
    
    select count(1) into counter from i18n_message t where t.language = lan_id and t.localization = loc_id;
    if ( counter = 0 ) then
      insert into i18n_message ( id, localization, language, message )
      values ( i18n_message_seq.nextval, loc_id, lan_id, i18n_msg );
    else
      update i18n_message set message = i18n_msg where language = lan_id and localization = loc_id;
    end if;

  end loop;
  close cur_lan;

  open cur_rep for select t.id from report t where t.r_query = rq_id;
  loop
    fetch cur_rep into rep_id;
    exit when cur_rep%NOTFOUND;
    
    select count(1) into counter from report_field t where t.report = rep_id and t.r_query_field = rqf_id;
    if ( counter = 0 ) then
      if ( repf_pos_id is null ) then
        select max ( t.position ) + 1 into repf_pos_id from report_field t where t.report = rep_id;
        if ( repf_pos_id is null ) then
          repf_pos_id := 0;
        end if;
      else
        select count(1) into counter from report_field t where t.report = rep_id and position = repf_pos_id;
        if ( counter > 0 ) then
          --modificare le posizioni del corrente e dei successivi
          update report_field set position = ( position + 1 ) where report = rep_id and position >= repf_pos_id;
        end if;
      end if;
      
      if ( rqf_ord_by = 1 ) then
        select max(t.order_by) + 1 into rqf_ord_pos from report_field t where t.report = rep_id;
        if ( rqf_ord_pos is null ) then
          rqf_ord_pos := 0;
        end if;
      else
        rqf_ord_by_clau := null;
      end if;

      insert into report_field ( id, report, r_query_field, localization, width, position, order_by, order_by_clause )
      values ( report_field_seq.nextval, rep_id, rqf_id, loc_id, rqf_width, repf_pos_id, rqf_ord_pos, rqf_ord_by_clau );
    elsif ( counter = 1 and repf_pos_id is not null ) then
      select t.position into repf_pos_id_old from report_field t where t.report = rep_id and t.r_query_field = rqf_id;
      --spostiamo il campo in una posizione speciale
      update report_field set position = -1 where report = rep_id and position = repf_pos_id_old;
      if ( repf_pos_id_old > repf_pos_id ) then
        update report_field set position = ( position + 1 ) where report = rep_id and position >= repf_pos_id and position <= repf_pos_id_old;
      else
        update report_field set position = ( position - 1 ) where report = rep_id and position >= repf_pos_id_old and position <= repf_pos_id;
      end if;
      --spostiamo il campo in una posizione finale
      update report_field set position = repf_pos_id where report = rep_id and position = -1;
      update report_field set localization = loc_id where report = rep_id and r_query_field = rqf_id;
    end if;
    
    if ( loc_rename = false ) then
      update report_field set localization = loc_id where report = rep_id and r_query_field = rqf_id;
    end if;

    update report_field set width = rqf_width where report = rep_id;
  end loop;
  close cur_rep;
  --QUERY FIELD 02: END

  --REPORT FILTER 01: BEGIN
  repfr_id           := null;
  repfr_name_old     := repfr_name01_old;
  repfr_name         := repfr_name01;
  repfr_value        := repfr_value01;
  repfr_l_id         := null;
  repfr_l_code_old   := repfr_l_code01_old;
  repfr_l_code       := repfr_l_code01;
  repfr_i18n_msg     := repfr_i18n_msg01;
  repfr_vis          := repfr_vis01;
  repfr_mand         := repfr_mand01;
  repfr_type         := repfr_type01;
  repfr_cust_id      := null;
  repfr_cust_name    := repfr_cust_name01;
  repfr_pos_id_old   := null;
  repfr_pos_id       := repfr_pos_id01;

  if ( repfr_l_code_old is null or repfr_l_code_old = repfr_l_code ) then
    select count(1) into counter from localization t where lower ( t.code ) = lower ( repfr_l_code );
    if ( counter = 0 ) then
      select localization_seq.nextval into repfr_l_id from dual;
      
      insert into localization ( id, code, code_type )
      values ( repfr_l_id, repfr_l_code, 0 );
    end if;
  elsif ( repfr_l_code_old is not null and repfr_l_code_old <> repfr_l_code ) then
    select count(1) into counter from localization t where lower ( t.code ) = lower ( repfr_l_code_old );
    if ( counter = 1 ) then
      select t.id into repfr_l_id from localization t where lower ( t.code ) = lower ( repfr_l_code_old );
      update localization set code = repfr_l_code where lower ( code ) = lower ( repfr_l_code_old );
      update report_filter set filter = repfr_l_code where lower ( filter ) = lower ( repfr_l_code_old );
    end if;
  end if;
  if ( repfr_l_id is null ) then
    select t.id into repfr_l_id from localization t where lower ( t.code ) = lower ( repfr_l_code );
  end if;

  open cur_lan for select t.id from language t where t.language_status > 0;
  loop
    fetch cur_lan into lan_id;
    exit when cur_lan%NOTFOUND;
    
    select count(1) into counter from i18n_message t where t.language = lan_id and t.localization = repfr_l_id;
    if ( counter = 0 ) then
      insert into i18n_message ( id, localization, language, message )
      values ( i18n_message_seq.nextval, repfr_l_id, lan_id, repfr_i18n_msg );
    else
      update i18n_message set message = repfr_i18n_msg where language = lan_id and localization = repfr_l_id;
    end if;

  end loop;
  close cur_lan;

  open cur_rep for select t.id from report t where t.r_query = rq_id;
  loop
    fetch cur_rep into rep_id;
    exit when cur_rep%NOTFOUND;
    
    if ( repfr_cust_name is not null ) then
      select count(1) into counter from custom_filter t where lower ( t.name ) = lower ( repfr_cust_name );
      if ( counter = 1 ) then
        select t.id into repfr_cust_id from custom_filter t where lower ( t.name ) = lower ( repfr_cust_name );
      end if;
    else
      repfr_cust_id := null;
    end if;
    
    select count(1) into counter from report_filter t where t.report = rep_id and lower ( t.filter ) = lower ( repfr_name );
    if ( counter = 0 ) then
      if ( repfr_pos_id is null ) then
        select max ( t.position ) + 1 into repfr_pos_id from report_filter t where t.report = rep_id;
        if ( repfr_pos_id is null ) then
          repfr_pos_id := 1;
        end if;
      else
        --modificare le posizioni del corrente e dei successivi
        update report_filter set position = ( position + 1 ) where report = rep_id and position >= repfr_pos_id;
      end if;
      
      select report_filter_seq.nextval into repfr_id from dual;

      insert into report_filter ( id, report, filter, value, localization, state, type, position, custom_filter, description, mandatory )
      values ( repfr_id, rep_id, repfr_name, repfr_value, repfr_l_id, repfr_vis, repfr_type, repfr_pos_id, repfr_cust_id, null, repfr_mand );
    elsif ( counter = 1 and repfr_pos_id is not null ) then
      select t.position into repfr_pos_id_old from report_filter t where t.report = rep_id and lower ( t.filter ) = lower ( repfr_name );
      --spostiamo il campo in una posizione speciale
      update report_filter set position = -1 where report = rep_id and position = repfr_pos_id_old;
      if ( repfr_pos_id_old > repfr_pos_id ) then
        update report_filter set position = ( position + 1 ) where report = rep_id and position >= repfr_pos_id and position <= repfr_pos_id_old;
      else
        update report_filter set position = ( position - 1 ) where report = rep_id and position >= repfr_pos_id_old and position <= repfr_pos_id;
      end if;
      --spostiamo il campo in una posizione finale
      update report_filter set position = repfr_pos_id where report = rep_id and position = -1;
    end if;

  end loop;
  close cur_rep;
  --REPORT FILTER 01: END

  --QUERY VISIBILITY AND REPORT VISIBILITY 01: BEGIN
  rv_name := rv_name01;
  repv_vis_type := repv_vis_type01;
  select count (1) into counter from r_visibility rv where lower ( rv.name ) = lower ( rv_name );
  if ( counter = 1 ) then
    select rv.id, rv.entity into rv_id, rv_ent_id from r_visibility rv where lower ( rv.name ) = lower ( rv_name );
    
    --QUERY VISIBILITY
    select count(1) into counter from r_query_visibility rqv where rqv.r_query = rq_id and rqv.r_visibility = rv_id;

    if ( counter = 0 ) then
      select max ( rqv.position ) + 1 into rq_vis_pos from r_query_visibility rqv where rqv.r_query = rq_id and rqv.r_visibility = rv_id;
      if ( rq_vis_pos is null ) then
        rq_vis_pos := 0;
      end if;
      insert into r_query_visibility ( id, r_query, r_visibility, position )
      values ( r_query_visibility_seq.nextval, rq_id, rv_id, rq_vis_pos );
    end if;

    --REPORT VISIBILITY
    select count(1) into counter from report_visibility rv where rv.report = r_id and rv.r_visibility = rv_id;

    if ( counter = 0 ) then
      insert into report_visibility ( id, report, entity, vis_type, r_visibility )
      values ( report_visibility_seq.nextval, r_id, rv_ent_id, repv_vis_type, rv_id );
    end if;
  end if;
  --QUERY VISIBILITY AND REPORT VISIBILITY 01: END

end;
/

commit;
