declare
  r_name_old           varchar2(256) := 'Recent requests';
  r_name               varchar2(256) := 'Recent requests';
  --se 0  un report, se 1  un dashboard
  r_dashboard          number(1) := 1;

  rq_name_old          varchar2(256) := 'Recent requests DB';
  rq_name              varchar2(256) := 'Recent requests DB';

  r_rename             boolean := false;
  rq_rename            boolean := false;

  r_id                 number(16);
  rq_id                number(16);

  counter              number(16);
begin
  --sezione query
  if ( rq_name <> rq_name_old ) then
    select count(1) into counter from r_query t where lower ( t.name ) = lower ( rq_name_old ) and t.product = 1;
    if ( counter = 1 ) then
      rq_rename := true;
    end if;
  end if;

  if ( rq_rename = true ) then
    select count(1) into counter from r_query t where lower ( t.name ) = lower ( rq_name_old ) and t.product = 1;
  else
    select count(1) into counter from r_query t where lower ( t.name ) = lower ( rq_name ) and t.product = 1;
  end if;

  if ( r_name <> r_name_old ) then
    select count(1) into counter from report t where lower ( t.name ) = lower ( r_name_old ) and t.dashboard = r_dashboard and t.product = 1;
    if ( counter = 1 ) then
      r_rename := true;
    end if;
  end if;

  if ( r_rename = true ) then
    select count(1) into counter from report t where lower ( t.name ) = lower ( r_name_old ) and t.dashboard = r_dashboard and t.product = 1;
  else
    select count(1) into counter from report t where lower ( t.name ) = lower ( r_name ) and t.dashboard = r_dashboard and t.product = 1;
  end if;

  select t.id, t.r_query into r_id, rq_id from report t where lower ( t.name ) = lower ( r_name ) and t.dashboard = r_dashboard;

  select count(1) into counter from r_query_field t where t.r_query = rq_id;
  if ( counter > 0 ) then
    delete from r_query_field where r_query = rq_id;
  end if;

  select count(1) into counter from r_query_visibility t where t.r_query = rq_id;
  if ( counter > 0 ) then
    delete from r_query_visibility where r_query = rq_id;
  end if;

  select count(1) into counter from report_visibility t where t.report = r_id;
  if ( counter > 0 ) then
    delete from report_visibility where report = r_id;
  end if;

  select count(1) into counter from report_filter t where t.report = r_id;
  if ( counter > 0 ) then
    delete from report_filter where report = r_id;
  end if;
end;
/
commit;

declare
  counter              number(16);
  
  --report type
  rt_id                number(16);
  rt_name              varchar2(256) := '';
  rt_desc              varchar2(512) := '';

  --report parent
  rp_id                number(16);
  rp_name              varchar2(256) := '';

  r_id                 number(16);
  r_name_old           varchar2(256) := 'Recent requests';
  r_name               varchar2(256) := 'Recent requests';
  r_desc               varchar2(512) := '';
  r_code               varchar2(256) := null;
  r_i18n_mess          varchar2(256) := null;
  --se 0  un report, se 1  un dashboard
  r_dashboard          number(1) := 1;
  
  ra_name01            varchar2(256) := 'CHART';
  ra_value01           varchar2(256) := '0';

  ra_id                number(16);
  ra_name              varchar2(256);
  ra_value             varchar2(256);

  r_loc_id             number(16);
  r_loc_code           varchar2(256);

  r_rename             boolean := false;

  rq_id                number(16);
  rq_name_old          varchar2(256) := 'Recent requests DB';
  rq_name              varchar2(256) := 'Recent requests DB';
  rq_desc              varchar2(512) := '';
  rqd                  clob;

  rq_rename            boolean := false;

  --rv_name01            varchar2(256) := 'AG-Core Org. Unit';
  --repv_vis_type01      number(2) := 3;

  rv_id                number(16);
  rv_name              varchar2(256);
  rv_ent_id            number(16);
  repv_vis_type        number(2);
  rq_vis_pos           number(16);

  rqf_type_def         varchar2(256) := 'java.lang.String';
  rqf_width_def        number(16) := 300;

  rqf_id               number(16);
  rqf_name_old         varchar2(256);
  rqf_name             varchar2(256);
  rqf_type             varchar2(256);
  rqf_width            number(16);
  rqf_ord_by           number(1);
  rqf_ord_by_clau      varchar2(256);
  rqf_ord_pos          number(16);
  loc_id               number(16);
  loc_code_old         varchar2(256);
  loc_code             varchar2(256);
  loc_rename           boolean;
  i18n_msg             varchar2(256);
  repf_pos_id          number(16);
  repf_pos_id_old      number(16);

  --Si puo' modificare un campo esistente, se null si inserisce
  rqf_name01_old       varchar2(256) := null;
  rqf_name01           varchar2(256) := 'REQUEST_TYPE';
  rqf_type01           varchar2(256) := rqf_type_def;
  rqf_width01          varchar2(256) := rqf_width_def;
  rqf_ord_by01         number(1)     := 0;
  rqf_ord_by_clau01    varchar2(256) := 'ASC';
  --Si puo' modificare un campo esistente, se null si inserisce
  loc_code01_old       varchar2(256) := null;
  loc_code01           varchar2(256) := 'request.type';
  loc_rename01         boolean       := true;
  i18n_msg01           varchar2(256) := 'Subject';
  --Si puo' scegliere la posizione della colonna nel report. Gli indici iniziano da 0
  --Se il campo e' null viene lasciato per ultimo
  repf_pos_id01        number(16)    := null;

  --Si puo' modificare un campo esistente, se null si inserisce
  rqf_name02_old       varchar2(256) := null;
  rqf_name02           varchar2(256) := 'REQUEST_STATUS';
  rqf_type02           varchar2(256) := rqf_type_def;
  rqf_width02          varchar2(256) := rqf_width_def;
  rqf_ord_by02         number(1)     := 0;
  rqf_ord_by_clau02    varchar2(256) := 'ASC';
  --Si puo' modificare un campo esistente, se null si inserisce
  loc_code02_old       varchar2(256) := null;
  loc_code02           varchar2(256) := 'dashboard.request.status';
  loc_rename02         boolean       := true;
  i18n_msg02           varchar2(256) := 'Status';
  --Si puo' scegliere la posizione della colonna nel report. Gli indici iniziano da 0
  --Se il campo e' null viene lasciato per ultimo
  repf_pos_id02        number(16)    := null;

  --Si puo' modificare un campo esistente, se null si inserisce
  rqf_name03_old       varchar2(256) := null;
  rqf_name03           varchar2(256) := 'REQUEST_CREATED_ON';
  rqf_type03           varchar2(256) := 'java.util.Date';
  rqf_width03          varchar2(256) := rqf_width_def;
  rqf_ord_by03         number(1)     := 0;
  rqf_ord_by_clau03    varchar2(256) := 'ASC';
  --Si puo' modificare un campo esistente, se null si inserisce
  loc_code03_old       varchar2(256) := null;
  loc_code03           varchar2(256) := 'request.created.on';
  loc_rename03         boolean       := true;
  i18n_msg03           varchar2(256) := 'Request Creation Date';
  --Si puo' scegliere la posizione della colonna nel report. Gli indici iniziano da 0
  --Se il campo e' null viene lasciato per ultimo
  repf_pos_id03        number(16)    := null;

  --Si puo' modificare un campo esistente, se null si inserisce
  rqf_name04_old       varchar2(256) := null;
  rqf_name04           varchar2(256) := 'REQUEST_ENTITY_NAME';
  rqf_type04           varchar2(256) := rqf_type_def;
  rqf_width04          varchar2(256) := rqf_width_def;
  rqf_ord_by04         number(1)     := 0;
  rqf_ord_by_clau04    varchar2(256) := 'ASC';
  --Si puo' modificare un campo esistente, se null si inserisce
  loc_code04_old       varchar2(256) := null;
  loc_code04           varchar2(256) := 'request.entity.name';
  loc_rename04         boolean       := true;
  i18n_msg04           varchar2(256) := 'Request Entity Name';
  --Si puo' scegliere la posizione della colonna nel report. Gli indici iniziano da 0
  --Se il campo e' null viene lasciato per ultimo
  repf_pos_id04        number(16)    := null;

  --Si puo' modificare un campo esistente, se null si inserisce
  rqf_name05_old       varchar2(256) := null;
  rqf_name05           varchar2(256) := 'APPLICANT_CODE';
  rqf_type05           varchar2(256) := rqf_type_def;
  rqf_width05          varchar2(256) := rqf_width_def;
  rqf_ord_by05         number(1)     := 0;
  rqf_ord_by_clau05    varchar2(256) := 'ASC';
  --Si puo' modificare un campo esistente, se null si inserisce
  loc_code05_old       varchar2(256) := null;
  loc_code05           varchar2(256) := 'request.applicant';
  loc_rename05         boolean       := true;
  i18n_msg05           varchar2(256) := 'Initiator';
  --Si puo' scegliere la posizione della colonna nel report. Gli indici iniziano da 0
  --Se il campo e' null viene lasciato per ultimo
  repf_pos_id05        number(16)    := null;

  --Si puo' modificare un campo esistente, se null si inserisce
  rqf_name06_old       varchar2(256) := null;
  rqf_name06           varchar2(256) := 'BENEFICIARY_CODE';
  rqf_type06           varchar2(256) := rqf_type_def;
  rqf_width06          varchar2(256) := rqf_width_def;
  rqf_ord_by06         number(1)     := 0;
  rqf_ord_by_clau06    varchar2(256) := 'ASC';
  --Si puo' modificare un campo esistente, se null si inserisce
  loc_code06_old       varchar2(256) := null;
  loc_code06           varchar2(256) := 'request.beneficiary';
  loc_rename06         boolean       := true;
  i18n_msg06           varchar2(256) := 'Beneficiary';
  --Si puo' scegliere la posizione della colonna nel report. Gli indici iniziano da 0
  --Se il campo e' null viene lasciato per ultimo
  repf_pos_id06        number(16)    := null;

  --Si puo' modificare un campo esistente, se null si inserisce
  rqf_name07_old       varchar2(256) := null;
  rqf_name07           varchar2(256) := 'REQUEST_ID';
  rqf_type07           varchar2(256) := rqf_type_def;
  rqf_width07          varchar2(256) := rqf_width_def;
  rqf_ord_by07         number(1)     := 0;
  rqf_ord_by_clau07    varchar2(256) := 'ASC';
  --Si puo' modificare un campo esistente, se null si inserisce
  loc_code07_old       varchar2(256) := null;
  loc_code07           varchar2(256) := 'request.id';
  loc_rename07         boolean       := true;
  i18n_msg07           varchar2(256) := 'RequestID';
  --Si puo' scegliere la posizione della colonna nel report. Gli indici iniziano da 0
  --Se il campo e' null viene lasciato per ultimo
  repf_pos_id07        number(16)    := null;

  --Si puo' modificare un campo esistente, se null si inserisce
  rqf_name08_old       varchar2(256) := null;
  rqf_name08           varchar2(256) := 'SUB_REQUEST_ID';
  rqf_type08           varchar2(256) := rqf_type_def;
  rqf_width08          varchar2(256) := rqf_width_def;
  rqf_ord_by08         number(1)     := 0;
  rqf_ord_by_clau08    varchar2(256) := 'ASC';
  --Si puo' modificare un campo esistente, se null si inserisce
  loc_code08_old       varchar2(256) := null;
  loc_code08           varchar2(256) := 'request.sub.id';
  loc_rename08         boolean       := true;
  i18n_msg08           varchar2(256) := 'Sub RequestID';
  --Si puo' scegliere la posizione della colonna nel report. Gli indici iniziano da 0
  --Se il campo e' null viene lasciato per ultimo
  repf_pos_id08        number(16)    := null;

  --Si puo' modificare un campo esistente, se null si inserisce
  rqf_name09_old       varchar2(256) := null;
  rqf_name09           varchar2(256) := 'NOTES';
  rqf_type09           varchar2(256) := rqf_type_def;
  rqf_width09          varchar2(256) := rqf_width_def;
  rqf_ord_by09         number(1)     := 0;
  rqf_ord_by_clau09    varchar2(256) := 'ASC';
  --Si puo' modificare un campo esistente, se null si inserisce
  loc_code09_old       varchar2(256) := null;
  loc_code09           varchar2(256) := 'request.notes';
  loc_rename09         boolean       := true;
  i18n_msg09           varchar2(256) := 'Notes';
  --Si puo' scegliere la posizione della colonna nel report. Gli indici iniziano da 0
  --Se il campo e' null viene lasciato per ultimo
  repf_pos_id09        number(16)    := null;

  repfr_id             number(16);
  repfr_name_old       varchar2(256);
  repfr_name           varchar2(256);
  repfr_value          varchar2(256);
  repfr_l_id           number(16);
  repfr_l_code_old     varchar2(256);
  repfr_l_code         varchar2(256);
  repfr_i18n_msg       varchar2(256);
  repfr_vis            number(16);
  repfr_mand           number(16);
  repfr_type           number(16);
  repfr_cust_id        number(16);
  repfr_cust_name      varchar2(256);
  repfr_pos_id         number(16);
  repfr_pos_id_old     number(16);

  --Si puo' modificare un campo esistente, se null si inserisce
  repfr_name01_old     varchar2(256);
  repfr_name01         varchar2(256) := 'day_number';
  repfr_value01        varchar2(256) := '30';
  --Si puo' modificare un campo esistente, se null si inserisce
  repfr_l_code01_old   varchar2(256) := null;
  repfr_l_code01       varchar2(256) := 'day.number';
  repfr_i18n_msg01     varchar2(256) := '# days from today';
  repfr_vis01          number(16)    := 1;
  repfr_mand01         number(16)    := 1;
  repfr_type01         number(16)    := 3;
  repfr_cust_name01    varchar2(256) := null;
  --Si puo' scegliere la posizione del filtro nel report. Gli indici iniziano da 0
  --Se il campo e' null viene lasciato per ultimo
  repfr_pos_id01       number(16);
  repfr_pos_id01_old   number(16);

  cur_lan              sys_refcursor;
  lan_id               number(16);

  cur_rep              sys_refcursor;
  rep_id               number(16);

begin
  rqd := 'select distinct
'||'  case
'||'    when req.req_type = 4 then ''Admin Access Change''
'||'    when req.req_type = 5 then ''User Access Change''
'||'    when req.req_type = 6 then ''Role Assign''
'||'    when req.req_type = 8 then ''Role Removal''
'||'    when req.req_type = 9 then ''Role Renewal''
'||'    when req.req_type = 10 then ''Delegation Assign''
'||'    when req.req_type = 12 then ''Delegation Removal''
'||'    when req.req_type = 13 then ''Delegation Change''
'||'    when req.req_type = 18 then ''Password Reset''
'||'    when req.req_type = 19 then ''Password Change''
'||'    when req.req_type = 32 then ''Account Suspend''
'||'    when req.req_type = 33 then ''Account Restore''
'||'    when req.req_type = 58 then ''Account Management''
'||'    when req.req_type = 61 then ''Delegation Renewal''
'||'    when req.req_type = 70 then ''Entitlement Management''
'||'    when req.req_type = 71 then ''Insert User''
'||'    when req.req_type = 72 then ''Update User''
'||'    when req.req_type = 73 then ''User Delete''
'||'    when req.req_type = 77 then ''Entitlement Create''
'||'    when req.req_type = 78 then ''Entitlement Update''
'||'    when req.req_type = 79 then ''Entitlement Delete''
'||'    when req.req_type = 80 then ''User Management''
'||'    else cast ( req.req_type as varchar2(256) )
'||'  end as request_type,
'||'  case
'||'    when req.req_status = 2 then ''Authorizable''
'||'    when req.req_status = 3 then ''Approved''
'||'    when req.req_status = 4 then ''Suspended''
'||'    when req.req_status = 5 then ''Rejected''
'||'    when req.req_status = 6 then ''Performed''
'||'    when req.req_status = 7 then ''Completed''
'||'    when req.req_status = 8 then ''Failed Completion''
'||'    when req.req_status = 9 then ''Pending ''
'||'    when req.req_status = 10 then ''Escalation''
'||'    when req.req_status = 12 then ''Partially Authorizable''
'||'    when req.req_status = 13 then ''Partially Approved''
'||'    when req.req_status = 14 then ''Partially Executed''
'||'    when req.req_status = 15 then ''Partially Completed''
'||'    when req.req_status = 19 then ''Incompatibility''
'||'    when req.req_status = 30 then ''Terminated pending confirmation''
'||'    when req.req_status = 31 then ''Partially Terminated''
'||'    else cast ( req.req_status as varchar2(256) )
'||'  end request_status,
'||'  req.created_on request_created_on,
'||'  req.entity_name as request_entity_name,
'||'  req.applicant_code,
'||'  req.beneficiary_code,
'||'  req.request_id,
'||'  req.sub_request_id,
'||'  req.notes
'||'from
'||'(
'||'  select
'||'    req.parent as request_id,
'||'    req.id as sub_request_id,
'||'    ben.code as beneficiary_code,
'||'    appl.code as applicant_code,
'||'    req.req_type,
'||'    req.req_status,
'||'    ap.application_name as entity_name,
'||'    req.created_on,
'||'    req.notes
'||'  from
'||'    #pmschema#.person                             ben,
'||'    #pmschema#.person                             appl,
'||'    #swimschema#.request                            req,
'||'    #swimschema#.applications                       ap
'||'  where ben.s_user = req.beneficiary
'||'    and appl.s_user = req.applicant
'||'    and lower ( ben.code ) like lower (''#ideas_userlogged#'')
'||'    and req.id = ap.request
'||'    and req.parent is not null
'||'  union
'||'  select
'||'    req.parent as request_id,
'||'    req.id as sub_request_id,
'||'    ben.code as beneficiary_code,
'||'    appl.code as applicant_code,
'||'    req.req_type,
'||'    req.req_status,
'||'    ro.ent_name as entity_name,
'||'    req.created_on,
'||'    req.notes
'||'  from
'||'    #pmschema#.person                             ben,
'||'    #pmschema#.person                             appl,
'||'    #swimschema#.request                            req,
'||'    #swimschema#.roles                              ro
'||'  where ben.s_user = req.beneficiary
'||'    and appl.s_user = req.applicant
'||'    and lower ( ben.code ) like lower (''#ideas_userlogged#'')
'||'    and req.id = ro.request
'||'    and req.parent is not null
'||'  union
'||'  select
'||'    req.parent as request_id,
'||'    req.id as sub_request_id,
'||'    ben.code as beneficiary_code,
'||'    appl.code as applicant_code,
'||'    req.req_type,
'||'    req.req_status,
'||'    ef.entity as entity_name,
'||'    req.created_on,
'||'    req.notes
'||'  from
'||'    #pmschema#.person                             ben,
'||'    #pmschema#.person                             appl,
'||'    #swimschema#.request                            req,
'||'    #swimschema#.entity_fields                      ef
'||'  where ben.s_user = req.beneficiary
'||'    and appl.s_user = req.applicant
'||'    and lower ( ben.code ) like lower (''#ideas_userlogged#'')
'||'    and req.id = ef.request
'||'    and req.parent is not null
'||'  union
'||'  select distinct
'||'    req.parent as request_id,
'||'    req.id as sub_request_id,
'||'    ben.code as beneficiary_code,
'||'    appl.code as applicant_code,
'||'    req.req_type,
'||'    req.req_status,
'||'    ad.name as entity_name,
'||'    req.created_on,
'||'    req.notes
'||'  from
'||'    #pmschema#.person                             ben,
'||'    #pmschema#.person                             appl,
'||'    #swimschema#.request                            req,
'||'    #swimschema#.additional_data                    ad
'||'  where ben.s_user = req.beneficiary
'||'    and appl.s_user = req.applicant
'||'    and lower ( ben.code ) like lower (''#ideas_userlogged#'')
'||'    and req.id = ad.request
'||'    and req.parent is not null
'||') req
'||'where req.created_on >=
'||'         to_date(extract(year from sysdate - #day_number#) || ''/'' ||
'||'                 extract(month from sysdate - #day_number#) || ''/'' ||
'||'                 extract(day from sysdate - #day_number#) || '' 00:00:01'',  ''yyyy/mm/dd hh24:mi:ss'') 
'||'order by req.created_on asc
'||'';

  --sezione query
  if ( rq_name <> rq_name_old ) then
    select count(1) into counter from r_query t where lower ( t.name ) = lower ( rq_name_old ) and t.product = 1;
    if ( counter = 1 ) then
      rq_rename := true;
    end if;
  end if;

  if ( rq_rename = true ) then
    select count(1) into counter from r_query t where lower ( t.name ) = lower ( rq_name_old ) and t.product = 1;
  else
    select count(1) into counter from r_query t where lower ( t.name ) = lower ( rq_name ) and t.product = 1;
  end if;
  if ( counter = 0 ) then
    select max(id) + 1 into rq_id from r_query t;

    insert into r_query ( id, name, description, product )
    values ( rq_id, rq_name, rq_desc, 1 );

    insert into r_query_data ( r_query, query )
    values ( rq_id, rqd );
  else
    if ( rq_rename = true ) then
      select t.id into rq_id from r_query t where lower ( t.name ) = lower ( rq_name_old ) and t.product = 1;
    else
      select t.id into rq_id from r_query t where lower ( t.name ) = lower ( rq_name ) and t.product = 1;
    end if;
    
    update r_query_data set query = rqd where r_query = rq_id;
  end if;
  
  --modifica il nome della query
  if ( rq_rename = true ) then
    update r_query set name = rq_name where id = rq_id;
  end if;
  
  --sezione report
  if ( r_name <> r_name_old ) then
    select count(1) into counter from report t where lower ( t.name ) = lower ( r_name_old ) and t.dashboard = r_dashboard and t.product = 1;
    if ( counter = 1 ) then
      r_rename := true;
    end if;
  end if;

  if ( r_rename = true ) then
    select count(1) into counter from report t where lower ( t.name ) = lower ( r_name_old ) and t.dashboard = r_dashboard and t.product = 1;
  else
    select count(1) into counter from report t where lower ( t.name ) = lower ( r_name ) and t.dashboard = r_dashboard and t.product = 1;
  end if;
  if ( counter = 0 ) then
    --localization code for report
    if ( r_loc_code is null ) then
      /*DBALT-BEGIN*/
      select dbms_random.random into r_loc_code from dual;
      /*PG*select trunc(random()*1000) into r_loc_code from generate_series(1,1000) limit 1;*PG*/
      /*DB2*select int((rand()-0.5) * 32768) into r_loc_code from dual;*DB2*/
      /*DBALT-END*/

      select count(1) into counter from localization t where lower ( t.code ) = lower ( r_loc_code );
      if ( counter = 0 ) then
        select localization_seq.nextval into r_loc_id from dual;
        
        insert into localization ( id, code, code_type )
        values ( r_loc_id, r_loc_code, 0 );
      end if;
    elsif ( r_loc_code is not null ) then
      select count(1) into counter from localization t where lower ( t.code ) = lower ( r_loc_code );
      if ( counter = 1 ) then
        select t.id into r_loc_id from localization t where lower ( t.code ) = lower ( r_loc_code );
      end if;
    end if;
    if ( r_loc_id is null ) then
      select t.id into r_loc_id from localization t where lower ( t.code ) = lower ( r_loc_code );
    end if;

    select max(id) + 1 into r_id from report t;
    
    if ( rt_name is not null or length ( rt_name ) > 0 ) then
      select count(1) into counter from report_type t where lower ( t.name ) = lower ( rt_name );
      if ( counter = 0 ) then
        select ( max(id) +1 ) into rt_id from report_type t;

        insert into report_type ( id, name, description )
        values ( rt_id, rt_name, rt_desc );
      else
        select t.id into rt_id from report_type t where lower ( t.name ) = lower ( rt_name );
      end if;
    end if;


    insert into report ( id, name, description, localization, r_query, status, report_type, code, product, parent, dashboard )
    values ( r_id, r_name, r_desc, r_loc_id, rq_id, 0, rt_id, r_code, 1, 1, r_dashboard );
    
    insert into report_attribute ( id, report, name, value )
    values ( report_attribute_seq.nextval, r_id, 'PRIORITY', '0' );
    if ( r_dashboard = 0 ) then 
      insert into report_attribute ( id, report, name, value )
      values ( report_attribute_seq.nextval, r_id, 'ORIENTATION', '1' );
      insert into report_attribute ( id, report, name, value )
      values ( report_attribute_seq.nextval, r_id, 'MAX_ROW', null );
      insert into report_attribute ( id, report, name, value )
      values ( report_attribute_seq.nextval, r_id, 'FORMAT', 'pdf' );
      insert into report_attribute ( id, report, name, value )
      values ( report_attribute_seq.nextval, r_id, 'FORMAT', 'xlsx' );
    elsif ( r_dashboard = 1 ) then
      null;
    end if;    
  else
    --ORACLE BUG ON REPORT_LNAME_DASHBOARD_IDX INDEX
    --ORA-03113 end-of-file on communication channel
    --caused by
    --ORA-07445: trovata eccezione: dump della memoria [qcdlgcd()+70] [SIGSEGV] [ADDR:0x4] [PC:0xCEA8796] [Address not mapped to object] []
    if ( r_rename = true ) then
      select t.id, t.name into r_id, r_name_old from report t where lower ( t.name ) = lower ( r_name_old ) and t.dashboard = r_dashboard and t.product = 1;
    else
      select t.id, t.name into r_id, r_name from report t where lower ( t.name ) = lower ( r_name ) and t.dashboard = r_dashboard and t.product = 1;
    end if;
    
    select t.localization into r_loc_id from report t where t.id = r_id;
  end if;

  if ( r_i18n_mess is null or length ( r_i18n_mess ) = 0 ) then
    r_i18n_mess := r_name;
  end if;

  --modifica il nome del report
  if ( r_rename = true ) then
    update report set name = r_name where id = r_id;
    update i18n_message set message = r_i18n_mess where localization = ( select t.localization from report t where t.id = r_id );
  end if;
  
  --inserimento o modifica dei messaggi di localizzazione
  open cur_lan for select t.id from language t where t.language_status > 0;
  loop
    fetch cur_lan into lan_id;
    exit when cur_lan%NOTFOUND;
      
    select count(1) into counter from i18n_message t where t.language = lan_id and t.localization = r_loc_id;
    if ( counter = 0 ) then
      insert into i18n_message ( id, localization, language, message )
      values ( i18n_message_seq.nextval, r_loc_id, lan_id, r_i18n_mess );
    else
      update i18n_message set message = r_i18n_mess where language = lan_id and localization = r_loc_id;
    end if;

  end loop;
  close cur_lan;

  --report parent
  select count(1) into counter from (
    select distinct r.id from report r, localization l, i18n_message i18
    where r.localization = l.id and r.leaf = 0 and l.id = i18.localization
    and i18.message = rp_name and r.dashboard = r_dashboard ) t;
  if ( counter = 1 ) then
    select distinct r.id into rp_id from report r, localization l, i18n_message i18
    where r.localization = l.id and r.leaf = 0 and l.id = i18.localization
    and i18.message = rp_name and r.dashboard = r_dashboard;
    
    update report set parent = rp_id where id = r_id;
  end if;

  --REPORT ATTRIBUTE 01: BEGIN
  ra_name         := ra_name01;
  ra_value        := ra_value01;
  select count(1) into counter from report_attribute t where t.report = r_id and lower ( t.name ) = lower ( ra_name );
  if ( counter = 0 ) then
    insert into report_attribute ( id, report, name, value )
    values ( report_attribute_seq.nextval, r_id, ra_name, ra_value );
  else
    select t.id into ra_id from report_attribute t where t.report = r_id and lower ( t.name ) = lower ( ra_name );
    update report_attribute set value = ra_value where id = ra_id;
  end if;
  --REPORT ATTRIBUTE 01: END

  --QUERY FIELD 01: BEGIN
  rqf_id          := null;
  rqf_name_old    := rqf_name01_old;
  rqf_name        := rqf_name01;
  rqf_type        := rqf_type01;
  rqf_width       := rqf_width01;
  rqf_ord_by      := rqf_ord_by01;
  rqf_ord_by_clau := rqf_ord_by_clau01;
  rqf_ord_pos     := null;
  loc_id          := null;
  loc_code_old    := loc_code01_old;
  loc_code        := loc_code01;
  loc_rename      := loc_rename01;
  i18n_msg        := i18n_msg01;
  repf_pos_id_old := null;
  repf_pos_id     := repf_pos_id01;

  if ( rqf_name_old is null or rqf_name_old = rqf_name ) then
    select count(1) into counter from r_query_field t where t.r_query = rq_id and lower ( t.column_name ) = lower ( rqf_name );
    if ( counter = 0 ) then
      select r_query_field_seq.nextval into rqf_id from dual;
      
      insert into r_query_field ( id, r_query, column_name, title, type, width )
      values ( rqf_id, rq_id, rqf_name, loc_code, rqf_type, rqf_width );
    end if;
  elsif ( rqf_name_old is not null and rqf_name_old <> rqf_name ) then
    select count(1) into counter from r_query_field t where t.r_query = rq_id and lower ( t.column_name ) = lower ( rqf_name_old );
    if ( counter = 1 ) then
      select t.id into rqf_id from r_query_field t where t.r_query = rq_id and lower ( t.column_name ) = lower ( rqf_name_old );
      update r_query_field set column_name = rqf_name where id = rqf_id;
    end if;  
  end if;
  if ( rqf_id is null ) then
    select t.id into rqf_id from r_query_field t where t.r_query = rq_id and lower ( t.column_name ) = lower ( rqf_name );
  end if;
  
  if ( loc_code_old is null or loc_code_old = loc_code ) then
    select count(1) into counter from localization t where lower ( t.code ) = lower ( loc_code );
    if ( counter = 0 ) then
      select localization_seq.nextval into loc_id from dual;
      
      insert into localization ( id, code, code_type )
      values ( loc_id, loc_code, 0 );
    end if;
  elsif ( loc_code_old is not null and loc_code_old <> loc_code ) then
    if ( loc_rename = true ) then
      select count(1) into counter from localization t where lower ( t.code ) = lower ( loc_code_old );
      if ( counter = 1 ) then
        select count(1) into counter from localization t where lower ( t.code ) = lower ( loc_code );
        if ( counter = 0 ) then
          select t.id into loc_id from localization t where lower ( t.code ) = lower ( loc_code_old );
          update localization set code = loc_code where id = loc_id;
        end if;
        update r_query_field set title = loc_code where id = rqf_id;
      end if;
    else
      select count(1) into counter from localization t where lower ( t.code ) = lower ( loc_code_old );
      if ( counter = 1 ) then
        select count(1) into counter from localization t where lower ( t.code ) = lower ( loc_code );
        if ( counter = 0 ) then
          select localization_seq.nextval into loc_id from dual;
          
          insert into localization ( id, code, code_type )
          values ( loc_id, loc_code, 0 );
        end if;
        update r_query_field set title = loc_code where id = rqf_id;
      end if;
    end if;
  end if;
  if ( loc_id is null ) then
    select t.id into loc_id from localization t where lower ( t.code ) = lower ( loc_code );
  end if;

  open cur_lan for select t.id from language t where t.language_status > 0;
  loop
    fetch cur_lan into lan_id;
    exit when cur_lan%NOTFOUND;
    
    select count(1) into counter from i18n_message t where t.language = lan_id and t.localization = loc_id;
    if ( counter = 0 ) then
      insert into i18n_message ( id, localization, language, message )
      values ( i18n_message_seq.nextval, loc_id, lan_id, i18n_msg );
    else
      update i18n_message set message = i18n_msg where language = lan_id and localization = loc_id;
    end if;

  end loop;
  close cur_lan;

  open cur_rep for select t.id from report t where t.r_query = rq_id;
  loop
    fetch cur_rep into rep_id;
    exit when cur_rep%NOTFOUND;
    
    select count(1) into counter from report_field t where t.report = rep_id and t.r_query_field = rqf_id;
    if ( counter = 0 ) then
      if ( repf_pos_id is null ) then
        select max ( t.position ) + 1 into repf_pos_id from report_field t where t.report = rep_id;
        if ( repf_pos_id is null ) then
          repf_pos_id := 0;
        end if;
      else
        select count(1) into counter from report_field t where t.report = rep_id and position = repf_pos_id;
        if ( counter > 0 ) then
          --modificare le posizioni del corrente e dei successivi
          update report_field set position = ( position + 1 ) where report = rep_id and position >= repf_pos_id;
        end if;
      end if;
      
      if ( rqf_ord_by = 1 ) then
        select max(t.order_by) + 1 into rqf_ord_pos from report_field t where t.report = rep_id;
        if ( rqf_ord_pos is null ) then
          rqf_ord_pos := 0;
        end if;
      else
        rqf_ord_by_clau := null;
      end if;

      insert into report_field ( id, report, r_query_field, localization, width, position, order_by, order_by_clause )
      values ( report_field_seq.nextval, rep_id, rqf_id, loc_id, rqf_width, repf_pos_id, rqf_ord_pos, rqf_ord_by_clau );
    elsif ( counter = 1 and repf_pos_id is not null ) then
      select t.position into repf_pos_id_old from report_field t where t.report = rep_id and t.r_query_field = rqf_id;
      --spostiamo il campo in una posizione speciale
      update report_field set position = -1 where report = rep_id and position = repf_pos_id_old;
      if ( repf_pos_id_old > repf_pos_id ) then
        update report_field set position = ( position + 1 ) where report = rep_id and position >= repf_pos_id and position <= repf_pos_id_old;
      else
        update report_field set position = ( position - 1 ) where report = rep_id and position >= repf_pos_id_old and position <= repf_pos_id;
      end if;
      --spostiamo il campo in una posizione finale
      update report_field set position = repf_pos_id where report = rep_id and position = -1;
      update report_field set localization = loc_id where report = rep_id and r_query_field = rqf_id;
    end if;
    
    if ( loc_rename = false ) then
      update report_field set localization = loc_id where report = rep_id and r_query_field = rqf_id;
    end if;

    update report_field set width = rqf_width where report = rep_id;
  end loop;
  close cur_rep;
  --QUERY FIELD 01: END

  --QUERY FIELD 02: BEGIN
  rqf_id          := null;
  rqf_name_old    := rqf_name02_old;
  rqf_name        := rqf_name02;
  rqf_type        := rqf_type02;
  rqf_width       := rqf_width02;
  rqf_ord_by      := rqf_ord_by02;
  rqf_ord_by_clau := rqf_ord_by_clau02;
  rqf_ord_pos     := null;
  loc_id          := null;
  loc_code_old    := loc_code02_old;
  loc_code        := loc_code02;
  loc_rename      := loc_rename02;
  i18n_msg        := i18n_msg02;
  repf_pos_id_old := null;
  repf_pos_id     := repf_pos_id02;

  if ( rqf_name_old is null or rqf_name_old = rqf_name ) then
    select count(1) into counter from r_query_field t where t.r_query = rq_id and lower ( t.column_name ) = lower ( rqf_name );
    if ( counter = 0 ) then
      select r_query_field_seq.nextval into rqf_id from dual;
      
      insert into r_query_field ( id, r_query, column_name, title, type, width )
      values ( rqf_id, rq_id, rqf_name, loc_code, rqf_type, rqf_width );
    end if;
  elsif ( rqf_name_old is not null and rqf_name_old <> rqf_name ) then
    select count(1) into counter from r_query_field t where t.r_query = rq_id and lower ( t.column_name ) = lower ( rqf_name_old );
    if ( counter = 1 ) then
      select t.id into rqf_id from r_query_field t where t.r_query = rq_id and lower ( t.column_name ) = lower ( rqf_name_old );
      update r_query_field set column_name = rqf_name where id = rqf_id;
    end if;  
  end if;
  if ( rqf_id is null ) then
    select t.id into rqf_id from r_query_field t where t.r_query = rq_id and lower ( t.column_name ) = lower ( rqf_name );
  end if;
  
  if ( loc_code_old is null or loc_code_old = loc_code ) then
    select count(1) into counter from localization t where lower ( t.code ) = lower ( loc_code );
    if ( counter = 0 ) then
      select localization_seq.nextval into loc_id from dual;
      
      insert into localization ( id, code, code_type )
      values ( loc_id, loc_code, 0 );
    end if;
  elsif ( loc_code_old is not null and loc_code_old <> loc_code ) then
    if ( loc_rename = true ) then
      select count(1) into counter from localization t where lower ( t.code ) = lower ( loc_code_old );
      if ( counter = 1 ) then
        select count(1) into counter from localization t where lower ( t.code ) = lower ( loc_code );
        if ( counter = 0 ) then
          select t.id into loc_id from localization t where lower ( t.code ) = lower ( loc_code_old );
          update localization set code = loc_code where id = loc_id;
        end if;
        update r_query_field set title = loc_code where id = rqf_id;
      end if;
    else
      select count(1) into counter from localization t where lower ( t.code ) = lower ( loc_code_old );
      if ( counter = 1 ) then
        select count(1) into counter from localization t where lower ( t.code ) = lower ( loc_code );
        if ( counter = 0 ) then
          select localization_seq.nextval into loc_id from dual;
          
          insert into localization ( id, code, code_type )
          values ( loc_id, loc_code, 0 );
        end if;
        update r_query_field set title = loc_code where id = rqf_id;
      end if;
    end if;
  end if;
  if ( loc_id is null ) then
    select t.id into loc_id from localization t where lower ( t.code ) = lower ( loc_code );
  end if;

  open cur_lan for select t.id from language t where t.language_status > 0;
  loop
    fetch cur_lan into lan_id;
    exit when cur_lan%NOTFOUND;
    
    select count(1) into counter from i18n_message t where t.language = lan_id and t.localization = loc_id;
    if ( counter = 0 ) then
      insert into i18n_message ( id, localization, language, message )
      values ( i18n_message_seq.nextval, loc_id, lan_id, i18n_msg );
    else
      update i18n_message set message = i18n_msg where language = lan_id and localization = loc_id;
    end if;

  end loop;
  close cur_lan;

  open cur_rep for select t.id from report t where t.r_query = rq_id;
  loop
    fetch cur_rep into rep_id;
    exit when cur_rep%NOTFOUND;
    
    select count(1) into counter from report_field t where t.report = rep_id and t.r_query_field = rqf_id;
    if ( counter = 0 ) then
      if ( repf_pos_id is null ) then
        select max ( t.position ) + 1 into repf_pos_id from report_field t where t.report = rep_id;
        if ( repf_pos_id is null ) then
          repf_pos_id := 0;
        end if;
      else
        select count(1) into counter from report_field t where t.report = rep_id and position = repf_pos_id;
        if ( counter > 0 ) then
          --modificare le posizioni del corrente e dei successivi
          update report_field set position = ( position + 1 ) where report = rep_id and position >= repf_pos_id;
        end if;
      end if;
      
      if ( rqf_ord_by = 1 ) then
        select max(t.order_by) + 1 into rqf_ord_pos from report_field t where t.report = rep_id;
        if ( rqf_ord_pos is null ) then
          rqf_ord_pos := 0;
        end if;
      else
        rqf_ord_by_clau := null;
      end if;

      insert into report_field ( id, report, r_query_field, localization, width, position, order_by, order_by_clause )
      values ( report_field_seq.nextval, rep_id, rqf_id, loc_id, rqf_width, repf_pos_id, rqf_ord_pos, rqf_ord_by_clau );
    elsif ( counter = 1 and repf_pos_id is not null ) then
      select t.position into repf_pos_id_old from report_field t where t.report = rep_id and t.r_query_field = rqf_id;
      --spostiamo il campo in una posizione speciale
      update report_field set position = -1 where report = rep_id and position = repf_pos_id_old;
      if ( repf_pos_id_old > repf_pos_id ) then
        update report_field set position = ( position + 1 ) where report = rep_id and position >= repf_pos_id and position <= repf_pos_id_old;
      else
        update report_field set position = ( position - 1 ) where report = rep_id and position >= repf_pos_id_old and position <= repf_pos_id;
      end if;
      --spostiamo il campo in una posizione finale
      update report_field set position = repf_pos_id where report = rep_id and position = -1;
      update report_field set localization = loc_id where report = rep_id and r_query_field = rqf_id;
    end if;
    
    if ( loc_rename = false ) then
      update report_field set localization = loc_id where report = rep_id and r_query_field = rqf_id;
    end if;

    update report_field set width = rqf_width where report = rep_id;
  end loop;
  close cur_rep;
  --QUERY FIELD 02: END

  --QUERY FIELD 03: BEGIN
  rqf_id          := null;
  rqf_name_old    := rqf_name03_old;
  rqf_name        := rqf_name03;
  rqf_type        := rqf_type03;
  rqf_width       := rqf_width03;
  rqf_ord_by      := rqf_ord_by03;
  rqf_ord_by_clau := rqf_ord_by_clau03;
  rqf_ord_pos     := null;
  loc_id          := null;
  loc_code_old    := loc_code03_old;
  loc_code        := loc_code03;
  loc_rename      := loc_rename03;
  i18n_msg        := i18n_msg03;
  repf_pos_id_old := null;
  repf_pos_id     := repf_pos_id03;

  if ( rqf_name_old is null or rqf_name_old = rqf_name ) then
    select count(1) into counter from r_query_field t where t.r_query = rq_id and lower ( t.column_name ) = lower ( rqf_name );
    if ( counter = 0 ) then
      select r_query_field_seq.nextval into rqf_id from dual;
      
      insert into r_query_field ( id, r_query, column_name, title, type, width )
      values ( rqf_id, rq_id, rqf_name, loc_code, rqf_type, rqf_width );
    end if;
  elsif ( rqf_name_old is not null and rqf_name_old <> rqf_name ) then
    select count(1) into counter from r_query_field t where t.r_query = rq_id and lower ( t.column_name ) = lower ( rqf_name_old );
    if ( counter = 1 ) then
      select t.id into rqf_id from r_query_field t where t.r_query = rq_id and lower ( t.column_name ) = lower ( rqf_name_old );
      update r_query_field set column_name = rqf_name where id = rqf_id;
    end if;  
  end if;
  if ( rqf_id is null ) then
    select t.id into rqf_id from r_query_field t where t.r_query = rq_id and lower ( t.column_name ) = lower ( rqf_name );
  end if;
  
  if ( loc_code_old is null or loc_code_old = loc_code ) then
    select count(1) into counter from localization t where lower ( t.code ) = lower ( loc_code );
    if ( counter = 0 ) then
      select localization_seq.nextval into loc_id from dual;
      
      insert into localization ( id, code, code_type )
      values ( loc_id, loc_code, 0 );
    end if;
  elsif ( loc_code_old is not null and loc_code_old <> loc_code ) then
    if ( loc_rename = true ) then
      select count(1) into counter from localization t where lower ( t.code ) = lower ( loc_code_old );
      if ( counter = 1 ) then
        select count(1) into counter from localization t where lower ( t.code ) = lower ( loc_code );
        if ( counter = 0 ) then
          select t.id into loc_id from localization t where lower ( t.code ) = lower ( loc_code_old );
          update localization set code = loc_code where id = loc_id;
        end if;
        update r_query_field set title = loc_code where id = rqf_id;
      end if;
    else
      select count(1) into counter from localization t where lower ( t.code ) = lower ( loc_code_old );
      if ( counter = 1 ) then
        select count(1) into counter from localization t where lower ( t.code ) = lower ( loc_code );
        if ( counter = 0 ) then
          select localization_seq.nextval into loc_id from dual;
          
          insert into localization ( id, code, code_type )
          values ( loc_id, loc_code, 0 );
        end if;
        update r_query_field set title = loc_code where id = rqf_id;
      end if;
    end if;
  end if;
  if ( loc_id is null ) then
    select t.id into loc_id from localization t where lower ( t.code ) = lower ( loc_code );
  end if;

  open cur_lan for select t.id from language t where t.language_status > 0;
  loop
    fetch cur_lan into lan_id;
    exit when cur_lan%NOTFOUND;
    
    select count(1) into counter from i18n_message t where t.language = lan_id and t.localization = loc_id;
    if ( counter = 0 ) then
      insert into i18n_message ( id, localization, language, message )
      values ( i18n_message_seq.nextval, loc_id, lan_id, i18n_msg );
    else
      update i18n_message set message = i18n_msg where language = lan_id and localization = loc_id;
    end if;

  end loop;
  close cur_lan;

  open cur_rep for select t.id from report t where t.r_query = rq_id;
  loop
    fetch cur_rep into rep_id;
    exit when cur_rep%NOTFOUND;
    
    select count(1) into counter from report_field t where t.report = rep_id and t.r_query_field = rqf_id;
    if ( counter = 0 ) then
      if ( repf_pos_id is null ) then
        select max ( t.position ) + 1 into repf_pos_id from report_field t where t.report = rep_id;
        if ( repf_pos_id is null ) then
          repf_pos_id := 0;
        end if;
      else
        select count(1) into counter from report_field t where t.report = rep_id and position = repf_pos_id;
        if ( counter > 0 ) then
          --modificare le posizioni del corrente e dei successivi
          update report_field set position = ( position + 1 ) where report = rep_id and position >= repf_pos_id;
        end if;
      end if;
      
      if ( rqf_ord_by = 1 ) then
        select max(t.order_by) + 1 into rqf_ord_pos from report_field t where t.report = rep_id;
        if ( rqf_ord_pos is null ) then
          rqf_ord_pos := 0;
        end if;
      else
        rqf_ord_by_clau := null;
      end if;

      insert into report_field ( id, report, r_query_field, localization, width, position, order_by, order_by_clause )
      values ( report_field_seq.nextval, rep_id, rqf_id, loc_id, rqf_width, repf_pos_id, rqf_ord_pos, rqf_ord_by_clau );
    elsif ( counter = 1 and repf_pos_id is not null ) then
      select t.position into repf_pos_id_old from report_field t where t.report = rep_id and t.r_query_field = rqf_id;
      --spostiamo il campo in una posizione speciale
      update report_field set position = -1 where report = rep_id and position = repf_pos_id_old;
      if ( repf_pos_id_old > repf_pos_id ) then
        update report_field set position = ( position + 1 ) where report = rep_id and position >= repf_pos_id and position <= repf_pos_id_old;
      else
        update report_field set position = ( position - 1 ) where report = rep_id and position >= repf_pos_id_old and position <= repf_pos_id;
      end if;
      --spostiamo il campo in una posizione finale
      update report_field set position = repf_pos_id where report = rep_id and position = -1;
      update report_field set localization = loc_id where report = rep_id and r_query_field = rqf_id;
    end if;
    
    if ( loc_rename = false ) then
      update report_field set localization = loc_id where report = rep_id and r_query_field = rqf_id;
    end if;

    update report_field set width = rqf_width where report = rep_id;
  end loop;
  close cur_rep;
  --QUERY FIELD 03: END

  --QUERY FIELD 04: BEGIN
  rqf_id          := null;
  rqf_name_old    := rqf_name04_old;
  rqf_name        := rqf_name04;
  rqf_type        := rqf_type04;
  rqf_width       := rqf_width04;
  rqf_ord_by      := rqf_ord_by04;
  rqf_ord_by_clau := rqf_ord_by_clau04;
  rqf_ord_pos     := null;
  loc_id          := null;
  loc_code_old    := loc_code04_old;
  loc_code        := loc_code04;
  loc_rename      := loc_rename04;
  i18n_msg        := i18n_msg04;
  repf_pos_id_old := null;
  repf_pos_id     := repf_pos_id04;

  if ( rqf_name_old is null or rqf_name_old = rqf_name ) then
    select count(1) into counter from r_query_field t where t.r_query = rq_id and lower ( t.column_name ) = lower ( rqf_name );
    if ( counter = 0 ) then
      select r_query_field_seq.nextval into rqf_id from dual;
      
      insert into r_query_field ( id, r_query, column_name, title, type, width )
      values ( rqf_id, rq_id, rqf_name, loc_code, rqf_type, rqf_width );
    end if;
  elsif ( rqf_name_old is not null and rqf_name_old <> rqf_name ) then
    select count(1) into counter from r_query_field t where t.r_query = rq_id and lower ( t.column_name ) = lower ( rqf_name_old );
    if ( counter = 1 ) then
      select t.id into rqf_id from r_query_field t where t.r_query = rq_id and lower ( t.column_name ) = lower ( rqf_name_old );
      update r_query_field set column_name = rqf_name where id = rqf_id;
    end if;  
  end if;
  if ( rqf_id is null ) then
    select t.id into rqf_id from r_query_field t where t.r_query = rq_id and lower ( t.column_name ) = lower ( rqf_name );
  end if;
  
  if ( loc_code_old is null or loc_code_old = loc_code ) then
    select count(1) into counter from localization t where lower ( t.code ) = lower ( loc_code );
    if ( counter = 0 ) then
      select localization_seq.nextval into loc_id from dual;
      
      insert into localization ( id, code, code_type )
      values ( loc_id, loc_code, 0 );
    end if;
  elsif ( loc_code_old is not null and loc_code_old <> loc_code ) then
    if ( loc_rename = true ) then
      select count(1) into counter from localization t where lower ( t.code ) = lower ( loc_code_old );
      if ( counter = 1 ) then
        select count(1) into counter from localization t where lower ( t.code ) = lower ( loc_code );
        if ( counter = 0 ) then
          select t.id into loc_id from localization t where lower ( t.code ) = lower ( loc_code_old );
          update localization set code = loc_code where id = loc_id;
        end if;
        update r_query_field set title = loc_code where id = rqf_id;
      end if;
    else
      select count(1) into counter from localization t where lower ( t.code ) = lower ( loc_code_old );
      if ( counter = 1 ) then
        select count(1) into counter from localization t where lower ( t.code ) = lower ( loc_code );
        if ( counter = 0 ) then
          select localization_seq.nextval into loc_id from dual;
          
          insert into localization ( id, code, code_type )
          values ( loc_id, loc_code, 0 );
        end if;
        update r_query_field set title = loc_code where id = rqf_id;
      end if;
    end if;
  end if;
  if ( loc_id is null ) then
    select t.id into loc_id from localization t where lower ( t.code ) = lower ( loc_code );
  end if;

  open cur_lan for select t.id from language t where t.language_status > 0;
  loop
    fetch cur_lan into lan_id;
    exit when cur_lan%NOTFOUND;
    
    select count(1) into counter from i18n_message t where t.language = lan_id and t.localization = loc_id;
    if ( counter = 0 ) then
      insert into i18n_message ( id, localization, language, message )
      values ( i18n_message_seq.nextval, loc_id, lan_id, i18n_msg );
    else
      update i18n_message set message = i18n_msg where language = lan_id and localization = loc_id;
    end if;

  end loop;
  close cur_lan;

  open cur_rep for select t.id from report t where t.r_query = rq_id;
  loop
    fetch cur_rep into rep_id;
    exit when cur_rep%NOTFOUND;
    
    select count(1) into counter from report_field t where t.report = rep_id and t.r_query_field = rqf_id;
    if ( counter = 0 ) then
      if ( repf_pos_id is null ) then
        select max ( t.position ) + 1 into repf_pos_id from report_field t where t.report = rep_id;
        if ( repf_pos_id is null ) then
          repf_pos_id := 0;
        end if;
      else
        select count(1) into counter from report_field t where t.report = rep_id and position = repf_pos_id;
        if ( counter > 0 ) then
          --modificare le posizioni del corrente e dei successivi
          update report_field set position = ( position + 1 ) where report = rep_id and position >= repf_pos_id;
        end if;
      end if;
      
      if ( rqf_ord_by = 1 ) then
        select max(t.order_by) + 1 into rqf_ord_pos from report_field t where t.report = rep_id;
        if ( rqf_ord_pos is null ) then
          rqf_ord_pos := 0;
        end if;
      else
        rqf_ord_by_clau := null;
      end if;

      insert into report_field ( id, report, r_query_field, localization, width, position, order_by, order_by_clause )
      values ( report_field_seq.nextval, rep_id, rqf_id, loc_id, rqf_width, repf_pos_id, rqf_ord_pos, rqf_ord_by_clau );
    elsif ( counter = 1 and repf_pos_id is not null ) then
      select t.position into repf_pos_id_old from report_field t where t.report = rep_id and t.r_query_field = rqf_id;
      --spostiamo il campo in una posizione speciale
      update report_field set position = -1 where report = rep_id and position = repf_pos_id_old;
      if ( repf_pos_id_old > repf_pos_id ) then
        update report_field set position = ( position + 1 ) where report = rep_id and position >= repf_pos_id and position <= repf_pos_id_old;
      else
        update report_field set position = ( position - 1 ) where report = rep_id and position >= repf_pos_id_old and position <= repf_pos_id;
      end if;
      --spostiamo il campo in una posizione finale
      update report_field set position = repf_pos_id where report = rep_id and position = -1;
      update report_field set localization = loc_id where report = rep_id and r_query_field = rqf_id;
    end if;
    
    if ( loc_rename = false ) then
      update report_field set localization = loc_id where report = rep_id and r_query_field = rqf_id;
    end if;

    update report_field set width = rqf_width where report = rep_id;
  end loop;
  close cur_rep;
  --QUERY FIELD 04: END

  --QUERY FIELD 05: BEGIN
  rqf_id          := null;
  rqf_name_old    := rqf_name05_old;
  rqf_name        := rqf_name05;
  rqf_type        := rqf_type05;
  rqf_width       := rqf_width05;
  rqf_ord_by      := rqf_ord_by05;
  rqf_ord_by_clau := rqf_ord_by_clau05;
  rqf_ord_pos     := null;
  loc_id          := null;
  loc_code_old    := loc_code05_old;
  loc_code        := loc_code05;
  loc_rename      := loc_rename05;
  i18n_msg        := i18n_msg05;
  repf_pos_id_old := null;
  repf_pos_id     := repf_pos_id05;

  if ( rqf_name_old is null or rqf_name_old = rqf_name ) then
    select count(1) into counter from r_query_field t where t.r_query = rq_id and lower ( t.column_name ) = lower ( rqf_name );
    if ( counter = 0 ) then
      select r_query_field_seq.nextval into rqf_id from dual;
      
      insert into r_query_field ( id, r_query, column_name, title, type, width )
      values ( rqf_id, rq_id, rqf_name, loc_code, rqf_type, rqf_width );
    end if;
  elsif ( rqf_name_old is not null and rqf_name_old <> rqf_name ) then
    select count(1) into counter from r_query_field t where t.r_query = rq_id and lower ( t.column_name ) = lower ( rqf_name_old );
    if ( counter = 1 ) then
      select t.id into rqf_id from r_query_field t where t.r_query = rq_id and lower ( t.column_name ) = lower ( rqf_name_old );
      update r_query_field set column_name = rqf_name where id = rqf_id;
    end if;  
  end if;
  if ( rqf_id is null ) then
    select t.id into rqf_id from r_query_field t where t.r_query = rq_id and lower ( t.column_name ) = lower ( rqf_name );
  end if;
  
  if ( loc_code_old is null or loc_code_old = loc_code ) then
    select count(1) into counter from localization t where lower ( t.code ) = lower ( loc_code );
    if ( counter = 0 ) then
      select localization_seq.nextval into loc_id from dual;
      
      insert into localization ( id, code, code_type )
      values ( loc_id, loc_code, 0 );
    end if;
  elsif ( loc_code_old is not null and loc_code_old <> loc_code ) then
    if ( loc_rename = true ) then
      select count(1) into counter from localization t where lower ( t.code ) = lower ( loc_code_old );
      if ( counter = 1 ) then
        select count(1) into counter from localization t where lower ( t.code ) = lower ( loc_code );
        if ( counter = 0 ) then
          select t.id into loc_id from localization t where lower ( t.code ) = lower ( loc_code_old );
          update localization set code = loc_code where id = loc_id;
        end if;
        update r_query_field set title = loc_code where id = rqf_id;
      end if;
    else
      select count(1) into counter from localization t where lower ( t.code ) = lower ( loc_code_old );
      if ( counter = 1 ) then
        select count(1) into counter from localization t where lower ( t.code ) = lower ( loc_code );
        if ( counter = 0 ) then
          select localization_seq.nextval into loc_id from dual;
          
          insert into localization ( id, code, code_type )
          values ( loc_id, loc_code, 0 );
        end if;
        update r_query_field set title = loc_code where id = rqf_id;
      end if;
    end if;
  end if;
  if ( loc_id is null ) then
    select t.id into loc_id from localization t where lower ( t.code ) = lower ( loc_code );
  end if;

  open cur_lan for select t.id from language t where t.language_status > 0;
  loop
    fetch cur_lan into lan_id;
    exit when cur_lan%NOTFOUND;
    
    select count(1) into counter from i18n_message t where t.language = lan_id and t.localization = loc_id;
    if ( counter = 0 ) then
      insert into i18n_message ( id, localization, language, message )
      values ( i18n_message_seq.nextval, loc_id, lan_id, i18n_msg );
    else
      update i18n_message set message = i18n_msg where language = lan_id and localization = loc_id;
    end if;

  end loop;
  close cur_lan;

  open cur_rep for select t.id from report t where t.r_query = rq_id;
  loop
    fetch cur_rep into rep_id;
    exit when cur_rep%NOTFOUND;
    
    select count(1) into counter from report_field t where t.report = rep_id and t.r_query_field = rqf_id;
    if ( counter = 0 ) then
      if ( repf_pos_id is null ) then
        select max ( t.position ) + 1 into repf_pos_id from report_field t where t.report = rep_id;
        if ( repf_pos_id is null ) then
          repf_pos_id := 0;
        end if;
      else
        select count(1) into counter from report_field t where t.report = rep_id and position = repf_pos_id;
        if ( counter > 0 ) then
          --modificare le posizioni del corrente e dei successivi
          update report_field set position = ( position + 1 ) where report = rep_id and position >= repf_pos_id;
        end if;
      end if;
      
      if ( rqf_ord_by = 1 ) then
        select max(t.order_by) + 1 into rqf_ord_pos from report_field t where t.report = rep_id;
        if ( rqf_ord_pos is null ) then
          rqf_ord_pos := 0;
        end if;
      else
        rqf_ord_by_clau := null;
      end if;

      insert into report_field ( id, report, r_query_field, localization, width, position, order_by, order_by_clause )
      values ( report_field_seq.nextval, rep_id, rqf_id, loc_id, rqf_width, repf_pos_id, rqf_ord_pos, rqf_ord_by_clau );
    elsif ( counter = 1 and repf_pos_id is not null ) then
      select t.position into repf_pos_id_old from report_field t where t.report = rep_id and t.r_query_field = rqf_id;
      --spostiamo il campo in una posizione speciale
      update report_field set position = -1 where report = rep_id and position = repf_pos_id_old;
      if ( repf_pos_id_old > repf_pos_id ) then
        update report_field set position = ( position + 1 ) where report = rep_id and position >= repf_pos_id and position <= repf_pos_id_old;
      else
        update report_field set position = ( position - 1 ) where report = rep_id and position >= repf_pos_id_old and position <= repf_pos_id;
      end if;
      --spostiamo il campo in una posizione finale
      update report_field set position = repf_pos_id where report = rep_id and position = -1;
      update report_field set localization = loc_id where report = rep_id and r_query_field = rqf_id;
    end if;
    
    if ( loc_rename = false ) then
      update report_field set localization = loc_id where report = rep_id and r_query_field = rqf_id;
    end if;

    update report_field set width = rqf_width where report = rep_id;
  end loop;
  close cur_rep;
  --QUERY FIELD 05: END

  --QUERY FIELD 06: BEGIN
  rqf_id          := null;
  rqf_name_old    := rqf_name06_old;
  rqf_name        := rqf_name06;
  rqf_type        := rqf_type06;
  rqf_width       := rqf_width06;
  rqf_ord_by      := rqf_ord_by06;
  rqf_ord_by_clau := rqf_ord_by_clau06;
  rqf_ord_pos     := null;
  loc_id          := null;
  loc_code_old    := loc_code06_old;
  loc_code        := loc_code06;
  loc_rename      := loc_rename06;
  i18n_msg        := i18n_msg06;
  repf_pos_id_old := null;
  repf_pos_id     := repf_pos_id06;

  if ( rqf_name_old is null or rqf_name_old = rqf_name ) then
    select count(1) into counter from r_query_field t where t.r_query = rq_id and lower ( t.column_name ) = lower ( rqf_name );
    if ( counter = 0 ) then
      select r_query_field_seq.nextval into rqf_id from dual;
      
      insert into r_query_field ( id, r_query, column_name, title, type, width )
      values ( rqf_id, rq_id, rqf_name, loc_code, rqf_type, rqf_width );
    end if;
  elsif ( rqf_name_old is not null and rqf_name_old <> rqf_name ) then
    select count(1) into counter from r_query_field t where t.r_query = rq_id and lower ( t.column_name ) = lower ( rqf_name_old );
    if ( counter = 1 ) then
      select t.id into rqf_id from r_query_field t where t.r_query = rq_id and lower ( t.column_name ) = lower ( rqf_name_old );
      update r_query_field set column_name = rqf_name where id = rqf_id;
    end if;  
  end if;
  if ( rqf_id is null ) then
    select t.id into rqf_id from r_query_field t where t.r_query = rq_id and lower ( t.column_name ) = lower ( rqf_name );
  end if;
  
  if ( loc_code_old is null or loc_code_old = loc_code ) then
    select count(1) into counter from localization t where lower ( t.code ) = lower ( loc_code );
    if ( counter = 0 ) then
      select localization_seq.nextval into loc_id from dual;
      
      insert into localization ( id, code, code_type )
      values ( loc_id, loc_code, 0 );
    end if;
  elsif ( loc_code_old is not null and loc_code_old <> loc_code ) then
    if ( loc_rename = true ) then
      select count(1) into counter from localization t where lower ( t.code ) = lower ( loc_code_old );
      if ( counter = 1 ) then
        select count(1) into counter from localization t where lower ( t.code ) = lower ( loc_code );
        if ( counter = 0 ) then
          select t.id into loc_id from localization t where lower ( t.code ) = lower ( loc_code_old );
          update localization set code = loc_code where id = loc_id;
        end if;
        update r_query_field set title = loc_code where id = rqf_id;
      end if;
    else
      select count(1) into counter from localization t where lower ( t.code ) = lower ( loc_code_old );
      if ( counter = 1 ) then
        select count(1) into counter from localization t where lower ( t.code ) = lower ( loc_code );
        if ( counter = 0 ) then
          select localization_seq.nextval into loc_id from dual;
          
          insert into localization ( id, code, code_type )
          values ( loc_id, loc_code, 0 );
        end if;
        update r_query_field set title = loc_code where id = rqf_id;
      end if;
    end if;
  end if;
  if ( loc_id is null ) then
    select t.id into loc_id from localization t where lower ( t.code ) = lower ( loc_code );
  end if;

  open cur_lan for select t.id from language t where t.language_status > 0;
  loop
    fetch cur_lan into lan_id;
    exit when cur_lan%NOTFOUND;
    
    select count(1) into counter from i18n_message t where t.language = lan_id and t.localization = loc_id;
    if ( counter = 0 ) then
      insert into i18n_message ( id, localization, language, message )
      values ( i18n_message_seq.nextval, loc_id, lan_id, i18n_msg );
    else
      update i18n_message set message = i18n_msg where language = lan_id and localization = loc_id;
    end if;

  end loop;
  close cur_lan;

  open cur_rep for select t.id from report t where t.r_query = rq_id;
  loop
    fetch cur_rep into rep_id;
    exit when cur_rep%NOTFOUND;
    
    select count(1) into counter from report_field t where t.report = rep_id and t.r_query_field = rqf_id;
    if ( counter = 0 ) then
      if ( repf_pos_id is null ) then
        select max ( t.position ) + 1 into repf_pos_id from report_field t where t.report = rep_id;
        if ( repf_pos_id is null ) then
          repf_pos_id := 0;
        end if;
      else
        select count(1) into counter from report_field t where t.report = rep_id and position = repf_pos_id;
        if ( counter > 0 ) then
          --modificare le posizioni del corrente e dei successivi
          update report_field set position = ( position + 1 ) where report = rep_id and position >= repf_pos_id;
        end if;
      end if;
      
      if ( rqf_ord_by = 1 ) then
        select max(t.order_by) + 1 into rqf_ord_pos from report_field t where t.report = rep_id;
        if ( rqf_ord_pos is null ) then
          rqf_ord_pos := 0;
        end if;
      else
        rqf_ord_by_clau := null;
      end if;

      insert into report_field ( id, report, r_query_field, localization, width, position, order_by, order_by_clause )
      values ( report_field_seq.nextval, rep_id, rqf_id, loc_id, rqf_width, repf_pos_id, rqf_ord_pos, rqf_ord_by_clau );
    elsif ( counter = 1 and repf_pos_id is not null ) then
      select t.position into repf_pos_id_old from report_field t where t.report = rep_id and t.r_query_field = rqf_id;
      --spostiamo il campo in una posizione speciale
      update report_field set position = -1 where report = rep_id and position = repf_pos_id_old;
      if ( repf_pos_id_old > repf_pos_id ) then
        update report_field set position = ( position + 1 ) where report = rep_id and position >= repf_pos_id and position <= repf_pos_id_old;
      else
        update report_field set position = ( position - 1 ) where report = rep_id and position >= repf_pos_id_old and position <= repf_pos_id;
      end if;
      --spostiamo il campo in una posizione finale
      update report_field set position = repf_pos_id where report = rep_id and position = -1;
      update report_field set localization = loc_id where report = rep_id and r_query_field = rqf_id;
    end if;
    
    if ( loc_rename = false ) then
      update report_field set localization = loc_id where report = rep_id and r_query_field = rqf_id;
    end if;

    update report_field set width = rqf_width where report = rep_id;
  end loop;
  close cur_rep;
  --QUERY FIELD 06: END

  --QUERY FIELD 07: BEGIN
  rqf_id          := null;
  rqf_name_old    := rqf_name07_old;
  rqf_name        := rqf_name07;
  rqf_type        := rqf_type07;
  rqf_width       := rqf_width07;
  rqf_ord_by      := rqf_ord_by07;
  rqf_ord_by_clau := rqf_ord_by_clau07;
  rqf_ord_pos     := null;
  loc_id          := null;
  loc_code_old    := loc_code07_old;
  loc_code        := loc_code07;
  loc_rename      := loc_rename07;
  i18n_msg        := i18n_msg07;
  repf_pos_id_old := null;
  repf_pos_id     := repf_pos_id07;

  if ( rqf_name_old is null or rqf_name_old = rqf_name ) then
    select count(1) into counter from r_query_field t where t.r_query = rq_id and lower ( t.column_name ) = lower ( rqf_name );
    if ( counter = 0 ) then
      select r_query_field_seq.nextval into rqf_id from dual;
      
      insert into r_query_field ( id, r_query, column_name, title, type, width )
      values ( rqf_id, rq_id, rqf_name, loc_code, rqf_type, rqf_width );
    end if;
  elsif ( rqf_name_old is not null and rqf_name_old <> rqf_name ) then
    select count(1) into counter from r_query_field t where t.r_query = rq_id and lower ( t.column_name ) = lower ( rqf_name_old );
    if ( counter = 1 ) then
      select t.id into rqf_id from r_query_field t where t.r_query = rq_id and lower ( t.column_name ) = lower ( rqf_name_old );
      update r_query_field set column_name = rqf_name where id = rqf_id;
    end if;  
  end if;
  if ( rqf_id is null ) then
    select t.id into rqf_id from r_query_field t where t.r_query = rq_id and lower ( t.column_name ) = lower ( rqf_name );
  end if;
  
  if ( loc_code_old is null or loc_code_old = loc_code ) then
    select count(1) into counter from localization t where lower ( t.code ) = lower ( loc_code );
    if ( counter = 0 ) then
      select localization_seq.nextval into loc_id from dual;
      
      insert into localization ( id, code, code_type )
      values ( loc_id, loc_code, 0 );
    end if;
  elsif ( loc_code_old is not null and loc_code_old <> loc_code ) then
    if ( loc_rename = true ) then
      select count(1) into counter from localization t where lower ( t.code ) = lower ( loc_code_old );
      if ( counter = 1 ) then
        select count(1) into counter from localization t where lower ( t.code ) = lower ( loc_code );
        if ( counter = 0 ) then
          select t.id into loc_id from localization t where lower ( t.code ) = lower ( loc_code_old );
          update localization set code = loc_code where id = loc_id;
        end if;
        update r_query_field set title = loc_code where id = rqf_id;
      end if;
    else
      select count(1) into counter from localization t where lower ( t.code ) = lower ( loc_code_old );
      if ( counter = 1 ) then
        select count(1) into counter from localization t where lower ( t.code ) = lower ( loc_code );
        if ( counter = 0 ) then
          select localization_seq.nextval into loc_id from dual;
          
          insert into localization ( id, code, code_type )
          values ( loc_id, loc_code, 0 );
        end if;
        update r_query_field set title = loc_code where id = rqf_id;
      end if;
    end if;
  end if;
  if ( loc_id is null ) then
    select t.id into loc_id from localization t where lower ( t.code ) = lower ( loc_code );
  end if;

  open cur_lan for select t.id from language t where t.language_status > 0;
  loop
    fetch cur_lan into lan_id;
    exit when cur_lan%NOTFOUND;
    
    select count(1) into counter from i18n_message t where t.language = lan_id and t.localization = loc_id;
    if ( counter = 0 ) then
      insert into i18n_message ( id, localization, language, message )
      values ( i18n_message_seq.nextval, loc_id, lan_id, i18n_msg );
    else
      update i18n_message set message = i18n_msg where language = lan_id and localization = loc_id;
    end if;

  end loop;
  close cur_lan;

  open cur_rep for select t.id from report t where t.r_query = rq_id;
  loop
    fetch cur_rep into rep_id;
    exit when cur_rep%NOTFOUND;
    
    select count(1) into counter from report_field t where t.report = rep_id and t.r_query_field = rqf_id;
    if ( counter = 0 ) then
      if ( repf_pos_id is null ) then
        select max ( t.position ) + 1 into repf_pos_id from report_field t where t.report = rep_id;
        if ( repf_pos_id is null ) then
          repf_pos_id := 0;
        end if;
      else
        select count(1) into counter from report_field t where t.report = rep_id and position = repf_pos_id;
        if ( counter > 0 ) then
          --modificare le posizioni del corrente e dei successivi
          update report_field set position = ( position + 1 ) where report = rep_id and position >= repf_pos_id;
        end if;
      end if;
      
      if ( rqf_ord_by = 1 ) then
        select max(t.order_by) + 1 into rqf_ord_pos from report_field t where t.report = rep_id;
        if ( rqf_ord_pos is null ) then
          rqf_ord_pos := 0;
        end if;
      else
        rqf_ord_by_clau := null;
      end if;

      insert into report_field ( id, report, r_query_field, localization, width, position, order_by, order_by_clause )
      values ( report_field_seq.nextval, rep_id, rqf_id, loc_id, rqf_width, repf_pos_id, rqf_ord_pos, rqf_ord_by_clau );
    elsif ( counter = 1 and repf_pos_id is not null ) then
      select t.position into repf_pos_id_old from report_field t where t.report = rep_id and t.r_query_field = rqf_id;
      --spostiamo il campo in una posizione speciale
      update report_field set position = -1 where report = rep_id and position = repf_pos_id_old;
      if ( repf_pos_id_old > repf_pos_id ) then
        update report_field set position = ( position + 1 ) where report = rep_id and position >= repf_pos_id and position <= repf_pos_id_old;
      else
        update report_field set position = ( position - 1 ) where report = rep_id and position >= repf_pos_id_old and position <= repf_pos_id;
      end if;
      --spostiamo il campo in una posizione finale
      update report_field set position = repf_pos_id where report = rep_id and position = -1;
      update report_field set localization = loc_id where report = rep_id and r_query_field = rqf_id;
    end if;
    
    if ( loc_rename = false ) then
      update report_field set localization = loc_id where report = rep_id and r_query_field = rqf_id;
    end if;

    update report_field set width = rqf_width where report = rep_id;
  end loop;
  close cur_rep;
  --QUERY FIELD 07: END

  --QUERY FIELD 08: BEGIN
  rqf_id          := null;
  rqf_name_old    := rqf_name08_old;
  rqf_name        := rqf_name08;
  rqf_type        := rqf_type08;
  rqf_width       := rqf_width08;
  rqf_ord_by      := rqf_ord_by08;
  rqf_ord_by_clau := rqf_ord_by_clau08;
  rqf_ord_pos     := null;
  loc_id          := null;
  loc_code_old    := loc_code08_old;
  loc_code        := loc_code08;
  loc_rename      := loc_rename08;
  i18n_msg        := i18n_msg08;
  repf_pos_id_old := null;
  repf_pos_id     := repf_pos_id08;

  if ( rqf_name_old is null or rqf_name_old = rqf_name ) then
    select count(1) into counter from r_query_field t where t.r_query = rq_id and lower ( t.column_name ) = lower ( rqf_name );
    if ( counter = 0 ) then
      select r_query_field_seq.nextval into rqf_id from dual;
      
      insert into r_query_field ( id, r_query, column_name, title, type, width )
      values ( rqf_id, rq_id, rqf_name, loc_code, rqf_type, rqf_width );
    end if;
  elsif ( rqf_name_old is not null and rqf_name_old <> rqf_name ) then
    select count(1) into counter from r_query_field t where t.r_query = rq_id and lower ( t.column_name ) = lower ( rqf_name_old );
    if ( counter = 1 ) then
      select t.id into rqf_id from r_query_field t where t.r_query = rq_id and lower ( t.column_name ) = lower ( rqf_name_old );
      update r_query_field set column_name = rqf_name where id = rqf_id;
    end if;  
  end if;
  if ( rqf_id is null ) then
    select t.id into rqf_id from r_query_field t where t.r_query = rq_id and lower ( t.column_name ) = lower ( rqf_name );
  end if;
  
  if ( loc_code_old is null or loc_code_old = loc_code ) then
    select count(1) into counter from localization t where lower ( t.code ) = lower ( loc_code );
    if ( counter = 0 ) then
      select localization_seq.nextval into loc_id from dual;
      
      insert into localization ( id, code, code_type )
      values ( loc_id, loc_code, 0 );
    end if;
  elsif ( loc_code_old is not null and loc_code_old <> loc_code ) then
    if ( loc_rename = true ) then
      select count(1) into counter from localization t where lower ( t.code ) = lower ( loc_code_old );
      if ( counter = 1 ) then
        select count(1) into counter from localization t where lower ( t.code ) = lower ( loc_code );
        if ( counter = 0 ) then
          select t.id into loc_id from localization t where lower ( t.code ) = lower ( loc_code_old );
          update localization set code = loc_code where id = loc_id;
        end if;
        update r_query_field set title = loc_code where id = rqf_id;
      end if;
    else
      select count(1) into counter from localization t where lower ( t.code ) = lower ( loc_code_old );
      if ( counter = 1 ) then
        select count(1) into counter from localization t where lower ( t.code ) = lower ( loc_code );
        if ( counter = 0 ) then
          select localization_seq.nextval into loc_id from dual;
          
          insert into localization ( id, code, code_type )
          values ( loc_id, loc_code, 0 );
        end if;
        update r_query_field set title = loc_code where id = rqf_id;
      end if;
    end if;
  end if;
  if ( loc_id is null ) then
    select t.id into loc_id from localization t where lower ( t.code ) = lower ( loc_code );
  end if;

  open cur_lan for select t.id from language t where t.language_status > 0;
  loop
    fetch cur_lan into lan_id;
    exit when cur_lan%NOTFOUND;
    
    select count(1) into counter from i18n_message t where t.language = lan_id and t.localization = loc_id;
    if ( counter = 0 ) then
      insert into i18n_message ( id, localization, language, message )
      values ( i18n_message_seq.nextval, loc_id, lan_id, i18n_msg );
    else
      update i18n_message set message = i18n_msg where language = lan_id and localization = loc_id;
    end if;

  end loop;
  close cur_lan;

  open cur_rep for select t.id from report t where t.r_query = rq_id;
  loop
    fetch cur_rep into rep_id;
    exit when cur_rep%NOTFOUND;
    
    select count(1) into counter from report_field t where t.report = rep_id and t.r_query_field = rqf_id;
    if ( counter = 0 ) then
      if ( repf_pos_id is null ) then
        select max ( t.position ) + 1 into repf_pos_id from report_field t where t.report = rep_id;
        if ( repf_pos_id is null ) then
          repf_pos_id := 0;
        end if;
      else
        select count(1) into counter from report_field t where t.report = rep_id and position = repf_pos_id;
        if ( counter > 0 ) then
          --modificare le posizioni del corrente e dei successivi
          update report_field set position = ( position + 1 ) where report = rep_id and position >= repf_pos_id;
        end if;
      end if;
      
      if ( rqf_ord_by = 1 ) then
        select max(t.order_by) + 1 into rqf_ord_pos from report_field t where t.report = rep_id;
        if ( rqf_ord_pos is null ) then
          rqf_ord_pos := 0;
        end if;
      else
        rqf_ord_by_clau := null;
      end if;

      insert into report_field ( id, report, r_query_field, localization, width, position, order_by, order_by_clause )
      values ( report_field_seq.nextval, rep_id, rqf_id, loc_id, rqf_width, repf_pos_id, rqf_ord_pos, rqf_ord_by_clau );
    elsif ( counter = 1 and repf_pos_id is not null ) then
      select t.position into repf_pos_id_old from report_field t where t.report = rep_id and t.r_query_field = rqf_id;
      --spostiamo il campo in una posizione speciale
      update report_field set position = -1 where report = rep_id and position = repf_pos_id_old;
      if ( repf_pos_id_old > repf_pos_id ) then
        update report_field set position = ( position + 1 ) where report = rep_id and position >= repf_pos_id and position <= repf_pos_id_old;
      else
        update report_field set position = ( position - 1 ) where report = rep_id and position >= repf_pos_id_old and position <= repf_pos_id;
      end if;
      --spostiamo il campo in una posizione finale
      update report_field set position = repf_pos_id where report = rep_id and position = -1;
      update report_field set localization = loc_id where report = rep_id and r_query_field = rqf_id;
    end if;
    
    if ( loc_rename = false ) then
      update report_field set localization = loc_id where report = rep_id and r_query_field = rqf_id;
    end if;

    update report_field set width = rqf_width where report = rep_id;
  end loop;
  close cur_rep;
  --QUERY FIELD 08: END

  --QUERY FIELD 09: BEGIN
  rqf_id          := null;
  rqf_name_old    := rqf_name09_old;
  rqf_name        := rqf_name09;
  rqf_type        := rqf_type09;
  rqf_width       := rqf_width09;
  rqf_ord_by      := rqf_ord_by09;
  rqf_ord_by_clau := rqf_ord_by_clau09;
  rqf_ord_pos     := null;
  loc_id          := null;
  loc_code_old    := loc_code09_old;
  loc_code        := loc_code09;
  loc_rename      := loc_rename09;
  i18n_msg        := i18n_msg09;
  repf_pos_id_old := null;
  repf_pos_id     := repf_pos_id09;

  if ( rqf_name_old is null or rqf_name_old = rqf_name ) then
    select count(1) into counter from r_query_field t where t.r_query = rq_id and lower ( t.column_name ) = lower ( rqf_name );
    if ( counter = 0 ) then
      select r_query_field_seq.nextval into rqf_id from dual;
      
      insert into r_query_field ( id, r_query, column_name, title, type, width )
      values ( rqf_id, rq_id, rqf_name, loc_code, rqf_type, rqf_width );
    end if;
  elsif ( rqf_name_old is not null and rqf_name_old <> rqf_name ) then
    select count(1) into counter from r_query_field t where t.r_query = rq_id and lower ( t.column_name ) = lower ( rqf_name_old );
    if ( counter = 1 ) then
      select t.id into rqf_id from r_query_field t where t.r_query = rq_id and lower ( t.column_name ) = lower ( rqf_name_old );
      update r_query_field set column_name = rqf_name where id = rqf_id;
    end if;  
  end if;
  if ( rqf_id is null ) then
    select t.id into rqf_id from r_query_field t where t.r_query = rq_id and lower ( t.column_name ) = lower ( rqf_name );
  end if;
  
  if ( loc_code_old is null or loc_code_old = loc_code ) then
    select count(1) into counter from localization t where lower ( t.code ) = lower ( loc_code );
    if ( counter = 0 ) then
      select localization_seq.nextval into loc_id from dual;
      
      insert into localization ( id, code, code_type )
      values ( loc_id, loc_code, 0 );
    end if;
  elsif ( loc_code_old is not null and loc_code_old <> loc_code ) then
    if ( loc_rename = true ) then
      select count(1) into counter from localization t where lower ( t.code ) = lower ( loc_code_old );
      if ( counter = 1 ) then
        select count(1) into counter from localization t where lower ( t.code ) = lower ( loc_code );
        if ( counter = 0 ) then
          select t.id into loc_id from localization t where lower ( t.code ) = lower ( loc_code_old );
          update localization set code = loc_code where id = loc_id;
        end if;
        update r_query_field set title = loc_code where id = rqf_id;
      end if;
    else
      select count(1) into counter from localization t where lower ( t.code ) = lower ( loc_code_old );
      if ( counter = 1 ) then
        select count(1) into counter from localization t where lower ( t.code ) = lower ( loc_code );
        if ( counter = 0 ) then
          select localization_seq.nextval into loc_id from dual;
          
          insert into localization ( id, code, code_type )
          values ( loc_id, loc_code, 0 );
        end if;
        update r_query_field set title = loc_code where id = rqf_id;
      end if;
    end if;
  end if;
  if ( loc_id is null ) then
    select t.id into loc_id from localization t where lower ( t.code ) = lower ( loc_code );
  end if;

  open cur_lan for select t.id from language t where t.language_status > 0;
  loop
    fetch cur_lan into lan_id;
    exit when cur_lan%NOTFOUND;
    
    select count(1) into counter from i18n_message t where t.language = lan_id and t.localization = loc_id;
    if ( counter = 0 ) then
      insert into i18n_message ( id, localization, language, message )
      values ( i18n_message_seq.nextval, loc_id, lan_id, i18n_msg );
    else
      update i18n_message set message = i18n_msg where language = lan_id and localization = loc_id;
    end if;

  end loop;
  close cur_lan;

  open cur_rep for select t.id from report t where t.r_query = rq_id;
  loop
    fetch cur_rep into rep_id;
    exit when cur_rep%NOTFOUND;
    
    select count(1) into counter from report_field t where t.report = rep_id and t.r_query_field = rqf_id;
    if ( counter = 0 ) then
      if ( repf_pos_id is null ) then
        select max ( t.position ) + 1 into repf_pos_id from report_field t where t.report = rep_id;
        if ( repf_pos_id is null ) then
          repf_pos_id := 0;
        end if;
      else
        select count(1) into counter from report_field t where t.report = rep_id and position = repf_pos_id;
        if ( counter > 0 ) then
          --modificare le posizioni del corrente e dei successivi
          update report_field set position = ( position + 1 ) where report = rep_id and position >= repf_pos_id;
        end if;
      end if;
      
      if ( rqf_ord_by = 1 ) then
        select max(t.order_by) + 1 into rqf_ord_pos from report_field t where t.report = rep_id;
        if ( rqf_ord_pos is null ) then
          rqf_ord_pos := 0;
        end if;
      else
        rqf_ord_by_clau := null;
      end if;

      insert into report_field ( id, report, r_query_field, localization, width, position, order_by, order_by_clause )
      values ( report_field_seq.nextval, rep_id, rqf_id, loc_id, rqf_width, repf_pos_id, rqf_ord_pos, rqf_ord_by_clau );
    elsif ( counter = 1 and repf_pos_id is not null ) then
      select t.position into repf_pos_id_old from report_field t where t.report = rep_id and t.r_query_field = rqf_id;
      --spostiamo il campo in una posizione speciale
      update report_field set position = -1 where report = rep_id and position = repf_pos_id_old;
      if ( repf_pos_id_old > repf_pos_id ) then
        update report_field set position = ( position + 1 ) where report = rep_id and position >= repf_pos_id and position <= repf_pos_id_old;
      else
        update report_field set position = ( position - 1 ) where report = rep_id and position >= repf_pos_id_old and position <= repf_pos_id;
      end if;
      --spostiamo il campo in una posizione finale
      update report_field set position = repf_pos_id where report = rep_id and position = -1;
      update report_field set localization = loc_id where report = rep_id and r_query_field = rqf_id;
    end if;
    
    if ( loc_rename = false ) then
      update report_field set localization = loc_id where report = rep_id and r_query_field = rqf_id;
    end if;

    update report_field set width = rqf_width where report = rep_id;
  end loop;
  close cur_rep;
  --QUERY FIELD 09: END

  --REPORT FILTER 01: BEGIN
  repfr_id           := null;
  repfr_name_old     := repfr_name01_old;
  repfr_name         := repfr_name01;
  repfr_value        := repfr_value01;
  repfr_l_id         := null;
  repfr_l_code_old   := repfr_l_code01_old;
  repfr_l_code       := repfr_l_code01;
  repfr_i18n_msg     := repfr_i18n_msg01;
  repfr_vis          := repfr_vis01;
  repfr_mand         := repfr_mand01;
  repfr_type         := repfr_type01;
  repfr_cust_id      := null;
  repfr_cust_name    := repfr_cust_name01;
  repfr_pos_id_old   := null;
  repfr_pos_id       := repfr_pos_id01;

  if ( repfr_l_code_old is null or repfr_l_code_old = repfr_l_code ) then
    select count(1) into counter from localization t where lower ( t.code ) = lower ( repfr_l_code );
    if ( counter = 0 ) then
      select localization_seq.nextval into repfr_l_id from dual;
      
      insert into localization ( id, code, code_type )
      values ( repfr_l_id, repfr_l_code, 0 );
    end if;
  elsif ( repfr_l_code_old is not null and repfr_l_code_old <> repfr_l_code ) then
    select count(1) into counter from localization t where lower ( t.code ) = lower ( repfr_l_code_old );
    if ( counter = 1 ) then
      select t.id into repfr_l_id from localization t where lower ( t.code ) = lower ( repfr_l_code_old );
      update localization set code = repfr_l_code where lower ( code ) = lower ( repfr_l_code_old );
      update report_filter set filter = repfr_l_code where lower ( filter ) = lower ( repfr_l_code_old );
    end if;
  end if;
  if ( repfr_l_id is null ) then
    select t.id into repfr_l_id from localization t where lower ( t.code ) = lower ( repfr_l_code );
  end if;

  open cur_lan for select t.id from language t where t.language_status > 0;
  loop
    fetch cur_lan into lan_id;
    exit when cur_lan%NOTFOUND;
    
    select count(1) into counter from i18n_message t where t.language = lan_id and t.localization = repfr_l_id;
    if ( counter = 0 ) then
      insert into i18n_message ( id, localization, language, message )
      values ( i18n_message_seq.nextval, repfr_l_id, lan_id, repfr_i18n_msg );
    else
      update i18n_message set message = repfr_i18n_msg where language = lan_id and localization = repfr_l_id;
    end if;

  end loop;
  close cur_lan;

  open cur_rep for select t.id from report t where t.r_query = rq_id;
  loop
    fetch cur_rep into rep_id;
    exit when cur_rep%NOTFOUND;
    
    if ( repfr_cust_name is not null ) then
      select count(1) into counter from custom_filter t where lower ( t.name ) = lower ( repfr_cust_name );
      if ( counter = 1 ) then
        select t.id into repfr_cust_id from custom_filter t where lower ( t.name ) = lower ( repfr_cust_name );
      end if;
    else
      repfr_cust_id := null;
    end if;
    
    select count(1) into counter from report_filter t where t.report = rep_id and lower ( t.filter ) = lower ( repfr_name );
    if ( counter = 0 ) then
      if ( repfr_pos_id is null ) then
        select max ( t.position ) + 1 into repfr_pos_id from report_filter t where t.report = rep_id;
        if ( repfr_pos_id is null ) then
          repfr_pos_id := 1;
        end if;
      else
        --modificare le posizioni del corrente e dei successivi
        update report_filter set position = ( position + 1 ) where report = rep_id and position >= repfr_pos_id;
      end if;
      
      select report_filter_seq.nextval into repfr_id from dual;

      insert into report_filter ( id, report, filter, value, localization, state, type, position, custom_filter, description, mandatory )
      values ( repfr_id, rep_id, repfr_name, repfr_value, repfr_l_id, repfr_vis, repfr_type, repfr_pos_id, repfr_cust_id, null, repfr_mand );
    elsif ( counter = 1 and repfr_pos_id is not null ) then
      select t.position into repfr_pos_id_old from report_filter t where t.report = rep_id and lower ( t.filter ) = lower ( repfr_name );
      --spostiamo il campo in una posizione speciale
      update report_filter set position = -1 where report = rep_id and position = repfr_pos_id_old;
      if ( repfr_pos_id_old > repfr_pos_id ) then
        update report_filter set position = ( position + 1 ) where report = rep_id and position >= repfr_pos_id and position <= repfr_pos_id_old;
      else
        update report_filter set position = ( position - 1 ) where report = rep_id and position >= repfr_pos_id_old and position <= repfr_pos_id;
      end if;
      --spostiamo il campo in una posizione finale
      update report_filter set position = repfr_pos_id where report = rep_id and position = -1;
    end if;

  end loop;
  close cur_rep;
  --REPORT FILTER 01: END

end;
/

commit;
