declare
  r_name_old           varchar2(256) := 'User violations';
  r_name               varchar2(256) := 'User violations';
  --se 0  un report, se 1  un dashboard
  r_dashboard          number(1) := 1;

  rq_name_old          varchar2(256) := 'User violations DB';
  rq_name              varchar2(256) := 'User violations DB';

  r_rename             boolean := false;
  rq_rename            boolean := false;

  r_id                 number(16);
  rq_id                number(16);

  counter              number(16);
begin
  --sezione query
  if ( rq_name <> rq_name_old ) then
    select count(1) into counter from r_query t where lower ( t.name ) = lower ( rq_name_old ) and t.product = 1;
    if ( counter = 1 ) then
      rq_rename := true;
    end if;
  end if;

  if ( rq_rename = true ) then
    select count(1) into counter from r_query t where lower ( t.name ) = lower ( rq_name_old ) and t.product = 1;
  else
    select count(1) into counter from r_query t where lower ( t.name ) = lower ( rq_name ) and t.product = 1;
  end if;

  if ( r_name <> r_name_old ) then
    select count(1) into counter from report t where lower ( t.name ) = lower ( r_name_old ) and t.dashboard = r_dashboard and t.product = 1;
    if ( counter = 1 ) then
      r_rename := true;
    end if;
  end if;

  if ( r_rename = true ) then
    select count(1) into counter from report t where lower ( t.name ) = lower ( r_name_old ) and t.dashboard = r_dashboard and t.product = 1;
  else
    select count(1) into counter from report t where lower ( t.name ) = lower ( r_name ) and t.dashboard = r_dashboard and t.product = 1;
  end if;

  select t.id, t.r_query into r_id, rq_id from report t where lower ( t.name ) = lower ( r_name ) and t.dashboard = r_dashboard;

  select count(1) into counter from r_query_field t where t.r_query = rq_id;
  if ( counter > 0 ) then
    delete from r_query_field where r_query = rq_id;
  end if;

  select count(1) into counter from r_query_visibility t where t.r_query = rq_id;
  if ( counter > 0 ) then
    delete from r_query_visibility where r_query = rq_id;
  end if;

  select count(1) into counter from report_visibility t where t.report = r_id;
  if ( counter > 0 ) then
    delete from report_visibility where report = r_id;
  end if;

  select count(1) into counter from report_filter t where t.report = r_id;
  if ( counter > 0 ) then
    delete from report_filter where report = r_id;
  end if;
end;
/
commit;

declare
  counter              number(16);
  
  --report type
  rt_id                number(16);
  rt_name              varchar2(256) := '';
  rt_desc              varchar2(512) := '';

  --report parent
  rp_id                number(16);
  rp_name              varchar2(256) := '';

  r_id                 number(16);
  r_name_old           varchar2(256) := 'User violations';
  r_name               varchar2(256) := 'User violations';
  r_desc               varchar2(512) := '';
  r_code               varchar2(256) := null;
  r_i18n_mess          varchar2(256) := null;
  --se 0  un report, se 1  un dashboard
  r_dashboard          number(1) := 1;
  
  ra_name01            varchar2(256) := 'CHART';
  ra_value01           varchar2(256) := '0';

  ra_id                number(16);
  ra_name              varchar2(256);
  ra_value             varchar2(256);

  r_loc_id             number(16);
  r_loc_code           varchar2(256);

  r_rename             boolean := false;

  rq_id                number(16);
  rq_name_old          varchar2(256) := 'User violations DB';
  rq_name              varchar2(256) := 'User violations DB';
  rq_desc              varchar2(512) := '';
  rqd                  clob;

  rq_rename            boolean := false;

  rv_name01            varchar2(256) := 'AG-Core Org. Unit';
  repv_vis_type01      number(2) := 3;

  rv_id                number(16);
  rv_name              varchar2(256);
  rv_ent_id            number(16);
  repv_vis_type        number(2);
  rq_vis_pos           number(16);

  rqf_type_def         varchar2(256) := 'java.lang.String';
  rqf_width_def        number(16) := 300;

  rqf_id               number(16);
  rqf_name_old         varchar2(256);
  rqf_name             varchar2(256);
  rqf_type             varchar2(256);
  rqf_width            number(16);
  rqf_ord_by           number(1);
  rqf_ord_by_clau      varchar2(256);
  rqf_ord_pos          number(16);
  loc_id               number(16);
  loc_code_old         varchar2(256);
  loc_code             varchar2(256);
  loc_rename           boolean;
  i18n_msg             varchar2(256);
  repf_pos_id          number(16);
  repf_pos_id_old      number(16);

  --Si puo' modificare un campo esistente, se null si inserisce
  rqf_name01_old       varchar2(256) := null;
  rqf_name01           varchar2(256) := 'VIOLATION_SEVERITY';
  rqf_type01           varchar2(256) := rqf_type_def;
  rqf_width01          varchar2(256) := rqf_width_def;
  rqf_ord_by01         number(1)     := 0;
  rqf_ord_by_clau01    varchar2(256) := 'ASC';
  --Si puo' modificare un campo esistente, se null si inserisce
  loc_code01_old       varchar2(256) := null;
  loc_code01           varchar2(256) := 'dashboard.violation.severity';
  loc_rename01         boolean       := true;
  i18n_msg01           varchar2(256) := 'Risk';
  --Si puo' scegliere la posizione della colonna nel report. Gli indici iniziano da 0
  --Se il campo e' null viene lasciato per ultimo
  repf_pos_id01        number(16)    := null;

  --Si puo' modificare un campo esistente, se null si inserisce
  rqf_name02_old       varchar2(256) := null;
  rqf_name02           varchar2(256) := 'MITIGATION';
  rqf_type02           varchar2(256) := rqf_type_def;
  rqf_width02          varchar2(256) := rqf_width_def;
  rqf_ord_by02         number(1)     := 0;
  rqf_ord_by_clau02    varchar2(256) := 'ASC';
  --Si puo' modificare un campo esistente, se null si inserisce
  loc_code02_old       varchar2(256) := null;
  loc_code02           varchar2(256) := 'mitigation.level';
  loc_rename02         boolean       := true;
  i18n_msg02           varchar2(256) := 'Mitigation Level';
  --Si puo' scegliere la posizione della colonna nel report. Gli indici iniziano da 0
  --Se il campo e' null viene lasciato per ultimo
  repf_pos_id02        number(16)    := null;

  --Si puo' modificare un campo esistente, se null si inserisce
  rqf_name03_old       varchar2(256) := null;
  rqf_name03           varchar2(256) := 'USER_NAME';
  rqf_type03           varchar2(256) := rqf_type_def;
  rqf_width03          varchar2(256) := rqf_width_def;
  rqf_ord_by03         number(1)     := 0;
  rqf_ord_by_clau03    varchar2(256) := 'ASC';
  --Si puo' modificare un campo esistente, se null si inserisce
  loc_code03_old       varchar2(256) := null;
  loc_code03           varchar2(256) := 'user.name';
  loc_rename03         boolean       := true;
  i18n_msg03           varchar2(256) := 'First Name';
  --Si puo' scegliere la posizione della colonna nel report. Gli indici iniziano da 0
  --Se il campo e' null viene lasciato per ultimo
  repf_pos_id03        number(16)    := null;

  --Si puo' modificare un campo esistente, se null si inserisce
  rqf_name04_old       varchar2(256) := null;
  rqf_name04           varchar2(256) := 'USER_SURNAME';
  rqf_type04           varchar2(256) := rqf_type_def;
  rqf_width04          varchar2(256) := rqf_width_def;
  rqf_ord_by04         number(1)     := 0;
  rqf_ord_by_clau04    varchar2(256) := 'ASC';
  --Si puo' modificare un campo esistente, se null si inserisce
  loc_code04_old       varchar2(256) := null;
  loc_code04           varchar2(256) := 'user.surname';
  loc_rename04         boolean       := true;
  i18n_msg04           varchar2(256) := 'Last Name';
  --Si puo' scegliere la posizione della colonna nel report. Gli indici iniziano da 0
  --Se il campo e' null viene lasciato per ultimo
  repf_pos_id04        number(16)    := null;

  --Si puo' modificare un campo esistente, se null si inserisce
  rqf_name05_old       varchar2(256) := null;
  rqf_name05           varchar2(256) := 'USER_CODE';
  rqf_type05           varchar2(256) := rqf_type_def;
  rqf_width05          varchar2(256) := rqf_width_def;
  rqf_ord_by05         number(1)     := 0;
  rqf_ord_by_clau05    varchar2(256) := 'ASC';
  --Si puo' modificare un campo esistente, se null si inserisce
  loc_code05_old       varchar2(256) := null;
  loc_code05           varchar2(256) := 'dashboard.user.code';
  loc_rename05         boolean       := true;
  i18n_msg05           varchar2(256) := 'User Id';
  --Si puo' scegliere la posizione della colonna nel report. Gli indici iniziano da 0
  --Se il campo e' null viene lasciato per ultimo
  repf_pos_id05        number(16)    := null;

  --Si puo' modificare un campo esistente, se null si inserisce
  rqf_name06_old       varchar2(256) := null;
  rqf_name06           varchar2(256) := 'USER_DN';
  rqf_type06           varchar2(256) := rqf_type_def;
  rqf_width06          varchar2(256) := rqf_width_def;
  rqf_ord_by06         number(1)     := 0;
  rqf_ord_by_clau06    varchar2(256) := 'ASC';
  --Si puo' modificare un campo esistente, se null si inserisce
  loc_code06_old       varchar2(256) := null;
  loc_code06           varchar2(256) := 'user.dn';
  loc_rename06         boolean       := true;
  i18n_msg06           varchar2(256) := 'User DN';
  --Si puo' scegliere la posizione della colonna nel report. Gli indici iniziano da 0
  --Se il campo e' null viene lasciato per ultimo
  repf_pos_id06        number(16)    := null;

  repfr_id             number(16);
  repfr_name_old       varchar2(256);
  repfr_name           varchar2(256);
  repfr_value          varchar2(256);
  repfr_l_id           number(16);
  repfr_l_code_old     varchar2(256);
  repfr_l_code         varchar2(256);
  repfr_i18n_msg       varchar2(256);
  repfr_vis            number(16);
  repfr_mand           number(16);
  repfr_type           number(16);
  repfr_cust_id        number(16);
  repfr_cust_name      varchar2(256);
  repfr_pos_id         number(16);
  repfr_pos_id_old     number(16);

  cur_lan              sys_refcursor;
  lan_id               number(16);

  cur_rep              sys_refcursor;
  rep_id               number(16);

begin
  rqd := 'select distinct
'||'  case
'||'    when t.violation_sev = ''01'' then ''High''
'||'    when t.violation_sev = ''02'' then ''Medium''
'||'    when t.violation_sev = ''03'' then ''Low''
'||'  end as violation_severity,
'||'  t.mitigation,
'||'  t.user_name,
'||'  t.user_surname,
'||'  t.user_code,
'||'  t.user_dn
'||'from
'||'(
'||'  select
'||'    case
'||'      when pi.high > 0 then ''01''
'||'      when pi.high = 0 and pi.medium > 0 then ''02''
'||'      when pi.high = 0 and pi.medium = 0 and pi.low > 0 then ''03''
'||'    end as violation_sev,
'||'    case
'||'      when pi.rem_under > 0 and pi.rem_over > 0 then ''Under/Over Mitigation''
'||'      when pi.rem_under > 0 then ''Under Mitigation''
'||'      when pi.rem > 0 then ''Complete Mitigation''
'||'      when pi.rem_over > 0 then ''Over Mitigation''
'||'    end as mitigation,
'||'    p.name as user_name,
'||'    p.surname as user_surname,
'||'    p.code as user_code,
'||'    p.dn as user_dn
'||'  from
'||'    #schema_tmp#.tmp_rep_organizational_unit tmpou,
'||'    #pmschema#.group_person                       gp,
'||'    #pmschema#.person                             p,
'||'    #pmschema#.person_incomp                      pi,
'||'    #pmschema#.environment                        env
'||'  where tmpou.id = gp.organizational_unit
'||'    and gp.person = p.id
'||'    and p.id = pi.person
'||'    and pi.environment = env.id
'||'    and gp.hierarchy = 1
'||'    and env.working = 1
'||'    and pi.comp_time > 0
'||') t
'||'';

  --sezione query
  if ( rq_name <> rq_name_old ) then
    select count(1) into counter from r_query t where lower ( t.name ) = lower ( rq_name_old ) and t.product = 1;
    if ( counter = 1 ) then
      rq_rename := true;
    end if;
  end if;

  if ( rq_rename = true ) then
    select count(1) into counter from r_query t where lower ( t.name ) = lower ( rq_name_old ) and t.product = 1;
  else
    select count(1) into counter from r_query t where lower ( t.name ) = lower ( rq_name ) and t.product = 1;
  end if;
  if ( counter = 0 ) then
    select max(id) + 1 into rq_id from r_query t;

    insert into r_query ( id, name, description, product )
    values ( rq_id, rq_name, rq_desc, 1 );

    insert into r_query_data ( r_query, query )
    values ( rq_id, rqd );
  else
    if ( rq_rename = true ) then
      select t.id into rq_id from r_query t where lower ( t.name ) = lower ( rq_name_old ) and t.product = 1;
    else
      select t.id into rq_id from r_query t where lower ( t.name ) = lower ( rq_name ) and t.product = 1;
    end if;
    
    update r_query_data set query = rqd where r_query = rq_id;
  end if;
  
  --modifica il nome della query
  if ( rq_rename = true ) then
    update r_query set name = rq_name where id = rq_id;
  end if;
  
  --sezione report
  if ( r_name <> r_name_old ) then
    select count(1) into counter from report t where lower ( t.name ) = lower ( r_name_old ) and t.dashboard = r_dashboard and t.product = 1;
    if ( counter = 1 ) then
      r_rename := true;
    end if;
  end if;

  if ( r_rename = true ) then
    select count(1) into counter from report t where lower ( t.name ) = lower ( r_name_old ) and t.dashboard = r_dashboard and t.product = 1;
  else
    select count(1) into counter from report t where lower ( t.name ) = lower ( r_name ) and t.dashboard = r_dashboard and t.product = 1;
  end if;
  if ( counter = 0 ) then
    --localization code for report
    if ( r_loc_code is null ) then
      /*DBALT-BEGIN*/
      select dbms_random.random into r_loc_code from dual;
      /*PG*select trunc(random()*1000) into r_loc_code from generate_series(1,1000) limit 1;*PG*/
      /*DB2*select int((rand()-0.5) * 32768) into r_loc_code from dual;*DB2*/
      /*DBALT-END*/

      select count(1) into counter from localization t where lower ( t.code ) = lower ( r_loc_code );
      if ( counter = 0 ) then
        select localization_seq.nextval into r_loc_id from dual;
        
        insert into localization ( id, code, code_type )
        values ( r_loc_id, r_loc_code, 0 );
      end if;
    elsif ( r_loc_code is not null ) then
      select count(1) into counter from localization t where lower ( t.code ) = lower ( r_loc_code );
      if ( counter = 1 ) then
        select t.id into r_loc_id from localization t where lower ( t.code ) = lower ( r_loc_code );
      end if;
    end if;
    if ( r_loc_id is null ) then
      select t.id into r_loc_id from localization t where lower ( t.code ) = lower ( r_loc_code );
    end if;

    select max(id) + 1 into r_id from report t;
    
    if ( rt_name is not null or length ( rt_name ) > 0 ) then
      select count(1) into counter from report_type t where lower ( t.name ) = lower ( rt_name );
      if ( counter = 0 ) then
        select ( max(id) +1 ) into rt_id from report_type t;

        insert into report_type ( id, name, description )
        values ( rt_id, rt_name, rt_desc );
      else
        select t.id into rt_id from report_type t where lower ( t.name ) = lower ( rt_name );
      end if;
    end if;


    insert into report ( id, name, description, localization, r_query, status, report_type, code, product, parent, dashboard )
    values ( r_id, r_name, r_desc, r_loc_id, rq_id, 0, rt_id, r_code, 1, 1, r_dashboard );
    
    insert into report_attribute ( id, report, name, value )
    values ( report_attribute_seq.nextval, r_id, 'PRIORITY', '0' );
    if ( r_dashboard = 0 ) then 
      insert into report_attribute ( id, report, name, value )
      values ( report_attribute_seq.nextval, r_id, 'ORIENTATION', '1' );
      insert into report_attribute ( id, report, name, value )
      values ( report_attribute_seq.nextval, r_id, 'MAX_ROW', null );
      insert into report_attribute ( id, report, name, value )
      values ( report_attribute_seq.nextval, r_id, 'FORMAT', 'pdf' );
      insert into report_attribute ( id, report, name, value )
      values ( report_attribute_seq.nextval, r_id, 'FORMAT', 'xlsx' );
    elsif ( r_dashboard = 1 ) then
      null;
    end if;    
  else
    --ORACLE BUG ON REPORT_LNAME_DASHBOARD_IDX INDEX
    --ORA-03113 end-of-file on communication channel
    --caused by
    --ORA-07445: trovata eccezione: dump della memoria [qcdlgcd()+70] [SIGSEGV] [ADDR:0x4] [PC:0xCEA8796] [Address not mapped to object] []
    if ( r_rename = true ) then
      select t.id, t.name into r_id, r_name_old from report t where lower ( t.name ) = lower ( r_name_old ) and t.dashboard = r_dashboard and t.product = 1;
    else
      select t.id, t.name into r_id, r_name from report t where lower ( t.name ) = lower ( r_name ) and t.dashboard = r_dashboard and t.product = 1;
    end if;
    
    select t.localization into r_loc_id from report t where t.id = r_id;
  end if;

  if ( r_i18n_mess is null or length ( r_i18n_mess ) = 0 ) then
    r_i18n_mess := r_name;
  end if;

  --modifica il nome del report
  if ( r_rename = true ) then
    update report set name = r_name where id = r_id;
    update i18n_message set message = r_i18n_mess where localization = ( select t.localization from report t where t.id = r_id );
  end if;
  
  --inserimento o modifica dei messaggi di localizzazione
  open cur_lan for select t.id from language t where t.language_status > 0;
  loop
    fetch cur_lan into lan_id;
    exit when cur_lan%NOTFOUND;
      
    select count(1) into counter from i18n_message t where t.language = lan_id and t.localization = r_loc_id;
    if ( counter = 0 ) then
      insert into i18n_message ( id, localization, language, message )
      values ( i18n_message_seq.nextval, r_loc_id, lan_id, r_i18n_mess );
    else
      update i18n_message set message = r_i18n_mess where language = lan_id and localization = r_loc_id;
    end if;

  end loop;
  close cur_lan;

  --report parent
  select count(1) into counter from (
    select distinct r.id from report r, localization l, i18n_message i18
    where r.localization = l.id and r.leaf = 0 and l.id = i18.localization
    and i18.message = rp_name and r.dashboard = r_dashboard ) t;
  if ( counter = 1 ) then
    select distinct r.id into rp_id from report r, localization l, i18n_message i18
    where r.localization = l.id and r.leaf = 0 and l.id = i18.localization
    and i18.message = rp_name and r.dashboard = r_dashboard;
    
    update report set parent = rp_id where id = r_id;
  end if;

  --REPORT ATTRIBUTE 01: BEGIN
  ra_name         := ra_name01;
  ra_value        := ra_value01;
  select count(1) into counter from report_attribute t where t.report = r_id and lower ( t.name ) = lower ( ra_name );
  if ( counter = 0 ) then
    insert into report_attribute ( id, report, name, value )
    values ( report_attribute_seq.nextval, r_id, ra_name, ra_value );
  else
    select t.id into ra_id from report_attribute t where t.report = r_id and lower ( t.name ) = lower ( ra_name );
    update report_attribute set value = ra_value where id = ra_id;
  end if;
  --REPORT ATTRIBUTE 01: END

  --QUERY FIELD 01: BEGIN
  rqf_id          := null;
  rqf_name_old    := rqf_name01_old;
  rqf_name        := rqf_name01;
  rqf_type        := rqf_type01;
  rqf_width       := rqf_width01;
  rqf_ord_by      := rqf_ord_by01;
  rqf_ord_by_clau := rqf_ord_by_clau01;
  rqf_ord_pos     := null;
  loc_id          := null;
  loc_code_old    := loc_code01_old;
  loc_code        := loc_code01;
  loc_rename      := loc_rename01;
  i18n_msg        := i18n_msg01;
  repf_pos_id_old := null;
  repf_pos_id     := repf_pos_id01;

  if ( rqf_name_old is null or rqf_name_old = rqf_name ) then
    select count(1) into counter from r_query_field t where t.r_query = rq_id and lower ( t.column_name ) = lower ( rqf_name );
    if ( counter = 0 ) then
      select r_query_field_seq.nextval into rqf_id from dual;
      
      insert into r_query_field ( id, r_query, column_name, title, type, width )
      values ( rqf_id, rq_id, rqf_name, loc_code, rqf_type, rqf_width );
    end if;
  elsif ( rqf_name_old is not null and rqf_name_old <> rqf_name ) then
    select count(1) into counter from r_query_field t where t.r_query = rq_id and lower ( t.column_name ) = lower ( rqf_name_old );
    if ( counter = 1 ) then
      select t.id into rqf_id from r_query_field t where t.r_query = rq_id and lower ( t.column_name ) = lower ( rqf_name_old );
      update r_query_field set column_name = rqf_name where id = rqf_id;
    end if;  
  end if;
  if ( rqf_id is null ) then
    select t.id into rqf_id from r_query_field t where t.r_query = rq_id and lower ( t.column_name ) = lower ( rqf_name );
  end if;
  
  if ( loc_code_old is null or loc_code_old = loc_code ) then
    select count(1) into counter from localization t where lower ( t.code ) = lower ( loc_code );
    if ( counter = 0 ) then
      select localization_seq.nextval into loc_id from dual;
      
      insert into localization ( id, code, code_type )
      values ( loc_id, loc_code, 0 );
    end if;
  elsif ( loc_code_old is not null and loc_code_old <> loc_code ) then
    if ( loc_rename = true ) then
      select count(1) into counter from localization t where lower ( t.code ) = lower ( loc_code_old );
      if ( counter = 1 ) then
        select count(1) into counter from localization t where lower ( t.code ) = lower ( loc_code );
        if ( counter = 0 ) then
          select t.id into loc_id from localization t where lower ( t.code ) = lower ( loc_code_old );
          update localization set code = loc_code where id = loc_id;
        end if;
        update r_query_field set title = loc_code where id = rqf_id;
      end if;
    else
      select count(1) into counter from localization t where lower ( t.code ) = lower ( loc_code_old );
      if ( counter = 1 ) then
        select count(1) into counter from localization t where lower ( t.code ) = lower ( loc_code );
        if ( counter = 0 ) then
          select localization_seq.nextval into loc_id from dual;
          
          insert into localization ( id, code, code_type )
          values ( loc_id, loc_code, 0 );
        end if;
        update r_query_field set title = loc_code where id = rqf_id;
      end if;
    end if;
  end if;
  if ( loc_id is null ) then
    select t.id into loc_id from localization t where lower ( t.code ) = lower ( loc_code );
  end if;

  open cur_lan for select t.id from language t where t.language_status > 0;
  loop
    fetch cur_lan into lan_id;
    exit when cur_lan%NOTFOUND;
    
    select count(1) into counter from i18n_message t where t.language = lan_id and t.localization = loc_id;
    if ( counter = 0 ) then
      insert into i18n_message ( id, localization, language, message )
      values ( i18n_message_seq.nextval, loc_id, lan_id, i18n_msg );
    else
      update i18n_message set message = i18n_msg where language = lan_id and localization = loc_id;
    end if;

  end loop;
  close cur_lan;

  open cur_rep for select t.id from report t where t.r_query = rq_id;
  loop
    fetch cur_rep into rep_id;
    exit when cur_rep%NOTFOUND;
    
    select count(1) into counter from report_field t where t.report = rep_id and t.r_query_field = rqf_id;
    if ( counter = 0 ) then
      if ( repf_pos_id is null ) then
        select max ( t.position ) + 1 into repf_pos_id from report_field t where t.report = rep_id;
        if ( repf_pos_id is null ) then
          repf_pos_id := 0;
        end if;
      else
        select count(1) into counter from report_field t where t.report = rep_id and position = repf_pos_id;
        if ( counter > 0 ) then
          --modificare le posizioni del corrente e dei successivi
          update report_field set position = ( position + 1 ) where report = rep_id and position >= repf_pos_id;
        end if;
      end if;
      
      if ( rqf_ord_by = 1 ) then
        select max(t.order_by) + 1 into rqf_ord_pos from report_field t where t.report = rep_id;
        if ( rqf_ord_pos is null ) then
          rqf_ord_pos := 0;
        end if;
      else
        rqf_ord_by_clau := null;
      end if;

      insert into report_field ( id, report, r_query_field, localization, width, position, order_by, order_by_clause )
      values ( report_field_seq.nextval, rep_id, rqf_id, loc_id, rqf_width, repf_pos_id, rqf_ord_pos, rqf_ord_by_clau );
    elsif ( counter = 1 and repf_pos_id is not null ) then
      select t.position into repf_pos_id_old from report_field t where t.report = rep_id and t.r_query_field = rqf_id;
      --spostiamo il campo in una posizione speciale
      update report_field set position = -1 where report = rep_id and position = repf_pos_id_old;
      if ( repf_pos_id_old > repf_pos_id ) then
        update report_field set position = ( position + 1 ) where report = rep_id and position >= repf_pos_id and position <= repf_pos_id_old;
      else
        update report_field set position = ( position - 1 ) where report = rep_id and position >= repf_pos_id_old and position <= repf_pos_id;
      end if;
      --spostiamo il campo in una posizione finale
      update report_field set position = repf_pos_id where report = rep_id and position = -1;
      update report_field set localization = loc_id where report = rep_id and r_query_field = rqf_id;
    end if;
    
    if ( loc_rename = false ) then
      update report_field set localization = loc_id where report = rep_id and r_query_field = rqf_id;
    end if;

    update report_field set width = rqf_width where report = rep_id;
  end loop;
  close cur_rep;
  --QUERY FIELD 01: END

  --QUERY FIELD 02: BEGIN
  rqf_id          := null;
  rqf_name_old    := rqf_name02_old;
  rqf_name        := rqf_name02;
  rqf_type        := rqf_type02;
  rqf_width       := rqf_width02;
  rqf_ord_by      := rqf_ord_by02;
  rqf_ord_by_clau := rqf_ord_by_clau02;
  rqf_ord_pos     := null;
  loc_id          := null;
  loc_code_old    := loc_code02_old;
  loc_code        := loc_code02;
  loc_rename      := loc_rename02;
  i18n_msg        := i18n_msg02;
  repf_pos_id_old := null;
  repf_pos_id     := repf_pos_id02;

  if ( rqf_name_old is null or rqf_name_old = rqf_name ) then
    select count(1) into counter from r_query_field t where t.r_query = rq_id and lower ( t.column_name ) = lower ( rqf_name );
    if ( counter = 0 ) then
      select r_query_field_seq.nextval into rqf_id from dual;
      
      insert into r_query_field ( id, r_query, column_name, title, type, width )
      values ( rqf_id, rq_id, rqf_name, loc_code, rqf_type, rqf_width );
    end if;
  elsif ( rqf_name_old is not null and rqf_name_old <> rqf_name ) then
    select count(1) into counter from r_query_field t where t.r_query = rq_id and lower ( t.column_name ) = lower ( rqf_name_old );
    if ( counter = 1 ) then
      select t.id into rqf_id from r_query_field t where t.r_query = rq_id and lower ( t.column_name ) = lower ( rqf_name_old );
      update r_query_field set column_name = rqf_name where id = rqf_id;
    end if;  
  end if;
  if ( rqf_id is null ) then
    select t.id into rqf_id from r_query_field t where t.r_query = rq_id and lower ( t.column_name ) = lower ( rqf_name );
  end if;
  
  if ( loc_code_old is null or loc_code_old = loc_code ) then
    select count(1) into counter from localization t where lower ( t.code ) = lower ( loc_code );
    if ( counter = 0 ) then
      select localization_seq.nextval into loc_id from dual;
      
      insert into localization ( id, code, code_type )
      values ( loc_id, loc_code, 0 );
    end if;
  elsif ( loc_code_old is not null and loc_code_old <> loc_code ) then
    if ( loc_rename = true ) then
      select count(1) into counter from localization t where lower ( t.code ) = lower ( loc_code_old );
      if ( counter = 1 ) then
        select count(1) into counter from localization t where lower ( t.code ) = lower ( loc_code );
        if ( counter = 0 ) then
          select t.id into loc_id from localization t where lower ( t.code ) = lower ( loc_code_old );
          update localization set code = loc_code where id = loc_id;
        end if;
        update r_query_field set title = loc_code where id = rqf_id;
      end if;
    else
      select count(1) into counter from localization t where lower ( t.code ) = lower ( loc_code_old );
      if ( counter = 1 ) then
        select count(1) into counter from localization t where lower ( t.code ) = lower ( loc_code );
        if ( counter = 0 ) then
          select localization_seq.nextval into loc_id from dual;
          
          insert into localization ( id, code, code_type )
          values ( loc_id, loc_code, 0 );
        end if;
        update r_query_field set title = loc_code where id = rqf_id;
      end if;
    end if;
  end if;
  if ( loc_id is null ) then
    select t.id into loc_id from localization t where lower ( t.code ) = lower ( loc_code );
  end if;

  open cur_lan for select t.id from language t where t.language_status > 0;
  loop
    fetch cur_lan into lan_id;
    exit when cur_lan%NOTFOUND;
    
    select count(1) into counter from i18n_message t where t.language = lan_id and t.localization = loc_id;
    if ( counter = 0 ) then
      insert into i18n_message ( id, localization, language, message )
      values ( i18n_message_seq.nextval, loc_id, lan_id, i18n_msg );
    else
      update i18n_message set message = i18n_msg where language = lan_id and localization = loc_id;
    end if;

  end loop;
  close cur_lan;

  open cur_rep for select t.id from report t where t.r_query = rq_id;
  loop
    fetch cur_rep into rep_id;
    exit when cur_rep%NOTFOUND;
    
    select count(1) into counter from report_field t where t.report = rep_id and t.r_query_field = rqf_id;
    if ( counter = 0 ) then
      if ( repf_pos_id is null ) then
        select max ( t.position ) + 1 into repf_pos_id from report_field t where t.report = rep_id;
        if ( repf_pos_id is null ) then
          repf_pos_id := 0;
        end if;
      else
        select count(1) into counter from report_field t where t.report = rep_id and position = repf_pos_id;
        if ( counter > 0 ) then
          --modificare le posizioni del corrente e dei successivi
          update report_field set position = ( position + 1 ) where report = rep_id and position >= repf_pos_id;
        end if;
      end if;
      
      if ( rqf_ord_by = 1 ) then
        select max(t.order_by) + 1 into rqf_ord_pos from report_field t where t.report = rep_id;
        if ( rqf_ord_pos is null ) then
          rqf_ord_pos := 0;
        end if;
      else
        rqf_ord_by_clau := null;
      end if;

      insert into report_field ( id, report, r_query_field, localization, width, position, order_by, order_by_clause )
      values ( report_field_seq.nextval, rep_id, rqf_id, loc_id, rqf_width, repf_pos_id, rqf_ord_pos, rqf_ord_by_clau );
    elsif ( counter = 1 and repf_pos_id is not null ) then
      select t.position into repf_pos_id_old from report_field t where t.report = rep_id and t.r_query_field = rqf_id;
      --spostiamo il campo in una posizione speciale
      update report_field set position = -1 where report = rep_id and position = repf_pos_id_old;
      if ( repf_pos_id_old > repf_pos_id ) then
        update report_field set position = ( position + 1 ) where report = rep_id and position >= repf_pos_id and position <= repf_pos_id_old;
      else
        update report_field set position = ( position - 1 ) where report = rep_id and position >= repf_pos_id_old and position <= repf_pos_id;
      end if;
      --spostiamo il campo in una posizione finale
      update report_field set position = repf_pos_id where report = rep_id and position = -1;
      update report_field set localization = loc_id where report = rep_id and r_query_field = rqf_id;
    end if;
    
    if ( loc_rename = false ) then
      update report_field set localization = loc_id where report = rep_id and r_query_field = rqf_id;
    end if;

    update report_field set width = rqf_width where report = rep_id;
  end loop;
  close cur_rep;
  --QUERY FIELD 02: END

  --QUERY FIELD 03: BEGIN
  rqf_id          := null;
  rqf_name_old    := rqf_name03_old;
  rqf_name        := rqf_name03;
  rqf_type        := rqf_type03;
  rqf_width       := rqf_width03;
  rqf_ord_by      := rqf_ord_by03;
  rqf_ord_by_clau := rqf_ord_by_clau03;
  rqf_ord_pos     := null;
  loc_id          := null;
  loc_code_old    := loc_code03_old;
  loc_code        := loc_code03;
  loc_rename      := loc_rename03;
  i18n_msg        := i18n_msg03;
  repf_pos_id_old := null;
  repf_pos_id     := repf_pos_id03;

  if ( rqf_name_old is null or rqf_name_old = rqf_name ) then
    select count(1) into counter from r_query_field t where t.r_query = rq_id and lower ( t.column_name ) = lower ( rqf_name );
    if ( counter = 0 ) then
      select r_query_field_seq.nextval into rqf_id from dual;
      
      insert into r_query_field ( id, r_query, column_name, title, type, width )
      values ( rqf_id, rq_id, rqf_name, loc_code, rqf_type, rqf_width );
    end if;
  elsif ( rqf_name_old is not null and rqf_name_old <> rqf_name ) then
    select count(1) into counter from r_query_field t where t.r_query = rq_id and lower ( t.column_name ) = lower ( rqf_name_old );
    if ( counter = 1 ) then
      select t.id into rqf_id from r_query_field t where t.r_query = rq_id and lower ( t.column_name ) = lower ( rqf_name_old );
      update r_query_field set column_name = rqf_name where id = rqf_id;
    end if;  
  end if;
  if ( rqf_id is null ) then
    select t.id into rqf_id from r_query_field t where t.r_query = rq_id and lower ( t.column_name ) = lower ( rqf_name );
  end if;
  
  if ( loc_code_old is null or loc_code_old = loc_code ) then
    select count(1) into counter from localization t where lower ( t.code ) = lower ( loc_code );
    if ( counter = 0 ) then
      select localization_seq.nextval into loc_id from dual;
      
      insert into localization ( id, code, code_type )
      values ( loc_id, loc_code, 0 );
    end if;
  elsif ( loc_code_old is not null and loc_code_old <> loc_code ) then
    if ( loc_rename = true ) then
      select count(1) into counter from localization t where lower ( t.code ) = lower ( loc_code_old );
      if ( counter = 1 ) then
        select count(1) into counter from localization t where lower ( t.code ) = lower ( loc_code );
        if ( counter = 0 ) then
          select t.id into loc_id from localization t where lower ( t.code ) = lower ( loc_code_old );
          update localization set code = loc_code where id = loc_id;
        end if;
        update r_query_field set title = loc_code where id = rqf_id;
      end if;
    else
      select count(1) into counter from localization t where lower ( t.code ) = lower ( loc_code_old );
      if ( counter = 1 ) then
        select count(1) into counter from localization t where lower ( t.code ) = lower ( loc_code );
        if ( counter = 0 ) then
          select localization_seq.nextval into loc_id from dual;
          
          insert into localization ( id, code, code_type )
          values ( loc_id, loc_code, 0 );
        end if;
        update r_query_field set title = loc_code where id = rqf_id;
      end if;
    end if;
  end if;
  if ( loc_id is null ) then
    select t.id into loc_id from localization t where lower ( t.code ) = lower ( loc_code );
  end if;

  open cur_lan for select t.id from language t where t.language_status > 0;
  loop
    fetch cur_lan into lan_id;
    exit when cur_lan%NOTFOUND;
    
    select count(1) into counter from i18n_message t where t.language = lan_id and t.localization = loc_id;
    if ( counter = 0 ) then
      insert into i18n_message ( id, localization, language, message )
      values ( i18n_message_seq.nextval, loc_id, lan_id, i18n_msg );
    else
      update i18n_message set message = i18n_msg where language = lan_id and localization = loc_id;
    end if;

  end loop;
  close cur_lan;

  open cur_rep for select t.id from report t where t.r_query = rq_id;
  loop
    fetch cur_rep into rep_id;
    exit when cur_rep%NOTFOUND;
    
    select count(1) into counter from report_field t where t.report = rep_id and t.r_query_field = rqf_id;
    if ( counter = 0 ) then
      if ( repf_pos_id is null ) then
        select max ( t.position ) + 1 into repf_pos_id from report_field t where t.report = rep_id;
        if ( repf_pos_id is null ) then
          repf_pos_id := 0;
        end if;
      else
        select count(1) into counter from report_field t where t.report = rep_id and position = repf_pos_id;
        if ( counter > 0 ) then
          --modificare le posizioni del corrente e dei successivi
          update report_field set position = ( position + 1 ) where report = rep_id and position >= repf_pos_id;
        end if;
      end if;
      
      if ( rqf_ord_by = 1 ) then
        select max(t.order_by) + 1 into rqf_ord_pos from report_field t where t.report = rep_id;
        if ( rqf_ord_pos is null ) then
          rqf_ord_pos := 0;
        end if;
      else
        rqf_ord_by_clau := null;
      end if;

      insert into report_field ( id, report, r_query_field, localization, width, position, order_by, order_by_clause )
      values ( report_field_seq.nextval, rep_id, rqf_id, loc_id, rqf_width, repf_pos_id, rqf_ord_pos, rqf_ord_by_clau );
    elsif ( counter = 1 and repf_pos_id is not null ) then
      select t.position into repf_pos_id_old from report_field t where t.report = rep_id and t.r_query_field = rqf_id;
      --spostiamo il campo in una posizione speciale
      update report_field set position = -1 where report = rep_id and position = repf_pos_id_old;
      if ( repf_pos_id_old > repf_pos_id ) then
        update report_field set position = ( position + 1 ) where report = rep_id and position >= repf_pos_id and position <= repf_pos_id_old;
      else
        update report_field set position = ( position - 1 ) where report = rep_id and position >= repf_pos_id_old and position <= repf_pos_id;
      end if;
      --spostiamo il campo in una posizione finale
      update report_field set position = repf_pos_id where report = rep_id and position = -1;
      update report_field set localization = loc_id where report = rep_id and r_query_field = rqf_id;
    end if;
    
    if ( loc_rename = false ) then
      update report_field set localization = loc_id where report = rep_id and r_query_field = rqf_id;
    end if;

    update report_field set width = rqf_width where report = rep_id;
  end loop;
  close cur_rep;
  --QUERY FIELD 03: END

  --QUERY FIELD 04: BEGIN
  rqf_id          := null;
  rqf_name_old    := rqf_name04_old;
  rqf_name        := rqf_name04;
  rqf_type        := rqf_type04;
  rqf_width       := rqf_width04;
  rqf_ord_by      := rqf_ord_by04;
  rqf_ord_by_clau := rqf_ord_by_clau04;
  rqf_ord_pos     := null;
  loc_id          := null;
  loc_code_old    := loc_code04_old;
  loc_code        := loc_code04;
  loc_rename      := loc_rename04;
  i18n_msg        := i18n_msg04;
  repf_pos_id_old := null;
  repf_pos_id     := repf_pos_id04;

  if ( rqf_name_old is null or rqf_name_old = rqf_name ) then
    select count(1) into counter from r_query_field t where t.r_query = rq_id and lower ( t.column_name ) = lower ( rqf_name );
    if ( counter = 0 ) then
      select r_query_field_seq.nextval into rqf_id from dual;
      
      insert into r_query_field ( id, r_query, column_name, title, type, width )
      values ( rqf_id, rq_id, rqf_name, loc_code, rqf_type, rqf_width );
    end if;
  elsif ( rqf_name_old is not null and rqf_name_old <> rqf_name ) then
    select count(1) into counter from r_query_field t where t.r_query = rq_id and lower ( t.column_name ) = lower ( rqf_name_old );
    if ( counter = 1 ) then
      select t.id into rqf_id from r_query_field t where t.r_query = rq_id and lower ( t.column_name ) = lower ( rqf_name_old );
      update r_query_field set column_name = rqf_name where id = rqf_id;
    end if;  
  end if;
  if ( rqf_id is null ) then
    select t.id into rqf_id from r_query_field t where t.r_query = rq_id and lower ( t.column_name ) = lower ( rqf_name );
  end if;
  
  if ( loc_code_old is null or loc_code_old = loc_code ) then
    select count(1) into counter from localization t where lower ( t.code ) = lower ( loc_code );
    if ( counter = 0 ) then
      select localization_seq.nextval into loc_id from dual;
      
      insert into localization ( id, code, code_type )
      values ( loc_id, loc_code, 0 );
    end if;
  elsif ( loc_code_old is not null and loc_code_old <> loc_code ) then
    if ( loc_rename = true ) then
      select count(1) into counter from localization t where lower ( t.code ) = lower ( loc_code_old );
      if ( counter = 1 ) then
        select count(1) into counter from localization t where lower ( t.code ) = lower ( loc_code );
        if ( counter = 0 ) then
          select t.id into loc_id from localization t where lower ( t.code ) = lower ( loc_code_old );
          update localization set code = loc_code where id = loc_id;
        end if;
        update r_query_field set title = loc_code where id = rqf_id;
      end if;
    else
      select count(1) into counter from localization t where lower ( t.code ) = lower ( loc_code_old );
      if ( counter = 1 ) then
        select count(1) into counter from localization t where lower ( t.code ) = lower ( loc_code );
        if ( counter = 0 ) then
          select localization_seq.nextval into loc_id from dual;
          
          insert into localization ( id, code, code_type )
          values ( loc_id, loc_code, 0 );
        end if;
        update r_query_field set title = loc_code where id = rqf_id;
      end if;
    end if;
  end if;
  if ( loc_id is null ) then
    select t.id into loc_id from localization t where lower ( t.code ) = lower ( loc_code );
  end if;

  open cur_lan for select t.id from language t where t.language_status > 0;
  loop
    fetch cur_lan into lan_id;
    exit when cur_lan%NOTFOUND;
    
    select count(1) into counter from i18n_message t where t.language = lan_id and t.localization = loc_id;
    if ( counter = 0 ) then
      insert into i18n_message ( id, localization, language, message )
      values ( i18n_message_seq.nextval, loc_id, lan_id, i18n_msg );
    else
      update i18n_message set message = i18n_msg where language = lan_id and localization = loc_id;
    end if;

  end loop;
  close cur_lan;

  open cur_rep for select t.id from report t where t.r_query = rq_id;
  loop
    fetch cur_rep into rep_id;
    exit when cur_rep%NOTFOUND;
    
    select count(1) into counter from report_field t where t.report = rep_id and t.r_query_field = rqf_id;
    if ( counter = 0 ) then
      if ( repf_pos_id is null ) then
        select max ( t.position ) + 1 into repf_pos_id from report_field t where t.report = rep_id;
        if ( repf_pos_id is null ) then
          repf_pos_id := 0;
        end if;
      else
        select count(1) into counter from report_field t where t.report = rep_id and position = repf_pos_id;
        if ( counter > 0 ) then
          --modificare le posizioni del corrente e dei successivi
          update report_field set position = ( position + 1 ) where report = rep_id and position >= repf_pos_id;
        end if;
      end if;
      
      if ( rqf_ord_by = 1 ) then
        select max(t.order_by) + 1 into rqf_ord_pos from report_field t where t.report = rep_id;
        if ( rqf_ord_pos is null ) then
          rqf_ord_pos := 0;
        end if;
      else
        rqf_ord_by_clau := null;
      end if;

      insert into report_field ( id, report, r_query_field, localization, width, position, order_by, order_by_clause )
      values ( report_field_seq.nextval, rep_id, rqf_id, loc_id, rqf_width, repf_pos_id, rqf_ord_pos, rqf_ord_by_clau );
    elsif ( counter = 1 and repf_pos_id is not null ) then
      select t.position into repf_pos_id_old from report_field t where t.report = rep_id and t.r_query_field = rqf_id;
      --spostiamo il campo in una posizione speciale
      update report_field set position = -1 where report = rep_id and position = repf_pos_id_old;
      if ( repf_pos_id_old > repf_pos_id ) then
        update report_field set position = ( position + 1 ) where report = rep_id and position >= repf_pos_id and position <= repf_pos_id_old;
      else
        update report_field set position = ( position - 1 ) where report = rep_id and position >= repf_pos_id_old and position <= repf_pos_id;
      end if;
      --spostiamo il campo in una posizione finale
      update report_field set position = repf_pos_id where report = rep_id and position = -1;
      update report_field set localization = loc_id where report = rep_id and r_query_field = rqf_id;
    end if;
    
    if ( loc_rename = false ) then
      update report_field set localization = loc_id where report = rep_id and r_query_field = rqf_id;
    end if;

    update report_field set width = rqf_width where report = rep_id;
  end loop;
  close cur_rep;
  --QUERY FIELD 04: END

  --QUERY FIELD 05: BEGIN
  rqf_id          := null;
  rqf_name_old    := rqf_name05_old;
  rqf_name        := rqf_name05;
  rqf_type        := rqf_type05;
  rqf_width       := rqf_width05;
  rqf_ord_by      := rqf_ord_by05;
  rqf_ord_by_clau := rqf_ord_by_clau05;
  rqf_ord_pos     := null;
  loc_id          := null;
  loc_code_old    := loc_code05_old;
  loc_code        := loc_code05;
  loc_rename      := loc_rename05;
  i18n_msg        := i18n_msg05;
  repf_pos_id_old := null;
  repf_pos_id     := repf_pos_id05;

  if ( rqf_name_old is null or rqf_name_old = rqf_name ) then
    select count(1) into counter from r_query_field t where t.r_query = rq_id and lower ( t.column_name ) = lower ( rqf_name );
    if ( counter = 0 ) then
      select r_query_field_seq.nextval into rqf_id from dual;
      
      insert into r_query_field ( id, r_query, column_name, title, type, width )
      values ( rqf_id, rq_id, rqf_name, loc_code, rqf_type, rqf_width );
    end if;
  elsif ( rqf_name_old is not null and rqf_name_old <> rqf_name ) then
    select count(1) into counter from r_query_field t where t.r_query = rq_id and lower ( t.column_name ) = lower ( rqf_name_old );
    if ( counter = 1 ) then
      select t.id into rqf_id from r_query_field t where t.r_query = rq_id and lower ( t.column_name ) = lower ( rqf_name_old );
      update r_query_field set column_name = rqf_name where id = rqf_id;
    end if;  
  end if;
  if ( rqf_id is null ) then
    select t.id into rqf_id from r_query_field t where t.r_query = rq_id and lower ( t.column_name ) = lower ( rqf_name );
  end if;
  
  if ( loc_code_old is null or loc_code_old = loc_code ) then
    select count(1) into counter from localization t where lower ( t.code ) = lower ( loc_code );
    if ( counter = 0 ) then
      select localization_seq.nextval into loc_id from dual;
      
      insert into localization ( id, code, code_type )
      values ( loc_id, loc_code, 0 );
    end if;
  elsif ( loc_code_old is not null and loc_code_old <> loc_code ) then
    if ( loc_rename = true ) then
      select count(1) into counter from localization t where lower ( t.code ) = lower ( loc_code_old );
      if ( counter = 1 ) then
        select count(1) into counter from localization t where lower ( t.code ) = lower ( loc_code );
        if ( counter = 0 ) then
          select t.id into loc_id from localization t where lower ( t.code ) = lower ( loc_code_old );
          update localization set code = loc_code where id = loc_id;
        end if;
        update r_query_field set title = loc_code where id = rqf_id;
      end if;
    else
      select count(1) into counter from localization t where lower ( t.code ) = lower ( loc_code_old );
      if ( counter = 1 ) then
        select count(1) into counter from localization t where lower ( t.code ) = lower ( loc_code );
        if ( counter = 0 ) then
          select localization_seq.nextval into loc_id from dual;
          
          insert into localization ( id, code, code_type )
          values ( loc_id, loc_code, 0 );
        end if;
        update r_query_field set title = loc_code where id = rqf_id;
      end if;
    end if;
  end if;
  if ( loc_id is null ) then
    select t.id into loc_id from localization t where lower ( t.code ) = lower ( loc_code );
  end if;

  open cur_lan for select t.id from language t where t.language_status > 0;
  loop
    fetch cur_lan into lan_id;
    exit when cur_lan%NOTFOUND;
    
    select count(1) into counter from i18n_message t where t.language = lan_id and t.localization = loc_id;
    if ( counter = 0 ) then
      insert into i18n_message ( id, localization, language, message )
      values ( i18n_message_seq.nextval, loc_id, lan_id, i18n_msg );
    else
      update i18n_message set message = i18n_msg where language = lan_id and localization = loc_id;
    end if;

  end loop;
  close cur_lan;

  open cur_rep for select t.id from report t where t.r_query = rq_id;
  loop
    fetch cur_rep into rep_id;
    exit when cur_rep%NOTFOUND;
    
    select count(1) into counter from report_field t where t.report = rep_id and t.r_query_field = rqf_id;
    if ( counter = 0 ) then
      if ( repf_pos_id is null ) then
        select max ( t.position ) + 1 into repf_pos_id from report_field t where t.report = rep_id;
        if ( repf_pos_id is null ) then
          repf_pos_id := 0;
        end if;
      else
        select count(1) into counter from report_field t where t.report = rep_id and position = repf_pos_id;
        if ( counter > 0 ) then
          --modificare le posizioni del corrente e dei successivi
          update report_field set position = ( position + 1 ) where report = rep_id and position >= repf_pos_id;
        end if;
      end if;
      
      if ( rqf_ord_by = 1 ) then
        select max(t.order_by) + 1 into rqf_ord_pos from report_field t where t.report = rep_id;
        if ( rqf_ord_pos is null ) then
          rqf_ord_pos := 0;
        end if;
      else
        rqf_ord_by_clau := null;
      end if;

      insert into report_field ( id, report, r_query_field, localization, width, position, order_by, order_by_clause )
      values ( report_field_seq.nextval, rep_id, rqf_id, loc_id, rqf_width, repf_pos_id, rqf_ord_pos, rqf_ord_by_clau );
    elsif ( counter = 1 and repf_pos_id is not null ) then
      select t.position into repf_pos_id_old from report_field t where t.report = rep_id and t.r_query_field = rqf_id;
      --spostiamo il campo in una posizione speciale
      update report_field set position = -1 where report = rep_id and position = repf_pos_id_old;
      if ( repf_pos_id_old > repf_pos_id ) then
        update report_field set position = ( position + 1 ) where report = rep_id and position >= repf_pos_id and position <= repf_pos_id_old;
      else
        update report_field set position = ( position - 1 ) where report = rep_id and position >= repf_pos_id_old and position <= repf_pos_id;
      end if;
      --spostiamo il campo in una posizione finale
      update report_field set position = repf_pos_id where report = rep_id and position = -1;
      update report_field set localization = loc_id where report = rep_id and r_query_field = rqf_id;
    end if;
    
    if ( loc_rename = false ) then
      update report_field set localization = loc_id where report = rep_id and r_query_field = rqf_id;
    end if;

    update report_field set width = rqf_width where report = rep_id;
  end loop;
  close cur_rep;
  --QUERY FIELD 05: END

  --QUERY FIELD 06: BEGIN
  rqf_id          := null;
  rqf_name_old    := rqf_name06_old;
  rqf_name        := rqf_name06;
  rqf_type        := rqf_type06;
  rqf_width       := rqf_width06;
  rqf_ord_by      := rqf_ord_by06;
  rqf_ord_by_clau := rqf_ord_by_clau06;
  rqf_ord_pos     := null;
  loc_id          := null;
  loc_code_old    := loc_code06_old;
  loc_code        := loc_code06;
  loc_rename      := loc_rename06;
  i18n_msg        := i18n_msg06;
  repf_pos_id_old := null;
  repf_pos_id     := repf_pos_id06;

  if ( rqf_name_old is null or rqf_name_old = rqf_name ) then
    select count(1) into counter from r_query_field t where t.r_query = rq_id and lower ( t.column_name ) = lower ( rqf_name );
    if ( counter = 0 ) then
      select r_query_field_seq.nextval into rqf_id from dual;
      
      insert into r_query_field ( id, r_query, column_name, title, type, width )
      values ( rqf_id, rq_id, rqf_name, loc_code, rqf_type, rqf_width );
    end if;
  elsif ( rqf_name_old is not null and rqf_name_old <> rqf_name ) then
    select count(1) into counter from r_query_field t where t.r_query = rq_id and lower ( t.column_name ) = lower ( rqf_name_old );
    if ( counter = 1 ) then
      select t.id into rqf_id from r_query_field t where t.r_query = rq_id and lower ( t.column_name ) = lower ( rqf_name_old );
      update r_query_field set column_name = rqf_name where id = rqf_id;
    end if;  
  end if;
  if ( rqf_id is null ) then
    select t.id into rqf_id from r_query_field t where t.r_query = rq_id and lower ( t.column_name ) = lower ( rqf_name );
  end if;
  
  if ( loc_code_old is null or loc_code_old = loc_code ) then
    select count(1) into counter from localization t where lower ( t.code ) = lower ( loc_code );
    if ( counter = 0 ) then
      select localization_seq.nextval into loc_id from dual;
      
      insert into localization ( id, code, code_type )
      values ( loc_id, loc_code, 0 );
    end if;
  elsif ( loc_code_old is not null and loc_code_old <> loc_code ) then
    if ( loc_rename = true ) then
      select count(1) into counter from localization t where lower ( t.code ) = lower ( loc_code_old );
      if ( counter = 1 ) then
        select count(1) into counter from localization t where lower ( t.code ) = lower ( loc_code );
        if ( counter = 0 ) then
          select t.id into loc_id from localization t where lower ( t.code ) = lower ( loc_code_old );
          update localization set code = loc_code where id = loc_id;
        end if;
        update r_query_field set title = loc_code where id = rqf_id;
      end if;
    else
      select count(1) into counter from localization t where lower ( t.code ) = lower ( loc_code_old );
      if ( counter = 1 ) then
        select count(1) into counter from localization t where lower ( t.code ) = lower ( loc_code );
        if ( counter = 0 ) then
          select localization_seq.nextval into loc_id from dual;
          
          insert into localization ( id, code, code_type )
          values ( loc_id, loc_code, 0 );
        end if;
        update r_query_field set title = loc_code where id = rqf_id;
      end if;
    end if;
  end if;
  if ( loc_id is null ) then
    select t.id into loc_id from localization t where lower ( t.code ) = lower ( loc_code );
  end if;

  open cur_lan for select t.id from language t where t.language_status > 0;
  loop
    fetch cur_lan into lan_id;
    exit when cur_lan%NOTFOUND;
    
    select count(1) into counter from i18n_message t where t.language = lan_id and t.localization = loc_id;
    if ( counter = 0 ) then
      insert into i18n_message ( id, localization, language, message )
      values ( i18n_message_seq.nextval, loc_id, lan_id, i18n_msg );
    else
      update i18n_message set message = i18n_msg where language = lan_id and localization = loc_id;
    end if;

  end loop;
  close cur_lan;

  open cur_rep for select t.id from report t where t.r_query = rq_id;
  loop
    fetch cur_rep into rep_id;
    exit when cur_rep%NOTFOUND;
    
    select count(1) into counter from report_field t where t.report = rep_id and t.r_query_field = rqf_id;
    if ( counter = 0 ) then
      if ( repf_pos_id is null ) then
        select max ( t.position ) + 1 into repf_pos_id from report_field t where t.report = rep_id;
        if ( repf_pos_id is null ) then
          repf_pos_id := 0;
        end if;
      else
        select count(1) into counter from report_field t where t.report = rep_id and position = repf_pos_id;
        if ( counter > 0 ) then
          --modificare le posizioni del corrente e dei successivi
          update report_field set position = ( position + 1 ) where report = rep_id and position >= repf_pos_id;
        end if;
      end if;
      
      if ( rqf_ord_by = 1 ) then
        select max(t.order_by) + 1 into rqf_ord_pos from report_field t where t.report = rep_id;
        if ( rqf_ord_pos is null ) then
          rqf_ord_pos := 0;
        end if;
      else
        rqf_ord_by_clau := null;
      end if;

      insert into report_field ( id, report, r_query_field, localization, width, position, order_by, order_by_clause )
      values ( report_field_seq.nextval, rep_id, rqf_id, loc_id, rqf_width, repf_pos_id, rqf_ord_pos, rqf_ord_by_clau );
    elsif ( counter = 1 and repf_pos_id is not null ) then
      select t.position into repf_pos_id_old from report_field t where t.report = rep_id and t.r_query_field = rqf_id;
      --spostiamo il campo in una posizione speciale
      update report_field set position = -1 where report = rep_id and position = repf_pos_id_old;
      if ( repf_pos_id_old > repf_pos_id ) then
        update report_field set position = ( position + 1 ) where report = rep_id and position >= repf_pos_id and position <= repf_pos_id_old;
      else
        update report_field set position = ( position - 1 ) where report = rep_id and position >= repf_pos_id_old and position <= repf_pos_id;
      end if;
      --spostiamo il campo in una posizione finale
      update report_field set position = repf_pos_id where report = rep_id and position = -1;
      update report_field set localization = loc_id where report = rep_id and r_query_field = rqf_id;
    end if;
    
    if ( loc_rename = false ) then
      update report_field set localization = loc_id where report = rep_id and r_query_field = rqf_id;
    end if;

    update report_field set width = rqf_width where report = rep_id;
  end loop;
  close cur_rep;
  --QUERY FIELD 06: END

  --QUERY VISIBILITY AND REPORT VISIBILITY 01: BEGIN
  rv_name := rv_name01;
  repv_vis_type := repv_vis_type01;
  select count (1) into counter from r_visibility rv where lower ( rv.name ) = lower ( rv_name );
  if ( counter = 1 ) then
    select rv.id, rv.entity into rv_id, rv_ent_id from r_visibility rv where lower ( rv.name ) = lower ( rv_name );
    
    --QUERY VISIBILITY
    select count(1) into counter from r_query_visibility rqv where rqv.r_query = rq_id and rqv.r_visibility = rv_id;

    if ( counter = 0 ) then
      select max ( rqv.position ) + 1 into rq_vis_pos from r_query_visibility rqv where rqv.r_query = rq_id and rqv.r_visibility = rv_id;
      if ( rq_vis_pos is null ) then
        rq_vis_pos := 0;
      end if;
      insert into r_query_visibility ( id, r_query, r_visibility, position )
      values ( r_query_visibility_seq.nextval, rq_id, rv_id, rq_vis_pos );
    end if;

    --REPORT VISIBILITY
    select count(1) into counter from report_visibility rv where rv.report = r_id and rv.r_visibility = rv_id;

    if ( counter = 0 ) then
      insert into report_visibility ( id, report, entity, vis_type, r_visibility )
      values ( report_visibility_seq.nextval, r_id, rv_ent_id, repv_vis_type, rv_id );
    end if;
  end if;
  --QUERY VISIBILITY AND REPORT VISIBILITY 01: END

end;
/

commit;
