#ORACLE CLIENT CONFIGURATION
export ORACLE_BASE=/home/oracle
export ORACLE_HOME=$ORACLE_BASE/app/oracle/product/12.1.0/dbhome_1

#ORACLE SERVER CONFIGURATION
export ORACLE_SERVER=[ORACLE_SERVER_TNS_NAME]


#FIXED CONFIGURATION
export UPGRADE_SCRIPT=$PWD

cd $UPGRADE_SCRIPT/AccessGovernanceCoreBackend
$ORACLE_HOME/bin/sqlplus iga_admin/ideas@$ORACLE_SERVER @agc_pre_req_upgrade_73_to_74.sql
$ORACLE_HOME/bin/sqlplus iga_core/ideas@$ORACLE_SERVER @agc_pre_req_upgrade_73_to_74.sql
$ORACLE_HOME/bin/sqlplus ccs_core/ideas@$ORACLE_SERVER @arc4s_pre_req_upgrade_73_to_74.sql

cd $UPGRADE_SCRIPT/Localization
$ORACLE_HOME/bin/sqlplus iga_admin/ideas@$ORACLE_SERVER @agc_localization.sql
$ORACLE_HOME/bin/sqlplus iga_core/ideas@$ORACLE_SERVER @agc_localization.sql
$ORACLE_HOME/bin/sqlplus ccs_core/ideas@$ORACLE_SERVER @arc4s_localization.sql

cd $UPGRADE_SCRIPT/AccessGovernanceCoreBackend
$ORACLE_HOME/bin/sqlplus iga_admin/ideas@$ORACLE_SERVER @agc_upgrade_73_to_74.sql
$ORACLE_HOME/bin/sqlplus iga_core/ideas@$ORACLE_SERVER @agc_upgrade_73_to_74.sql
$ORACLE_HOME/bin/sqlplus ccs_core/ideas@$ORACLE_SERVER @arc4s_upgrade_73_to_74.sql

cd $UPGRADE_SCRIPT/AccessRequestsBackend
$ORACLE_HOME/bin/sqlplus iga_admin/ideas@$ORACLE_SERVER @arm_upgrade_13_to_14.sql
$ORACLE_HOME/bin/sqlplus iga_core/ideas@$ORACLE_SERVER @arm_upgrade_13_to_14.sql

cd $UPGRADE_SCRIPT/AccessOptimizerBackend
$ORACLE_HOME/bin/sqlplus aa_admin/ideas@$ORACLE_SERVER @aa_upgrade_53_to_54.sql
$ORACLE_HOME/bin/sqlplus aa_core/ideas@$ORACLE_SERVER @aa_upgrade_53_to_54.sql

cd $UPGRADE_SCRIPT/AccessRiskControlsForSAPBackend
$ORACLE_HOME/bin/sqlplus ccs_core/ideas@$ORACLE_SERVER @arc4s_upgrade_43_to_44.sql

cd $UPGRADE_SCRIPT/DeskBackend
$ORACLE_HOME/bin/sqlplus iga_service/ideas@$ORACLE_SERVER @desk_upgrade_23_to_24.sql

cd $UPGRADE_SCRIPT/EmailBackend
$ORACLE_HOME/bin/sqlplus iga_admin/ideas@$ORACLE_SERVER @es_upgrade_23_to_24.sql
$ORACLE_HOME/bin/sqlplus iga_core/ideas@$ORACLE_SERVER @es_upgrade_23_to_24.sql

cd $UPGRADE_SCRIPT/EnterpriseConnectorsBackend
$ORACLE_HOME/bin/sqlplus iga_admin/ideas@$ORACLE_SERVER @ec_upgrade_33_to_34.sql
$ORACLE_HOME/bin/sqlplus iga_core/ideas@$ORACLE_SERVER @ec_upgrade_33_to_34.sql

cd $UPGRADE_SCRIPT/JobBackend
$ORACLE_HOME/bin/sqlplus aa_admin/ideas@$ORACLE_SERVER @job_upgrade_23_to_24.sql
$ORACLE_HOME/bin/sqlplus aa_core/ideas@$ORACLE_SERVER @job_upgrade_23_to_24.sql
$ORACLE_HOME/bin/sqlplus iga_admin/ideas@$ORACLE_SERVER @job_upgrade_23_to_24.sql
$ORACLE_HOME/bin/sqlplus iga_core/ideas@$ORACLE_SERVER @job_upgrade_23_to_24.sql
$ORACLE_HOME/bin/sqlplus ccs_core/ideas@$ORACLE_SERVER @job_upgrade_23_to_24.sql
$ORACLE_HOME/bin/sqlplus iga_report_admin/ideas@$ORACLE_SERVER @job_upgrade_23_to_24.sql
$ORACLE_HOME/bin/sqlplus iga_report_core/ideas@$ORACLE_SERVER @job_upgrade_23_to_24.sql

cd $UPGRADE_SCRIPT/ReportBackend
$ORACLE_HOME/bin/sqlplus iga_report_admin/ideas@$ORACLE_SERVER @rd_upgrade_23_to_24.sql
$ORACLE_HOME/bin/sqlplus iga_report_core/ideas@$ORACLE_SERVER @rd_upgrade_23_to_24.sql

cd $UPGRADE_SCRIPT/RuleEngineBackend
$ORACLE_HOME/bin/sqlplus iga_admin/ideas@$ORACLE_SERVER @re_upgrade_23_to_24.sql
$ORACLE_HOME/bin/sqlplus iga_core/ideas@$ORACLE_SERVER @re_upgrade_23_to_24.sql
$ORACLE_HOME/bin/sqlplus ccs_core/ideas@$ORACLE_SERVER @re_upgrade_23_to_24.sql

cd $UPGRADE_SCRIPT/TaskPlannerBackend
$ORACLE_HOME/bin/sqlplus iga_quartz/ideas@$ORACLE_SERVER @quartz_upgrade.sql
$ORACLE_HOME/bin/sqlplus iga_service/ideas@$ORACLE_SERVER @sk_upgrade_23_to_24.sql

cd $UPGRADE_SCRIPT/AuditHelper
$ORACLE_HOME/bin/sqlplus iga_service/ideas@$ORACLE_SERVER @account_upgrade_33_to_34.sql

cd $UPGRADE_SCRIPT/SIB_IB_ILC
$ORACLE_HOME/bin/sqlplus itimuser/ideas@$ORACLE_SERVER @IB_ILC_upgrade.sql
$ORACLE_HOME/bin/sqlplus itiml000/ideas@$ORACLE_SERVER @SIB_upgrade.sql

cd $UPGRADE_SCRIPT/AccessGovernanceCoreBackend
$ORACLE_HOME/bin/sqlplus iga_admin/ideas@$ORACLE_SERVER @report_assignment.sql
$ORACLE_HOME/bin/sqlplus iga_core/ideas@$ORACLE_SERVER @report_assignment.sql

cd $UPGRADE_SCRIPT/ReportBackend
$ORACLE_HOME/bin/sqlplus iga_report_admin/ideas@$ORACLE_SERVER @revoke_from_agc.sql
$ORACLE_HOME/bin/sqlplus iga_report_core/ideas@$ORACLE_SERVER @revoke_from_agc.sql

cd $UPGRADE_SCRIPT/IdeasModule
$ORACLE_HOME/bin/sqlplus aa_admin/ideas@$ORACLE_SERVER @ideas_module_upgrade.sql
$ORACLE_HOME/bin/sqlplus aa_core/ideas@$ORACLE_SERVER @ideas_module_upgrade.sql
$ORACLE_HOME/bin/sqlplus iga_admin/ideas@$ORACLE_SERVER @ideas_module_upgrade.sql
$ORACLE_HOME/bin/sqlplus iga_core/ideas@$ORACLE_SERVER @ideas_module_upgrade.sql
$ORACLE_HOME/bin/sqlplus ccs_core/ideas@$ORACLE_SERVER @ideas_module_upgrade.sql
$ORACLE_HOME/bin/sqlplus iga_report_admin/ideas@$ORACLE_SERVER @ideas_module_upgrade.sql
$ORACLE_HOME/bin/sqlplus iga_report_core/ideas@$ORACLE_SERVER @ideas_module_upgrade.sql

cd $UPGRADE_SCRIPT
